//
//  JRF5NSTextView.h
//
//  Created by Jay Freeman on 06/14/2010
//  Copyright 2007 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

/* JRF5NSTextView */

#ifndef JRF5NSTEXTVIEW
#define JRF5NSTEXTVIEW

#import <Cocoa/Cocoa.h>
#import "PixieIIWindowController.h"

@class PixieIIWindowController;
@class PixieSchemeIIController;

@interface JRF5NSTextView : NSTextView
{
    IBOutlet PixieSchemeIIController *theController;
    IBOutlet PixieIIWindowController *theWindowController;    
    IBOutlet NSMenuItem *iMPMenuItem;
    IBOutlet NSMenuItem *sSWPMenuItem;
    IBOutlet NSMenuItem *iPOQMMenuItem;
    IBOutlet NSMenuItem *sSWQMMenuItem;

    SEL dealWithText;

    NSArray *allowedTypes;

    NSRange typingRange;
    bool needsNewTypingRange;

    NSInteger startLengthForKeyPress;
    NSInteger endLengthForKeyPress;

    }

- (void) setDealWithText:(SEL)aMethod;
- (void) appendNewline;
- (void) appendString:(NSString *)aString;
- (void) insertString:(NSString *)aString;
- (NSRange) getSelectedRange;
- (void) showEndRange;
- (void) showSelectedRange;
- (bool) inFirstLine;
- (bool) inLastLine;
- (NSRange) currentLinesRange;
- (IBAction) selectCurrentLines:(id)sender;
- (bool) atFirstCharacterInLine;
- (bool) atLastCharacterInLine;
- (void) lineStartsAt:(NSUInteger *)lineLocation withLength:(NSUInteger *)lineLength withSelectionOffset:(NSInteger *)selOffset;
- (void) lastLineStartsAt:(NSUInteger *)lineLocation withLength:(NSUInteger *)lineLength;
- (void) scrollToBottom;
- (void) transmitAll:(NSString *)theString;
- (void) disableShortcuts;
- (void) enableShortcuts;
- (IBAction) insertMatchedParentheses:(id)sender;
- (IBAction) surroundSelectionWithParentheses:(id)sender;
- (IBAction) insertPairOfQuotationMarks:(id)sender;
- (IBAction) surroundSelectionWithQuotationMarks:(id)sender;
- (IBAction)markOrTransmitSelection:(id)sender;
- (IBAction) transmitSelection:(id)sender;
- (bool) hasSelectedText;
- (bool) hasTypingRange;
- (void) setNeedsNewTypingRange:(bool)value;
- (void) startTypingRange;
- (void) adjustTypingRange;

@end

#endif
