/****************************************************************************************

PixieIIMainAux.e -- Copyright (c) by Jay Reynolds Freeman 2006

Auxiliaries for Main, for Pixie Scheme II.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#ifndef __PIXIEIIMAINAUXEXTERNS__
#define __PIXIEIIMAINAUXEXTERNS__

extern void runSchemeWithArguments( const char *LocalInitFileName, const char *LocalInitFilePath,
                                    long LocalMemorySize, unsigned char LocalInitFileExists );
extern void cleanUpForExit();
extern int runSchemeWithPathAndMemory( const char *argv0, UnsignedLongWord memorySizeProvided,
                                       UnsignedLongWord generationSizeProvided );
extern void spinOnGC();
extern void reportGCDoneGlobally();
extern Boolean allKittensSpinning();
extern Boolean allKittensAreActive();
extern void errorRecovery( Text *reinitializationAction );
extern void requireGC();
extern int getProcessorCount();
extern void failAtOnce();
extern void printfKittens();
extern Boolean momSaysQuit();
extern Boolean momSaysReset();
extern Boolean momSaysWorldOp();
#endif
