//
//  JRF6UITextView.h
//
//  Created by Jay Freeman on 07/08/2010
//  Copyright 2010 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

/* JRF6UITextView */

#import <UIKit/UIKit.h>

#import "PixieSchemeIIIViewController.h"
#import "ParenFinder.h"
#import "TintedUIView.h"

@class PixieSchemeIIIViewController;

@interface JRF6UITextView : UITextView
{
    IBOutlet bool typingRangeIlluminated;
    IBOutlet PixieSchemeIIIViewController *theController;

    UIColor *color1;
    UIColor *color2;
    UIColor *color3;
    UIColor *color4;

    SEL dealWithText;

    NSArray *allowedTypes;

    NSRange lastSelectedRange;
    NSRange illuminatedRange;
    NSRange typingRange;

    bool typingRangeIsActive;

    NSInteger startLengthForKeyPress;
    NSInteger endLengthForKeyPress;

    float osVersionFloat;

    ParenFinder *theParenFinder;

    }

+ (void) _keepAtLinkTime;
- (void) applicationDidFinishLaunchingContent;
- (NSRange) replaceCharactersInRange:(NSRange)aRange withString:(NSString *)aString;
- (void) setDealWithText:(SEL)aMethod;
- (NSRange) getSelectedRange;
- (NSRange) getTypingRange;
- (void) showEndRange;
- (void) showSelectedRange;
- (NSRange) currentLinesRange;
- (IBAction) selectCurrentLines:(id)sender;
- (void) transmitAll:(NSString *)theString;
- (IBAction) markOrTransmitSelection:(id)sender;
- (IBAction) transmitSelection:(id)sender;
- (bool) hasSelectedText;
- (bool) typingRangeIsActive;
- (bool) typingRangeIsNonEmpty;
- (void) setTypingRangeIsActive:(bool)value;
- (NSString *)typingRangeContent;
- (NSString *)typingRangeAbbreviatedContent;
- (void) logTypingRangeDescription;
- (void) startTypingRange;
- (void) adjustTypingRange:(NSRange)range forLength:(NSInteger)lnth isDelete:(bool)isDelete;
- (CGPoint) topLeftCornerOfCharAtIndex:(NSUInteger)index;
- (CGPoint) topRightCornerOfCharAtIndex:(NSUInteger)index;
- (CGPoint) topLeftJustPastEnd;
- (void) describePoint:(CGPoint)point named:(NSString *)name;
- (void) describeFrame:(CGRect)frame named:(NSString *)name;
- (void) illuminateRange:(NSRange)range color:(NSInteger)colorNumber;
- (void) illuminateRange:(NSRange)range;
- (void) illuminateTintedUIView:(TintedUIView *)theView colorNumber:(NSInteger)color;
- (void) reilluminateRange;
- (void) bringUpMenuForRange:(NSRange)range;
- (void) deilluminateRange;
- (NSRange) getLastSelectedRange;
- (void) illuminateCharacterNumber:(NSInteger)n at:(NSUInteger)index colorNumber:(NSInteger)colorNum;
- (void) deilluminateCharacterNumber:(NSInteger)n;
- (BOOL) findMatchingLeftParenInCode:(NSUInteger)here at:(NSUInteger *)foundAt;
- (BOOL) findMatchingRightParenInCode:(NSUInteger)here at:(NSUInteger *)foundAt;
- (void) displayParenMatchAt:(NSUInteger)here;
- (void) repositionParenMatch;
- (BOOL) matchedParensDisplayed;
- (void) analyzeParens;
- (void) invalidateParensStarting:(NSUInteger)here;
- (void) revalidateParensTo:(NSUInteger)here;
- (void) reanalyzeParens;

@property(nonatomic) IBOutlet bool typingRangeIlluminated;

@end

