//
//  ParenFinder.h
//
//  Created by Jay Freeman on 12/02/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <UIKit/UIKit.h>
#import <Foundation/Foundation.h>
#import "ParenTriple.h"

@class PixieSchemeIIIViewController;
@class JRF6UITextView;

typedef struct parenRecord_struct {


    } parenRecord;

@interface ParenFinder : NSObject {

    IBOutlet PixieSchemeIIIViewController* theController;
    IBOutlet JRF6UITextView *theMainJRFView;

    NSMutableArray *parenStack;

    }

- (void) clearBackTo:(NSUInteger)there;
- (void) describeParenStack;
- (NSInteger) endLevel;
- (NSUInteger) eatCommentFrom:(NSUInteger)start inText:(NSString *)theText;
- (NSUInteger) eatStringFrom:(NSUInteger)start inText:(NSString *)theText;
- (NSUInteger) findCodeBackwardFrom:(NSUInteger)start inText:(NSString *)theText;
- (BOOL) findMatchingLeftParenInCode:(NSUInteger)here at:(NSUInteger *)foundAt;
- (BOOL) findMatchingRParenFrom:(NSUInteger)start at:(NSUInteger *)whereFound inText:(NSString *)theText;
- (BOOL) findMatchingRightParenInCode:(NSUInteger)here at:(NSUInteger *)foundAt inText:(NSString *)theText;
- (BOOL) isInCode:(NSUInteger)here withCodeStart:(NSUInteger)start inText:(NSString *)theText;
- (BOOL) lastIndexBefore:(NSUInteger)here is:(NSUInteger *)desiredIndex;
- (BOOL) lastParenBefore:(NSUInteger)here at:(NSUInteger *)foundAt inText:(NSString *)theText;
- (void) pushLeftParenAt:(NSUInteger)here;
- (void) pushRightParenAt:(NSUInteger)here;
- (void) rebuildParenStackFromCodeAt:(NSUInteger)start toButNotIncluding:(NSUInteger)end inText:(NSString *)theText;
- (void) rebuildParenStackToButNotIncluding:(NSUInteger)end inText:(NSString *)theText;
- (NSUInteger) scanSkipBackslash:(NSUInteger)start inText:(NSString *)theText;

@property( nonatomic, retain ) IBOutlet PixieSchemeIIIViewController *theController;
@property( nonatomic, retain ) IBOutlet JRF6UITextView *theMainJRFView;

@end
