//
//  PixieIIISenseLightArrayController.h
//  WraithCocoa
//
//  Copyright 2010 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <UIKit/UIKit.h>
#import "SenseLightCommands.h"
#import "LocalTypes.h"

@interface PixieIIISenseLightArrayController : NSObject {

    IBOutlet id theSchemeController;    

    bool state[ N_SENSE_LIGHTS ];             // true <--> on; false <--> off.
    bool visible[ N_SENSE_LIGHTS ];           // Are the lights visible?
    int illumination[ N_SENSE_LIGHTS ];       // What colors are the lights?  (Includes "off")
    UIButton *theView[ N_SENSE_LIGHTS ];

    IBOutlet UIButton *button0;
    IBOutlet UIButton *button1;
    IBOutlet UIButton *button2;
    IBOutlet UIButton *button3;
    IBOutlet UIButton *button4;
    IBOutlet UIButton *button5;
    IBOutlet UIButton *button6;
    IBOutlet UIButton *button7;

    UIImage *redImage;
    UIImage *orangeImage;
    UIImage *yellowImage;
    UIImage *greenImage;
    UIImage *cyanImage;
    UIImage *magentaImage;
    UIImage *offImage;
    UIImage *blackImage;

    }

- (void) initialize;
- (void) clearSenseLights;
- (void) interpretLongCommand:(LongWord)c;
- (void) interpretOneCommand:(unsigned char)c forLight:(int)light;
- (void) interpretBothCommands:(unsigned char)c forLight:(LongWord)light;
- (void) rotateLights:(LongWord)n;
- (void) setLight:(int)light toIllumination:(int)newIllumination;
- (void) setLight:(int)light toVisible:(bool)newVisible;
- (bool *) getState;
- (bool *) getVisible;
- (bool) anyVisible;
- (int *) getIllumination;
- (void) setLightNFromRecordedState:(int)n;

@end
