
//
//  PixieIIIStatusLightController.m
//  WraithCocoa
//
//  Created by Jay Freeman on 12/16/06.
//  Copyright 2006 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import "PixieIIIStatusLightController.h"

@implementation PixieIIIStatusLightController

- init {

    onImage = nil;
    offImage = nil;

    return [super init];
    }

- (void) awakeFromNib { [self turnOff]; }

- (bool) statusControllerState { return state; }

- (void) setOnImage:(UIImage *)theOnImage { 

    if( onImage != nil )
        [onImage release];
    onImage = [theOnImage retain];
    }

- (void) setOffImage:(UIImage *)theOffImage {

    if( offImage != nil )
        [offImage release];
    offImage = [theOffImage retain];
    }

- (void) turnOn {

    [theView setImage:onImage forState:[theView state]];
    state = true;
    }

- (void) turnOff {

    [theView setImage:offImage forState:[theView state]];
    state = false;
    }

- (bool) isOn { return state; }

@end
