
//
//  PixieSchemeIIIViewController.h
//
//  Created by Jay Freeman on 06/13/2010
//  Copyright 2006 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <UIKit/UIKit.h>

#import <sys/types.h>
#import <sys/stat.h>

#define WORD_MASK 0xffffffff

#import "CocoaInterface.h"
#import "CocoaIO.h"
#import "UserSetup.h"
#import "PixieIIIMainAux.e"
#import "JRF6UITextView.h"

@class DialogController;
@class FeaturesViewController;
@class HelpViewController;
@class PixieIIIWindowController;
@class PixieIIIStatusLightController;
@class PixieIIISenseLightArrayController;
@class Pixie_Scheme_IIIAppDelegate;
@class JRF6UITextView;
@class CustomDockIconView;
@class TextDocController;
@class TintedUIView;
@class WebDocController;

@interface PixieSchemeIIIViewController : UIViewController <UIActionSheetDelegate, UITextViewDelegate> {

    bool displayingMessage;
    bool evaluating;
    bool expectMoreInput;
    bool gcing;
    bool outputEnabled;
    bool showingGenerationalInformation;
    bool stopEvaluatingPending;
    bool wantsToQuit;

    BOOL keyboardShown;

    CGFloat currentFontSize;
    CGFloat currentLineSize;

    int nextTask;
    long messageDisplayCounter;

    LongWord generationalMemorySizeInUse;
    LongWord mainMemorySizeInUse;
            
    NSArray *symbolsInPixieSchemeDictionary;

    NSMutableString *mainDisplayBuffer;

    NSRange rangeForNextInsertion;
	NSRange textLastRange;
    NSRange rangeBeingChanged;

    NSString *stringOfChange;

    UIActionSheet *currentReportDisasterAndQuitAS;
    UIActionSheet *currentReportEarlyDisasterAndQuitAS;
    UIActionSheet *currentRunReloadWorldAS;
    UIActionSheet *currentLocalErrorAS;

    UIColor *black;
    UIColor *buttonTextNormalColor;
    UIColor *darkGreen;
    UIColor *paleGreen;
    UIColor *red;
    UIColor *paleRed;
    UIColor *coolBlue;
    UIColor *paleCoolBlue;
;
    UIColor *specialYellow;

    UIFont *applicationFont;

//     UIImage *PixieFace;    // FIXME out for development

    UIImage *PixieIIIIconImage;

    UIPopoverController *featuresPopover;
    UIPopoverController *helpPopover;

    UIViewController *frontController;

    IBOutlet NSString *dialogResponseString;

    IBOutlet UIBarButtonItem *featuresBarButtonItem;
    IBOutlet UIBarButtonItem *helpBarButtonItem;

    IBOutlet UIButton *markOrEvalButton;
    IBOutlet UIButton *resetSchemeButton;

    IBOutlet UIButton *featuresButton;
    IBOutlet UIButton *helpButton;

    IBOutlet UIButton *demonstrateSchemeButton;
    IBOutlet UIButton *fontBiggerButton;
    IBOutlet UIButton *fontSmallerButton;
    IBOutlet UIButton *completeRestartButton;    
    IBOutlet UIButton *saveWorldButton;

    IBOutlet UIButton *helpFileButton;
    IBOutlet UIButton *dictionaryFileButton;
    IBOutlet UIButton *warrantyFileButton;
    IBOutlet UIButton *readmeFileButton;

    IBOutlet UILabel *dialogPrompt;

    IBOutlet UISwitch *compileDefinesSwitch;
    IBOutlet UISwitch *showFullPrecisionSwitch;

    IBOutlet UITextField *dialogResponse;

    IBOutlet UIView *dialogView;

    IBOutlet TintedUIView *tintRectangle1;
    IBOutlet TintedUIView *tintRectangle2;
    IBOutlet TintedUIView *tintRectangle3;
    IBOutlet TintedUIView *tintRectangle4;
    IBOutlet TintedUIView *tintRectangle5;

    IBOutlet DialogController *dialogController;
    IBOutlet FeaturesViewController *featuresController;
    IBOutlet HelpViewController *helpController;
    IBOutlet TextDocController *readmeController;
    IBOutlet TextDocController *warrantyController;
    IBOutlet WebDocController *helpFileController;
    IBOutlet WebDocController *dictionaryFileController;

    IBOutlet JRF6UITextView *theMainJRFView;

//    IBOutlet NSMenu *ShortcutsMenu;    // FIXME out for development

    IBOutlet PixieIIISenseLightArrayController *sLAController;

    IBOutlet PixieIIIStatusLightController *eVBController;
    IBOutlet PixieIIIStatusLightController *gCBController;

    IBOutlet UIApplication *theApplication;

    IBOutlet UINavigationBar *theNavigationBar;

    IBOutlet UIProgressView *myLevelIndicator;

    IBOutlet UITextField *memoryUsedLabel;
    IBOutlet UITextField *memoryRangeLabel;

    IBOutlet UIToolbar *theToolBar;

    IBOutlet UIWindow *myParentWindow;

    IBOutlet Pixie_Scheme_IIIAppDelegate *appDelegate;
    }

- (void) actionToSaveState;
- (void) applicationDidFinishLaunchingContent;
- (void) beginInitLevel;
//- (IBAction) closeDialogSheet:(id)sender;    // FIXME out for development
- (void) changeFrontControllerTo:(UIViewController *)newFrontController;
- (void) cleanUpForExit;
- (bool) controllerInitializationTask;
- (CGFloat) currentFontSize;
- (CGFloat) currentLineSize;
- (NSArray *) createCompletionArray;
- (void) didRedo:(NSNotification *)notification;
- (void) didUndo:(NSNotification *)notification;
- (bool) dealWithResponseText;
- (void) dealWithSelection:(bool)value;
- (void) dealWithTextRange:(bool)value;
- (IBAction) demonstrateScheme:(id)sender;
//- (void) didEndUserDialogSheet:(UIWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo;    // FIXME out for development
- (void) dismissModal:(id)sender;
- (void) displayAll;
- (IBAction) displayDictionary:(id)sender;
- (IBAction) displayHelp:(id)sender;
- (IBAction) displayReadMe:(id)sender;
- (void) displayStringInMainView:(NSString *)str;
- (IBAction) displayWarranty:(id)sender;
- (void) doControllerInitializationTask:(NSTimer *)theTimer;
- (NSString *) documentsDirectoryAndSetGlobal;
- (IBAction) doQuit:(id)sender;
- (void) endInitLevel;
- (IBAction) findInPixieSchemeDictionary:(id)sender;
- (BOOL) keyboardShown;
- (void) keyboardDidShow:(NSNotification *)aNotification;
// - (void)keyboardWillBeHidden:(NSNotification*)aNotification;
// - (void)keyboardWillBeShown:(NSNotification*)aNotification;
- (void) keyboardWillHide:(NSNotification *)notification;
- (void) keyboardWillShow:(NSNotification *)notification;
- (void) loadEditSession;
- (void) localError:(NSString *)message;
void logRect( CGRect aRect, NSString *name );
- (IBAction) makeFontBigger:(id)sender;
- (IBAction) makeFontSmaller:(id)sender;
CGFloat matchingLineHeight( CGFloat fontSize );
- (void) moveTextViewForKeyboard:(NSNotification*)aNotification up:(BOOL)up;
- (void) newViewString:(const char *)newString forView:(UITextField *)theView;
CGFloat nextLargestFontSize( CGFloat fontSize );
CGFloat nextSmallestFontSize( CGFloat fontSize );
- (void) nothing:(id)thing;
- (IBAction) openDictionaryFile:(id)sender;
- (IBAction) openGNU:(id)sender;
- (IBAction) openReadMe:(id)sender;
- (IBAction) openHelpFile:(id)sender;
- (IBAction) openSourceCode1:(id)sender;
- (IBAction) openSourceCode2:(id)sender;
- (IBAction) openSourceCode3:(id)sender;
- (IBAction) openSourceCode4:(id)sender;
- (IBAction) openSourceCode5:(id)sender;
- (IBAction) openSourceCode6:(id)sender;
- (IBAction) openSourceCode7:(id)sender;
- (IBAction) openSourceCode8:(id)sender;
- (IBAction) openSourceCode9:(id)sender;
- (IBAction) openSourceCode10:(id)sender;
- (bool) pollEvaluatorOnce;
- (void) postMakeFinalWorld;
- (IBAction) presentFeaturesPopover:(id)sender;
- (IBAction) presentHelpPopover:(id)sender;
- (void) provideUserSetup;
- (void) reportDisasterAndQuit:(const char *)errorMessage;
- (void) reportEarlyDisasterAndQuit;
- (IBAction) requestReset:(id)sender;
- (void) runEvaluator:(id)theObject;
- (IBAction) runReloadWorldSheet:(id)sender;
- (IBAction) saveWorld:(id)sender;
- (void) saveEditSession;
- (void) saveWorldForEnd;
- (void) selectExpression:(id)sender;
- (void) setControllerSetup:(userSetup *)aSetup;
- (void) setCurrentFontSize:(CGFloat)fontSize;
- (void) setDefaultControllerSetup;
- (void) setFontsToSize:(CGFloat)fontSize;
- (void) setForForgettingTyping;
- (void) setForEvaluating;
- (void) setForGCing;
- (void) setForNotEvaluating;
- (void) setForNotGCing;
- (void) setMainViewText:(NSString *)msg;
- (void) setNormalLights;
- (void) setRangeForNextInsertion:(NSRange)newSelectionRange;
//- (void) showDialogSheet:(UIWindow *)window;    // FIXME out for development
- (NSArray *) spellingCompletionsForPartialWord:(NSString *)partWord;
- (void) startDialog:(NSString *)thePrompt;
- (void) startNormalInput;
- (void) tellEvaluator:(Word)mID withLong:(LongWord)mLong withString:(const char *)mString;
- (IBAction) toggleCompileDefines:(id)sender;
- (IBAction) toggleFullNumericPrecision:(id)sender;
- (void) touchesBeganInView:(UIEvent *)theEvent;
- (void) updateLevel:( float )newValue;
- (void) takeInputFromTitle:(id)sender;
- (void) worldLoadSucceeded:(const char *)path;

@property (nonatomic, retain) IBOutlet JRF6UITextView *theMainJRFView;
@property (nonatomic, retain) IBOutlet NSString *dialogResponseString;
@property (nonatomic, retain) IBOutlet UINavigationBar *theNavigationBar;
@property (nonatomic, retain) IBOutlet UIToolbar *theToolBar;
@property (nonatomic, retain) IBOutlet UIWindow *myParentWindow;
@property (nonatomic, retain) IBOutlet UIButton *markOrEvalButton;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *featuresBarButtonItem;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *helpBarButtonItem;
@property (nonatomic, retain) IBOutlet UIButton *featuresButton;
@property (nonatomic, retain) IBOutlet UIButton *helpButton;
@property (nonatomic, retain) IBOutlet UIButton *resetSchemeButton;
@property (nonatomic, retain) IBOutlet UIButton *demonstrateSchemeButton;
@property (nonatomic, retain) IBOutlet UIButton *fontBiggerButton;
@property (nonatomic, retain) IBOutlet UIButton *fontSmallerButton;
@property (nonatomic, retain) IBOutlet UIButton *completeRestartButton;
@property (nonatomic, retain) IBOutlet UIButton *saveWorldButton;
@property (nonatomic, retain) IBOutlet UIButton *helpFileButton;
@property (nonatomic, retain) IBOutlet UIButton *dictionaryFileButton;
@property (nonatomic, retain) IBOutlet UIButton *warrantyFileButton;
@property (nonatomic, retain) IBOutlet UIButton *readmeFileButton;
@property (nonatomic, retain) IBOutlet UILabel *dialogPrompt;
@property (nonatomic, retain) IBOutlet UISwitch *compileDefinesSwitch;
@property (nonatomic, retain) IBOutlet UISwitch *showFullPrecisionSwitch;
@property (nonatomic, retain) IBOutlet UITextField *dialogResponse;
@property (nonatomic, retain) IBOutlet UIView *dialogView;
@property (nonatomic, retain) IBOutlet DialogController *dialogController;
@property (nonatomic, retain) IBOutlet FeaturesViewController *featuresController;
@property (nonatomic, retain) IBOutlet HelpViewController *helpController;
@property (nonatomic, retain) IBOutlet TextDocController *readmeController;
@property (nonatomic, retain) IBOutlet TextDocController *warrantyController;
@property (nonatomic, retain) IBOutlet WebDocController *helpFileController;
@property (nonatomic, retain) IBOutlet WebDocController *dictionaryFileController;
@property (nonatomic, retain) IBOutlet UIApplication *theApplication;
@property (nonatomic, retain) IBOutlet UIProgressView *myLevelIndicator;
@property (nonatomic, retain) IBOutlet PixieIIIStatusLightController *eVBController;
@property (nonatomic, retain) IBOutlet PixieIIIStatusLightController *gCBController;
@property (nonatomic, retain) IBOutlet PixieIIISenseLightArrayController *sLAController;
@property (nonatomic, retain) IBOutlet UITextField *memoryUsedLabel;
@property (nonatomic, retain) IBOutlet UITextField *memoryRangeLabel;
@property (nonatomic, retain) IBOutlet TintedUIView *tintRectangle1;
@property (nonatomic, retain) IBOutlet TintedUIView *tintRectangle2;
@property (nonatomic, retain) IBOutlet TintedUIView *tintRectangle3;
@property (nonatomic, retain) IBOutlet TintedUIView *tintRectangle4;
@property (nonatomic, retain) IBOutlet TintedUIView *tintRectangle5;
@property (nonatomic, retain) IBOutlet Pixie_Scheme_IIIAppDelegate *appDelegate;

//@property (nonatomic, retain) IBOutlet 


@end
