;; Copyright (c) 2009 by Jay Reynolds Freeman

;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;
;;    Contact information:
;;
;;        EMail:       Jay_Reynolds_Freeman@mac.com
;;        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman
;;
;;        Paper Mail:  Jay Reynolds Freeman
;;                     Post Office Box 60628
;;                     Palo Alto, CA, 94306-0628

((lambda () (write "CompileStuff.s:") (newline)))

(c::define c::rebinder
  (lambda (x)
    (e::substitute-new-permanent-symbols (c::symeval x))
;;    (c::make-lambda-immutable! (c::symeval x))
    (display "Put new permanent symbols in ") (display x) (newline)
    ))

(c::define c::first-compiler
  (lambda (x)
    (e::cons-with-continuation `(set! ,x (e::compile-form ,x)))
    (display "Compiled ") (display x) (newline)
    ))

(c::define c::first-compiler-simple
  (lambda (x)
    (e::cons-with-continuation `(set! ,x (e::compile-form-simple ,x)))
    (display "Simple-compiled ") (display x) (newline)
    ))

(map c::first-compiler-simple c::recursive-list)
(display "Compilation step 1 complete.\n")
(map c::first-compiler-simple c::low-level-macros-list)
(display "Compilation step 2 complete.\n")
(map c::first-compiler-simple c::r5-macros-list)
(display "Compilation step 3 complete.\n")
(map c::first-compiler-simple c::compile-defines-list)
(display "Compilation step 4 complete.\n")
(map c::first-compiler-simple c::primitive-library-functions-list)
(display "Compilation step 5 complete.\n")
(map c::first-compiler-simple c::hygienic-macros-list)
(display "Compilation step 6 complete.\n")
(map c::first-compiler-simple c::dynamic-wind-list)
(display "Compilation step 7 complete.\n")
(map c::first-compiler-simple c::constants-and-primitives-list)
(display "Compilation step 8 complete.\n")
(map c::first-compiler-simple c::released-compiler-code-list)
(display "Compilation step 9 complete.\n")
(map c::first-compiler-simple c::simple-class-list)
(display "Compilation step 10 complete.\n")

(map c::first-compiler c::recursive-list)
(display "Compilation step 11 complete.\n")
(map c::first-compiler c::low-level-macros-list)
(display "Compilation step 12 complete.\n")
(map c::first-compiler c::r5-macros-list)
(display "Compilation step 13 complete.\n")
(map c::first-compiler c::compile-defines-list)
(display "Compilation step 14 complete.\n")
(map c::first-compiler c::primitive-library-functions-list)
(display "Compilation step 15 complete.\n")
(map c::first-compiler c::hygienic-macros-list)
(display "Compilation step 16 complete.\n")
(map c::first-compiler c::dynamic-wind-list)
(display "Compilation step 17 complete.\n")
(map c::first-compiler c::constants-and-primitives-list)
(display "Compilation step 18 complete.\n")
(map c::first-compiler c::released-compiler-code-list)
(display "Compilation step 19 complete.\n")
(map c::first-compiler c::simple-class-list)
(display "Compilation step 20 complete.\n")

(map e::set-permanent! c::recursive-list)
(map e::set-permanent! c::low-level-macros-list)
(map e::set-permanent! c::r5-macros-list)
(map e::set-permanent! c::compile-defines-list)
(map e::set-permanent! c::primitive-library-functions-list)
(map e::set-permanent! c::hygienic-macros-list)
(map e::set-permanent! c::dynamic-wind-list)
(map e::set-permanent! c::constants-and-primitives-list)
(map e::set-permanent! c::released-compiler-code-list)
(map e::set-permanent! c::simple-class-list)

(display "Compilation step 21 complete.\n")

(map c::rebinder c::recursive-list)
(display "Compilation step 22 complete.\n")
(map c::rebinder c::low-level-macros-list)
(display "Compilation step 23 complete.\n")
(map c::rebinder c::r5-macros-list)
(display "Compilation step 24 complete.\n")
(map c::rebinder c::compile-defines-list)
(display "Compilation step 25 complete.\n")
(map c::rebinder c::primitive-library-functions-list)
(display "Compilation step 26 complete.\n")
(map c::rebinder c::hygienic-macros-list)
(display "Compilation step 27 complete.\n")
(map c::rebinder c::dynamic-wind-list)
(display "Compilation step 28 complete.\n")
(map c::rebinder c::constants-and-primitives-list)
(display "Compilation step 29 complete.\n")
(map c::rebinder c::released-compiler-code-list)
(display "Compilation step 30 complete.\n")
(map c::rebinder c::simple-class-list)
(display "Compilation step 31 complete.\n")

(set! c::recursive-list #f)
(set! c::low-level-macros-list #f)
(set! c::r5-macros-list #f)
(set! c::compile-defines-list #f)
(set! c::primitive-library-functions-list #f)
(set! c::hygienic-macros-list #f)
(set! c::dynamic-wind-list #f)
(set! c::constants-and-primitives-list #f)
(set! c::released-compiler-code-list #f)
(set! c::simple-class-list #f)

