;;  Copyright (c) 2009 by Jay Reynolds Freeman

;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;
;;    Contact information:
;;
;;        EMail:       Jay_Reynolds_Freeman@mac.com
;;        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman
;;
;;        Paper Mail:  Jay Reynolds Freeman
;;                     Post Office Box 60628
;;                     Palo Alto, CA, 94306-0628

(write "CompilerDevelopmentTests.s:") (newline)

;########################################################
;
;     Portmanteau of handy forms, useful for testing the compiler.

(define test-lambda-body
  '((a b) 
    (list a b `(a ,b))))
(define the-alist 
  '((foo . x) (bar . y) (baz . z)))
(define the-expr 
  '`(foo ,foo bar ,bar (foo baz) ,(foo baz) (bar baz) ,@(bar baz)))
(define f1 '(+ (+ 2 3) (+ 4 5)))
(define f2 '(+ frob 3))
(define f3 '(+ 2 3))
(define l1 (lambda () (+ 5 9)))
(define l2 (lambda () (+ 33 a)))
(define l3 (lambda (x) (+ x 5)))
(define l4 (lambda (x y) (+ x y 7)))
(define l5 (lambda (x y) (+ x y a)))
(define l6 (lambda (x) (c::if x 111 0)))
(define l7 (lambda (x) (if x (+ 20 40) (+ 1000 2000))))
(define l8 (lambda () 3))
(define l9 (lambda () (l8)))
(define inc (lambda (n) (+ n 1)))
(define l10 (lambda (n) (inc (+ n 1))))
(define l11 (lambda (m n) (inc (+ m n))))
(define l12 (lambda (m n) (inc (+ (inc m) (l11 n 3)))))
(define l13 (lambda (n) (cinc (+ n 1))))
(define l14 (lambda (a b c) (if a b c)))
(define l15 (lambda (n) ((lambda (m) (+ m 1)) (+ n 1))))
(define l16 (lambda (x y) (begin (display x) (display y) 3)))
(define l17 (lambda (a b c) (and a b c)))
(define l18 (lambda (a b c) ((lambda () (if a b c)))))

(define rme1
  (lambda (form level)
    (c::if (null? form)
	  '()
    (c::if (pair? form)
	  ((lambda (key)
	    (c::if (c::if (symbol? key) 
                 (c::if (e::bound-instance? key)
                   (c::if (e::macro? (e::cons-with-continuation key))
                     #t
                     '())
                   '())
                 '())
	      (rme1 (e::expand-macro form) level)
        (cons (rme1 (car form) level)
              (rme1 (cdr form) level))))
	   (car form))
	  form))))

(define a 6)
(define fib
  (lambda ( n )
    (if (= n 1)
       1
       (if (= n 0)
         1
         (+ (fib (- n 1)) (fib (- n 2)))))))

(define ufib
  (lambda ( n )
    (c::if (= n 1)
       1
       (c::if (= n 0)
         1
         (+ (ufib (- n 1)) (ufib (- n 2)))))))

(define cfact
  (lambda (n)
    (cfact1 n 1)))

(define cfact1
  (lambda (n start)
     (e::show-stack)
	 (c::if (= n 0)
	    start
		(cfact1 (- n 1) (* n start)))))

(define re
  (lambda ( x )
    (e::show-stack)
    (c::if (= x 0)
      #t
      (re (- x 1)))))

(define re
  (lambda ( x )
    (e::show-stack)
    (e::write-stack)
    (display x) (newline)
    (c::if (= x 0)
      (e::show-stack)
      (re (- x 1)))))

(define cl5 '())
(define cl7 '())
(define cl9 '())
(define cl10 '())
(define cl11 '())
(define cl12 '())
(define cl13 '())
(define cl14 '())
(define cl15 '())
(define cl16 '())
(define cl17 '())
(define cl18 '())
(define cinc '())

(define prepare-compiler-tests
  (lambda ()
    (display "Compiling l5 - ")
    (set! cl5 (e::compile-form l5))
    (display "done") (newline)
	(display "Compiling l7 - ")
	(set! cl7 (e::compile-form l7))
    (display "done") (newline)
	(display "Compiling l9 - ")
	(set! cl9 (e::compile-form l9))
	(display "done") (newline)
	(display "Compiling l10 - ")
	(set! cl10 (e::compile-form l10))
	(display "done") (newline)
	(display "Compiling l11 - ")
	(set! cl11 (e::compile-form l11))
	(display "done") (newline)
	(display "Compiling l12 - ")
	(set! cl12 (e::compile-form l12))
	(display "done") (newline)
	(display "Compiling inc - ")
	(set! cinc (e::compile-form inc))
	(display "done") (newline)
	(display "Compiling l13 - ")
	(set! cl13 (e::compile-form l13))
	(display "done") (newline)
	(display "Compiling l14 - ")
	(set! cl14 (e::compile-form l14))
	(display "done") (newline)
	(display "Compiling l15 - ")
    (set! cl15 (e::compile-form l15))
	(display "done") (newline)
	(display "Compiling l16 - ")
    (set! cl16 (e::compile-form l16))
	(display "done") (newline)
;;	(display "Compiling l17 - ")
;;    (set! cl17 (e::compile-form l17))
;;	(display "done") (newline)
	(display "Compiling l18 - ")
    (set! cl18 (e::compile-form l18))
	(display "done") (newline)
	(display "Compiling fib to fib - ")
    (set! fib
      (lambda ( n )
        (if (= n 1)
           1
           (if (= n 0)
             1
             (+ (fib (- n 1)) (fib (- n 2)))))))
	(set! fib (e::compile-form fib))
	(display "done") (newline)
	))

(define compiler-tests
  (lambda ()
    (display (list "l5" (l5 2 3) (cl5 2 3))) (newline)
    (display (list "l7" (l7 #t) (cl7 #t) (l7 #f) (cl7 #f))) (newline)
    (display (list "l9" (l9) (cl9))) (newline)
    (display (list "l10" (l10 2) (cl10 2))) (newline)
    (display (list "l11" (l11 2 3) (cl11 2 3))) (newline)
    (display (list "l12" (l12 5 4) (cl12 5 4))) (newline)
    (display (list "inc" (inc 2) (cinc 2))) (newline)
    (display (list "l13" (l13 2) (cl13 2))) (newline)
    (display (list "l14" (l14 #t 2 3) (cl14 #t 2 3) (l14 #f 2 3) (cl14 #f 2 3))) (newline)
    (display (list "l15" (l15 3) (cl15 3))) (newline)
    (display (list "l16" (l16 "foo " "bar ") (cl16 "foo " "bar "))) (newline)
;;    (display (list "l17" (l17 1 2 3)  (cl17 1 2 3)
;;                         (l17 1 #f 3) (cl17 1 #f 3)))
;;    (newline)
    (display (list "fib" (fib 15))) (newline)
	))
	
;;; TD

;     Convert two "ticks" results into a time difference in seconds.

(define (td finish start)
  (/ (- finish start) 60))

