(display "HygienicMacros.s:\n")

(c::define c::hygienic-macros-list (list (quote define-syntax) (quote if) (quote let*) (quote let) (quote letrec) (quote and) (quote or) (quote cond) (quote case) (quote do) (quote let-syntax) (quote letrec-syntax)))

(e::macro define-syntax c::define-syntax-code)

(define-syntax if (syntax-rules () ((if predicate consequent) (c::if predicate consequent #f)) ((if predicate consequent alternative) (c::if predicate consequent alternative))))

(define-syntax let* (syntax-rules () ((let* () body1 body2 ...) (let () body1 body2 ...)) ((let* ((name1 val1) (name2 val2) ...) body1 body2 ...) (let ((name1 val1)) (let* ((name2 val2) ...) body1 body2 ...)))))

(define-syntax let (syntax-rules () ((let ((name val) ...) body1 body2 ...) ((lambda (name ...) body1 body2 ...) val ...)) ((let tag ((name val) ...) body1 body2 ...) ((letrec ((tag (lambda (name ...) body1 body2 ...))) tag) val ...))))

(define-syntax letrec (syntax-rules () ((letrec ((name val) ...) body1 body2 ...) ((lambda (name ...) (begin (c::set! name val) ...) ((lambda () body1 body2 ...))) (quote name) ...))))

(define-syntax and (syntax-rules () ((and) #t) ((and e) e) ((and e1 e2 ...) (if e1 (and e2 ...) #f))))

(define-syntax or (syntax-rules () ((or) #f) ((or e) e) ((or e1 e2 ...) (let ((temp e1)) (if temp temp (or e2 ...))))))

(define-syntax cond (syntax-rules (else =>) ((cond (else result1 result2 ...)) (begin result1 result2 ...)) ((cond (test => result)) (let ((temp test)) (if temp (result temp)))) ((cond (test => result) clause1 clause2 ...) (let ((temp test)) (if temp (result temp) (cond clause1 clause2 ...)))) ((cond (test)) test) ((cond (test) clause1 clause2 ...) (let ((temp test)) (if temp temp (cond clause1 clause2 ...)))) ((cond (test result1 result2 ...)) (if test (begin result1 result2 ...) #t)) ((cond (test result1 result2 ...) clause1 clause2 ...) (if test (begin result1 result2 ...) (cond clause1 clause2 ...)))))

(define-syntax case (syntax-rules (else) ((case (key ...) clauses ...) (let ((atom-key (key ...))) (case atom-key clauses ...))) ((case key (else result1 result2 ...)) (begin result1 result2 ...)) ((case key ((atoms ...) result1 result2 ...)) (if (memv key (quote (atoms ...))) (begin result1 result2 ...) #t)) ((case key ((atoms ...) result1 result2 ...) clause clauses ...) (if (memv key (quote (atoms ...))) (begin result1 result2 ...) (case key clause clauses ...)))))

(define-syntax do (syntax-rules () ((do ((var init step ...) ...) (test expr ...) command ...) (letrec ((loop (lambda (var ...) (if test (begin #t expr ...) (begin #t command ... (loop (do "step" var step ...) ...)))))) (loop init ...))) ((do "step" x) x) ((do "step" x y) y)))

(define-syntax let-syntax (syntax-rules () ((let-syntax () body ...) (begin body ...)) ((let-syntax ((kwd tspec) ...) body ...) ((lambda (kwd ...) body ...) (e::syntax-macro-body kwd tspec) ...))))

(define-syntax letrec-syntax (syntax-rules () ((letrec-syntax () body ...) (begin body ...)) ((letrec-syntax ((kwd tspec) ...) body ...) (letrec ((kwd (e::syntax-macro-body kwd tspec)) ...) body ...))))

