(display "PrimitiveLibrary.s:\n")

(c::define c::primitive-library-functions-list (list (quote call-with-values) (quote port?) (quote values) (quote e::syntax-binding-binding) (quote e::syntax-binding-bound?) (quote e::syntax-binding-symbol) (quote e::syntax-binding-properties) (quote e::deep-copy) (quote null-environment) (quote scheme-report-environment) (quote interaction-environment) (quote eval) (quote e::number->string-with-n-decimals) (quote e::money->string) (quote e::logic-constant?) (quote e::non-printing-object?) (quote c::pi) (quote c::make-blocking-queue) (quote c::last-pair) (quote c::dequeue) (quote c::enqueue) (quote c::empty-queue?) (quote c::purge-queue) (quote c::make-lambda-immutable!) (quote e::entropy-death) (quote e::all?-aux) (quote e::all?) (quote e::any?-aux) (quote e::any?) (quote e::umber-nay->ing-stray) (quote e::make-offsets) (quote c::get-n-thousands) (quote c::n-thousands-characters) (quote c::get-n-hundreds) (quote c::n-hundreds-characters) (quote c::get-n-tens) (quote c::n-tens-characters) (quote c::get-n-ones) (quote c::n-ones-characters) (quote e::ing-stray->umber-nay) (quote e::perform-applicative)))

(c::map-without-type-checking e::clear-permanent! c::primitive-library-functions-list)

(c::define values (c::lambda x (c::if (> (length x) 1) (c::set-tag! x c::multiple_values_tag) (c::if (= (length x) 1) (car x) (e::error "\"values\" called with no arguments.")))))

(c::define port? (c::lambda (x) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (output-port? x))) (input-port? x))))

(c::define call-with-values (c::lambda (producer consumer) (c::if (c::if (procedure? consumer) (procedure? producer) #f) ((c::lambda (lambda-var-0) (c::if (e::multiple-values? lambda-var-0) (apply consumer (c::set-tag! lambda-var-0 c::pair_tag)) (apply consumer (list lambda-var-0)))) (producer)) (c::begin (newline) (display "Procedure \"call-with-values\" applied to " (e::error-port)) (display (list producer consumer) (e::error-port)) (display ":" (e::error-port)) (c::if (not (procedure? producer)) (c::begin (newline) (display " -> " (e::error-port)) (display producer (e::error-port)) (display "\n    Expected a procedure (either a built-in or a lambda expression) for argument list item 0 (zero-based)." (e::error-port))) #f) (c::if (not (procedure? consumer)) (c::begin (newline) (display " -> " (e::error-port)) (display consumer (e::error-port)) (display "\n    Expected a procedure (either a built-in or a lambda expression) for argument list item 1 (zero-based)." (e::error-port))) #f) (e::error (string-append "Marked argument" (c::if (c::if (not (procedure? consumer)) (not (procedure? producer)) #f) "s have improper types" " has improper type") " for this operation."))))))

(c::define e::syntax-binding-binding (c::lambda (sb) (c::if (e::syntax-binding? sb) (c::if (not (cadr (c::set-tag! sb c::pair_tag))) (c::begin (newline) (display "Procedure \"e::syntax-binding-binding\" applied to\n    " (e::error-port)) (display sb (e::error-port)) (display ":" (e::error-port)) (e::error "Variable is not bound in this syntax binding.")) (caddr (c::set-tag! sb 2))) (c::begin (newline) (display "Procedure \"e::syntax-binding-binding\" applied to\n    " (e::error-port)) (display sb (e::error-port)) (display ":" (e::error-port)) (e::error "Argument has improper type for this operation.")))))

(c::define e::syntax-binding-bound? (c::lambda (sb) (c::if (e::syntax-binding? sb) (cadr (c::set-tag! sb c::pair_tag)) (c::begin (newline) (display "Procedure \"e::syntax-binding-bound?\" applied to\n    " (e::error-port)) (display sb (e::error-port)) (display ":" (e::error-port)) (e::error "Argument has improper type for this operation.")))))

(c::define e::syntax-binding-symbol (c::lambda (sb) (c::if (e::syntax-binding? sb) (car (c::set-tag! sb c::pair_tag)) (c::begin (newline) (display "Procedure \"e::syntax-binding-symbol\" applied to\n    " (e::error-port)) (display sb (e::error-port)) (display ":" (e::error-port)) (e::error "Argument has improper type for this operation.")))))

(c::define e::syntax-binding-properties (c::lambda (sb) (c::if (e::syntax-binding? sb) (cdddr (c::set-tag! sb c::pair_tag)) (c::begin (newline) (display "Procedure \"e::syntax-binding-properties\" applied to\n    " (e::error-port)) (display sb (e::error-port)) (display ":" (e::error-port)) (e::error "Argument has improper type for this operation.")))))

(c::define e::deep-copy (c::lambda (x) (c::if (pair? x) (cons (e::deep-copy (car x)) (e::deep-copy (cdr x))) (c::if (vector? x) (list->vector (map e::deep-copy (vector->list x))) (c::if (string? x) (string-copy x) (c::if #t x #t))))))

(c::define null-environment (c::lambda (n) (c::if (c::if (= n 5) (exact? n) #f) (c::null-environment) (c::begin (display "Procedure \"null-environment\" called with version: " (e::error-port)) (display n (e::error-port)) (e::error "The only value of \"version\" allowed by Wraith Scheme is the exact integer 5.")))))

(c::define scheme-report-environment (c::lambda (n) (c::if (c::if (= n 5) (exact? n) #f) (c::scheme-report-environment) (c::begin (display "Procedure \"scheme-report-environment\" called with version: " (e::error-port)) (display n (e::error-port)) (e::error "The only value of \"version\" allowed by Wraith Scheme is the exact integer 5.")))))

(c::define interaction-environment (c::lambda () (c::top-level-environment)))

(c::define eval (c::lambda (quoted-thunk env) (c::eval-in-environment quoted-thunk env)))

(c::define e::number->string-with-n-decimals (c::lambda (x n) (c::if (not (number? x)) (c::begin (newline (e::error-port)) (display x (e::error-port)) (newline (e::error-port)) (e::error "\"e::number->string-with-n-decmals\" called with first argument that is not a number.")) #f) (c::if (not (c::if (integer? n) (c::if (not (negative? n)) (c::if (< n 11) (exact? n) #f) #f) #f)) (c::begin (newline (e::error-port)) (display n (e::error-port)) (newline (e::error-port)) (e::error "\"e::number->string-with-n-decmals\" called with second argument that is not an exact  positive integer less than 11.")) #f) (c::number->string-with-c-format x (string-append "%." (number->string n) "f"))))

(c::define e::money->string (c::lambda (x) (c::if (not (number? x)) (c::begin (newline (e::error-port)) (display x (e::error-port)) (newline (e::error-port)) (e::error "\"e::money->string\" called with argument that is not a number.")) #f) (e::number->string-with-n-decimals x 2)))

(c::define e::logic-constant? (c::lambda (x) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (eq? x #s))) (eq? x #u))))

(c::define c::pi 3.1415926535897931)

(c::define e::entropy-death 9223372036854775807)

(c::define (c::make-blocking-queue) (list (quote ()) 42))

(c::define c::last-pair (c::lambda (l) (c::if (null? (cdr l)) l (c::last-pair (cdr l)))))

(c::define c::dequeue (c::lambda (queue) ((c::lambda (lambda-var-0) (c::if (eq? (car queue) (quote ())) (c::begin (e::error "Attempt to dequeue an empty blocking queue") (c::release-block lambda-var-0) #t) ((c::lambda (lambda-var-1) ((c::lambda () (set-car! queue (cdar queue)) (c::release-block lambda-var-0) lambda-var-1))) (caar queue)))) (c::block (cdr queue)))))

(c::define c::enqueue (c::lambda (x queue) ((c::lambda (lambda-var-0) (c::if (null? (car queue)) (set-car! queue (cons x (quote ()))) (set-cdr! (c::last-pair (car queue)) (cons x (quote ())))) (c::release-block lambda-var-0) #t) (c::block (cdr queue)))))

(c::define c::empty-queue? (c::lambda (queue) ((c::lambda (lambda-var-0) ((c::lambda (lambda-var-1) ((c::lambda () (c::release-block lambda-var-0) lambda-var-1))) (null? (car queue)))) (c::block (cdr queue)))))

(c::define c::purge-queue (c::lambda (queue) ((c::lambda (lambda-var-0) (set-car! queue (quote ())) (c::release-block lambda-var-0) #t) (c::block (cdr queue)))))

(c::define c::make-lambda-immutable! (c::lambda (lam) (c::if (procedure? lam) ((c::lambda (lambda-var-2) ((c::lambda (lambda-var-0) ((c::lambda (lambda-var-1) ((c::lambda () (set-cdr! lambda-var-2 (cons (c::make-immutable! lambda-var-0) lambda-var-1))))) (cddr lambda-var-2))) (cadr lambda-var-2))) (c::set-tag! lam c::pair_tag)) #f) #t))

(c::define e::all?-aux (c::lambda (lyst) (c::if (null? lyst) #t (c::if (car lyst) (e::all?-aux (cdr lyst)) (c::if #t #f #t)))))

(c::define e::all? (c::lambda (lyst) (c::if (list? lyst) (e::all?-aux lyst) (c::begin (newline) (display "Procedure \"e::all?\" applied to " (e::error-port)) (display (list lyst) (e::error-port)) (display ":" (e::error-port)) (display "\n    Expected a list for the argument." (e::error-port)) (e::error "Argument has improper type for this operation.")))))

(c::define e::any?-aux (c::lambda (lyst) (c::if (null? lyst) #f (c::if (car lyst) #t (c::if #t (e::any?-aux (cdr lyst)) #t)))))

(c::define e::any? (c::lambda (lyst) (c::if (list? lyst) (e::any?-aux lyst) (c::begin (newline) (display "Procedure \"e::any?\" applied to " (e::error-port)) (display (list lyst) (e::error-port)) (display ":" (e::error-port)) (display "\n    Expected a list for the argument." (e::error-port)) (e::error "Argument has improper type for this operation.")))))

(c::define e::umber-nay->ing-stray (c::lambda (x) (c::if (not (number? x)) (c::begin (newline) (display "Procedure \"e::umber-nay->ing-stray\" applied to\n    " (e::error-port)) (display x (e::error-port)) (display ":" (e::error-port)) (e::error "Argument has improper type for this operation.")) #f) (c::if (c::if (number? x) (c::if (integer? x) (c::if (exact? x) (c::if (>= x 0) (<= x 3999) #f) #f) #f) #f) (c::if (= x 0) "N" ((c::lambda (lambda-var-0 lambda-var-1 lambda-var-2 lambda-var-3 lambda-var-4) (c::begin (c::if (= lambda-var-0 0) #t (c::if (= lambda-var-0 1000) (c::set! lambda-var-4 "M") (c::if (= lambda-var-0 2000) (c::set! lambda-var-4 "MM") (c::if #t (c::set! lambda-var-4 "MMM") #t)))) (c::if (= lambda-var-1 0) #t (c::if (= lambda-var-1 100) (c::set! lambda-var-4 (string-append lambda-var-4 "C")) (c::if (= lambda-var-1 200) (c::set! lambda-var-4 (string-append lambda-var-4 "CC")) (c::if (= lambda-var-1 300) (c::set! lambda-var-4 (string-append lambda-var-4 "CCC")) (c::if (= lambda-var-1 400) (c::set! lambda-var-4 (string-append lambda-var-4 "CD")) (c::if (= lambda-var-1 500) (c::set! lambda-var-4 (string-append lambda-var-4 "D")) (c::if (= lambda-var-1 600) (c::set! lambda-var-4 (string-append lambda-var-4 "DC")) (c::if (= lambda-var-1 700) (c::set! lambda-var-4 (string-append lambda-var-4 "DCC")) (c::if (= lambda-var-1 800) (c::set! lambda-var-4 (string-append lambda-var-4 "DCCC")) (c::if #t (c::set! lambda-var-4 (string-append lambda-var-4 "CM")) #t)))))))))) (c::if (= lambda-var-2 0) #t (c::if (= lambda-var-2 10) (c::set! lambda-var-4 (string-append lambda-var-4 "X")) (c::if (= lambda-var-2 20) (c::set! lambda-var-4 (string-append lambda-var-4 "XX")) (c::if (= lambda-var-2 30) (c::set! lambda-var-4 (string-append lambda-var-4 "XXX")) (c::if (= lambda-var-2 40) (c::set! lambda-var-4 (string-append lambda-var-4 "XL")) (c::if (= lambda-var-2 50) (c::set! lambda-var-4 (string-append lambda-var-4 "L")) (c::if (= lambda-var-2 60) (c::set! lambda-var-4 (string-append lambda-var-4 "LX")) (c::if (= lambda-var-2 70) (c::set! lambda-var-4 (string-append lambda-var-4 "LXX")) (c::if (= lambda-var-2 80) (c::set! lambda-var-4 (string-append lambda-var-4 "LXXX")) (c::if #t (c::set! lambda-var-4 (string-append lambda-var-4 "XC")) #t)))))))))) (c::if (= lambda-var-3 0) #t (c::if (= lambda-var-3 1) (c::set! lambda-var-4 (string-append lambda-var-4 "I")) (c::if (= lambda-var-3 2) (c::set! lambda-var-4 (string-append lambda-var-4 "II")) (c::if (= lambda-var-3 3) (c::set! lambda-var-4 (string-append lambda-var-4 "III")) (c::if (= lambda-var-3 4) (c::set! lambda-var-4 (string-append lambda-var-4 "IV")) (c::if (= lambda-var-3 5) (c::set! lambda-var-4 (string-append lambda-var-4 "V")) (c::if (= lambda-var-3 6) (c::set! lambda-var-4 (string-append lambda-var-4 "VI")) (c::if (= lambda-var-3 7) (c::set! lambda-var-4 (string-append lambda-var-4 "VII")) (c::if (= lambda-var-3 8) (c::set! lambda-var-4 (string-append lambda-var-4 "VIII")) (c::if #t (c::set! lambda-var-4 (string-append lambda-var-4 "IX")) #t)))))))))) lambda-var-4)) (* (quotient x 1000) 1000) (* (modulo (quotient x 100) 10) 100) (* (modulo (quotient x 10) 10) 10) (* (modulo (quotient x 1) 10) 1) "")) (number->string x))))

(define (e::make-offsets initial-offset pairs) (if (not (integer? initial-offset)) (c::begin (newline) (display "Procedure \"e::make-offsets\" applied to " (e::error-port)) (display (list initial-offset pairs) (e::error-port)) (display ":\n -> " (e::error-port)) (display initial-offset (e::error-port)) (display "\n Expected a number for argument list item 0 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (if (not (pair? pairs)) (c::begin (newline) (display "Procedure \"e::make-offsets\" applied to " (e::error-port)) (display (list initial-offset pairs) (e::error-port)) (display ":\n -> " (e::error-port)) (display pairs (e::error-port)) (display "\n Expected a non-empty list for argument list item 1 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (if (not (pair? (car pairs))) (c::begin (newline) (display "Procedure \"e::make-offsets\" applied to " (e::error-port)) (display (list initial-offset pairs) (e::error-port)) (display ":\n -> " (e::error-port)) (display pairs (e::error-port)) (display "\n Expected a non-empty list for the car of argument list item 1 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (letrec ((last-value (quote ())) (do-one-form (lambda (previous-offset previous-size name current-size) (if (not (integer? previous-offset)) (c::begin (newline) (display "Auxiliary procedure \"do-one-form\" for \"e::make-offsets\" applied to " (e::error-port)) (display (list previous-offset previous-size name current-size) (e::error-port)) (display ":\n -> " (e::error-port)) (display previous-offset (e::error-port)) (display "\n Expected a number for argument list item 0 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (if (not (integer? previous-size)) (c::begin (newline) (display "Auxiliary procedure \"do-one-form\" for \"e::make-offsets\" applied to " (e::error-port)) (display (list previous-offset previous-size name current-size) (e::error-port)) (display ":\n -> " (e::error-port)) (display previous-size (e::error-port)) (display "\n Expected a number for argument list item 1 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (if (not (symbol? name)) (c::begin (newline) (display "Auxiliary procedure \"do-one-form\" for \"e::make-offsets\" applied to " (e::error-port)) (display (list previous-offset previous-size name current-size) (e::error-port)) (display ":\n -> " (e::error-port)) (display name (e::error-port)) (display "\n Expected a symbol for argument list item 2 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (if (not (integer? current-size)) (c::begin (newline) (display "Auxiliary procedure \"do-one-form\" for \"e::make-offsets\" applied to " (e::error-port)) (display (list previous-offset previous-size name current-size) (e::error-port)) (display ":\n -> " (e::error-port)) (display current-size (e::error-port)) (display "\n Expected a number for argument list item 3 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (c::set! last-value (+ previous-offset previous-size current-size)) (quasiquote (define (unquote (string->symbol (string-append (symbol->string name) "-offset"))) (unquote (+ previous-offset previous-size)))))) (do-forms (lambda (previous-offset previous-size pairs) (if (not (integer? previous-offset)) (c::begin (newline) (display "Auxiliary procedure \"do-forms\" for \"e::make-offsets\" applied to " (e::error-port)) (display (list previous-offset previous-size pairs) (e::error-port)) (display ":\n -> " (e::error-port)) (display previous-offset (e::error-port)) (display "\n Expected a number for argument list item 0 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (if (not (integer? previous-size)) (c::begin (newline) (display "Auxiliary procedure \"do-forms\" for \"e::make-offsets\" applied to " (e::error-port)) (display (list previous-offset previous-size pairs) (e::error-port)) (display ":\n -> " (e::error-port)) (display previous-size (e::error-port)) (display "\n Expected a number for argument list item 1 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (if (not (list? pairs)) (c::begin (newline) (display "Auxiliary procedure \"do-forms\" for \"e::make-offsets\" applied to " (e::error-port)) (display (list previous-offset previous-size pairs) (e::error-port)) (display ":\n -> " (e::error-port)) (display pairs (e::error-port)) (display "\nExpected a list for argument list item 2 (zero-based)." (e::error-port)) (e::error "Argument has improper type for this operation."))) (cond ((null? pairs) (quote ())) (#t (cons (do-one-form previous-offset previous-size (caar pairs) (cadar pairs)) (do-forms (+ previous-offset previous-size) (cadar pairs) (cdr pairs)))))))) (display (list initial-offset pairs (caar pairs))) (newline) (eval (quasiquote (begin (unquote-splicing (do-forms 0 initial-offset pairs)) (unquote (- last-value initial-offset)))) (interaction-environment))))

(c::define c::get-n-thousands (c::lambda (s) ((c::lambda (lambda-var-0) (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "MMM") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "MM") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "M") #f) 1 0)))) (string-length s))))

(c::define c::n-thousands-characters (c::lambda (s) ((c::lambda (lambda-var-0) (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "MMM") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "MM") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "M") #f) 1 0)))) (string-length s))))

(c::define c::get-n-hundreds (c::lambda (s) ((c::lambda (lambda-var-0) (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "CM") #f) 9 (c::if (c::if (>= lambda-var-0 4) (string=? (substring s 0 4) "DCCC") #f) 8 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "DCC") #f) 7 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "DC") #f) 6 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "D") #f) 5 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "CD") #f) 4 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "CCC") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "CC") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "C") #f) 1 0)))))))))) (string-length s))))

(c::define c::n-hundreds-characters (c::lambda (s) ((c::lambda (lambda-var-0) (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "CM") #f) 2 (c::if (c::if (>= lambda-var-0 4) (string=? (substring s 0 4) "DCCC") #f) 4 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "DCC") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "DC") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "D") #f) 1 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "CD") #f) 2 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "CCC") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "CC") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "C") #f) 1 0)))))))))) (string-length s))))

(c::define c::get-n-tens (c::lambda (s) ((c::lambda (lambda-var-0) (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "XC") #f) 9 (c::if (c::if (>= lambda-var-0 4) (string=? (substring s 0 4) "LXXX") #f) 8 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "LXX") #f) 7 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "LX") #f) 6 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "L") #f) 5 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "XL") #f) 4 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "XXX") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "XX") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "X") #f) 1 0)))))))))) (string-length s))))

(c::define c::n-tens-characters (c::lambda (s) ((c::lambda (lambda-var-0) (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "XC") #f) 2 (c::if (c::if (>= lambda-var-0 4) (string=? (substring s 0 4) "LXXX") #f) 4 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "LXX") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "LX") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "L") #f) 1 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "XL") #f) 2 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "XXX") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "XX") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "X") #f) 1 0)))))))))) (string-length s))))

(c::define c::get-n-ones (c::lambda (s) ((c::lambda (lambda-var-0) (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "IX") #f) 9 (c::if (c::if (>= lambda-var-0 4) (string=? (substring s 0 4) "VIII") #f) 8 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "VII") #f) 7 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "VI") #f) 6 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "V") #f) 5 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "IV") #f) 4 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "III") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "II") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "I") #f) 1 0)))))))))) (string-length s))))

(c::define c::n-ones-characters (c::lambda (s) ((c::lambda (lambda-var-0) (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "IX") #f) 2 (c::if (c::if (>= lambda-var-0 4) (string=? (substring s 0 4) "VIII") #f) 4 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "VII") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "VI") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "V") #f) 1 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "IV") #f) 2 (c::if (c::if (>= lambda-var-0 3) (string=? (substring s 0 3) "III") #f) 3 (c::if (c::if (>= lambda-var-0 2) (string=? (substring s 0 2) "II") #f) 2 (c::if (c::if (>= lambda-var-0 1) (string=? (substring s 0 1) "I") #f) 1 0)))))))))) (string-length s))))

(c::define e::ing-stray->umber-nay (c::lambda (given-string) (c::if (= (string-length given-string) 0) #f ((c::lambda (lambda-var-13 lambda-var-12) (c::if (string=? lambda-var-13 "N") 0 ((c::lambda (lambda-var-2) ((c::lambda (lambda-var-11) ((c::lambda (lambda-var-10) ((c::lambda (lambda-var-3) ((c::lambda (lambda-var-9) ((c::lambda (lambda-var-8) ((c::lambda (lambda-var-4) ((c::lambda (lambda-var-7) ((c::lambda (lambda-var-0) ((c::lambda (lambda-var-6) ((c::lambda (lambda-var-5) ((c::lambda (lambda-var-1) ((c::lambda () (c::if (= (+ lambda-var-11 lambda-var-9 lambda-var-7 lambda-var-1) lambda-var-12) (+ (* 1000 lambda-var-2) (* 100 lambda-var-3) (* 10 lambda-var-4) lambda-var-5) #f)))) (c::n-ones-characters lambda-var-6))) (c::get-n-ones lambda-var-6))) (substring lambda-var-8 lambda-var-7 (string-length lambda-var-8)))) (c::if (< lambda-var-7 (string-length lambda-var-8)) (substring lambda-var-8 lambda-var-7 (string-length lambda-var-8)) ""))) (c::n-tens-characters lambda-var-8))) (c::get-n-tens lambda-var-8))) (c::if (< lambda-var-9 (string-length lambda-var-10)) (substring lambda-var-10 lambda-var-9 (string-length lambda-var-10)) ""))) (c::n-hundreds-characters lambda-var-10))) (c::get-n-hundreds lambda-var-10))) (c::if (< lambda-var-11 lambda-var-12) (substring lambda-var-13 lambda-var-11 lambda-var-12) ""))) (c::n-thousands-characters lambda-var-13))) (c::get-n-thousands lambda-var-13)))) (list->string (map char-upcase (string->list given-string))) (string-length given-string)))))

(c::define e::perform-applicative (c::lambda (thunk) (c::set-applicative-bit-n-down! 0) (thunk)))

