(display "RecursveMacroExpand.s:\n")

(c::define c::recursive-list (list (quote e::macro-call?) (quote c::check-name-for-lambda-formal) (quote c::list-lambda-variable-names) (quote c::get-lambda-variables-list) (quote c::check-lambda-names) (quote c::expand-macro-calls-till-done) (quote c::find-macro-expansion-and-expand) (quote e::expand-macros-recursively) (quote c::collect-initial-defines) (quote c::find-where-body-starts) (quote c::show-internal-define-and-form-error) (quote c::convert-define-to-letrec-list-item) (quote c::letrecify-defines)))

(c::define e::macro-call? (c::lambda (form) (c::if (pair? form) (c::if (symbol? (car form)) (c::if (e::bound-instance? (car form)) (e::macro? (c::symeval (car form))) #f) #f) #f)))

(c::define c::check-name-for-lambda-formal (c::lambda (name lambda-expression) (c::if (e::permanent? name) (c::begin (display lambda-expression (e::error-port)) (e::error (string-append "The given lambda expression uses the permanent symbol \"" (symbol->string name) "\" as a formal parameter."))) #f) (c::if (c::if (e::bound-instance? name) (e::macro? (c::symeval name)) #f) (c::begin (display lambda-expression (e::error-port)) (e::error (string-append "The given lambda expression uses the macro name \"" (symbol->string name) "\" as a formal parameter."))) #f) #t))

(c::define c::list-lambda-variable-names (c::lambda (varlist whole-varlist) (c::if (null? varlist) (quote ()) (c::if (symbol? varlist) (cons varlist (quote ())) (c::if (not (pair? varlist)) (c::begin (display whole-varlist (e::error-port)) (e::error "Ill-formed formal parameter list for a lambda expression.")) (c::if (symbol? (car varlist)) (cons (car varlist) (c::list-lambda-variable-names (cdr varlist) whole-varlist)) (c::begin (display whole-varlist (e::error-port)) (e::error "Ill-formed formal parameter list for a lambda expression."))))))))

(c::define c::get-lambda-variables-list (c::lambda (form) (c::if (not (pair? form)) (c::begin (display form (e::error-port)) (e::error "Implementation: \"c::get-lambda-variables-list\" called with a form that is not a pair.")) #f) (c::if (not ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (equal? (car form) (quote c::lambda)))) (equal? (car form) (quote lambda)))) (c::begin (display form (e::error-port)) (e::error "Implementation: \"c::get-lambda-variables-list\" called with a form that is not a lambda expression.")) #f) (c::if (not (pair? (cdr form))) (c::begin (display form (e::error-port)) (e::error "\"c::get-lambda-variables-list\" called with an ill-formed lambda expression.")) #f) (c::list-lambda-variable-names (cadr form) (cadr form))))

(c::define c::check-lambda-names (c::lambda (form) (c::map-without-type-checking (c::lambda (name) (c::check-name-for-lambda-formal name form)) (c::get-lambda-variables-list form)) #t))

(c::define c::expand-macro-calls-till-done (c::lambda (form quotation-level) (c::if (null? (car form)) quotation-level (c::if (c::if (list? (car form)) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (equal? (caar form) quote))) (equal? (caar form) (quote quote))) #f) (+ quotation-level 1) (c::if (c::if (= quotation-level 0) (c::if (list? (car form)) (equal? (caar form) (quote c::lambda)) #f) #f) (c::begin (c::check-lambda-names (car form)) quotation-level) (c::if (c::if (= quotation-level 0) (e::macro-call? (car form)) #f) ((c::lambda (lambda-var-1) (c::if (memv lambda-var-1 (quote (quasiquote))) (c::begin (set-car! form (e::expand-macro (car form))) 0) (c::begin (set-car! form (e::expand-macro (car form))) (c::expand-macro-calls-till-done form 0)))) (caar form)) quotation-level))))))

(c::define c::find-macro-expansion-and-expand (c::lambda (form quotation-level) (c::if (not ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (vector? form))) (pair? form))) (c::begin (display form (e::error-port)) (e::error "c::find-macro-expansion-and-expand called with the form shown, which is not a pair.")) #f) (c::if (null? form) #t (c::if (pair? form) ((c::lambda (lambda-var-2) (c::if ((c::lambda (lambda-var-1) (c::if lambda-var-1 lambda-var-1 (vector? (car form)))) (pair? (car form))) (c::begin (c::find-macro-expansion-and-expand (car form) lambda-var-2)) #f) (c::if ((c::lambda (lambda-var-3) (c::if lambda-var-3 lambda-var-3 (vector? (cdr form)))) (pair? (cdr form))) (c::begin (c::find-macro-expansion-and-expand (cdr form) quotation-level)) #f)) (c::expand-macro-calls-till-done form quotation-level)) (c::if (vector? form) (c::find-macro-expansion-and-expand (c::set-tag! form c::pair_tag) quotation-level) #t)))))

(c::define e::expand-macros-recursively (c::lambda (form) ((c::lambda (lambda-var-0) (c::find-macro-expansion-and-expand lambda-var-0 0) (car lambda-var-0)) (cons form (quote ())))))

(c::define c::collect-initial-defines (c::lambda (form) (c::if (null? form) (quote ()) (c::if (c::if (pair? form) (c::if (list? (car form)) (equal? (caar form) (quote define)) #f) #f) (cons (car form) (c::collect-initial-defines (cdr form))) (quote ())))))

(c::define c::find-where-body-starts (c::lambda (form) (c::if (c::if (pair? form) (c::if (list? (car form)) (equal? (caar form) (quote define)) #f) #f) (c::find-where-body-starts (cdr form)) form)))

(c::define c::show-internal-define-and-form-error (c::lambda (internal-deine form msg) (display "\nInternal define: " (e::error-port)) (display internal-define (e::error-port)) (display "\nIn form: " (e::error-port)) (display form (e::error-port)) (e::error msg)))

(c::define c::convert-define-to-letrec-list-item (c::lambda (internal-define form) (c::if ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 ((c::lambda (lambda-var-1) (c::if lambda-var-1 lambda-var-1 (not (equal? (car internal-define) (quote define))))) (< (length internal-define) 3)))) (not (list? internal-define))) (c::show-internal-define-and-form-error internal-define form "Badly-formed internal define in the form given.") #f) (c::if (pair? (cadr internal-define)) ((c::lambda (lambda-var-2 lambda-var-3) (c::if (not (symbol? lambda-var-2)) (c::show-internal-define-and-form-error internal-define form "Second item of internal define does not name a symbol.") (c::make-immutable! (cons lambda-var-2 (cons (cons (quote c::lambda) (cons lambda-var-3 (append (cddr internal-define) (quote ())))) (quote ())))))) (caadr internal-define) (cdadr internal-define)) (c::if (not (symbol? (cadr internal-define))) (c::show-internal-define-and-form-error internal-define form "Second item of internal define is not a symbol.") (cdr internal-define)))))

(c::define c::letrecify-defines (c::lambda (form) (c::if (c::if (pair? form) (c::if (list? (car form)) (equal? (caar form) (quote define)) #f) #f) ((c::lambda (lambda-var-3) ((c::lambda (lambda-var-0) ((c::lambda (lambda-var-2) ((c::lambda () (c::if (not (null? lambda-var-2)) (c::begin (c::if (null? lambda-var-0) (c::set! lambda-var-0 (list #t)) #f) ((c::lambda (lambda-var-1) (set-cdr! (cdr lambda-var-1) lambda-var-0) (list lambda-var-1)) (list (quote letrec) lambda-var-2))) form)))) (c::map-without-type-checking (c::lambda (internal-define) (c::convert-define-to-letrec-list-item internal-define form)) lambda-var-3))) (c::find-where-body-starts form))) (c::collect-initial-defines form)) form)))

