;;  Copyright (c) 2009 by Jay Reynolds Freeman

;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;
;;    Contact information:
;;
;;        EMail:       Jay_Reynolds_Freeman@mac.com
;;        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman
;;
;;        Paper Mail:  Jay Reynolds Freeman
;;                     Post Office Box 60628
;;                     Palo Alto, CA, 94306-0628

(define (test-in-base string base)
  (let* ((number (string->number string))
         (printed (number->string number base))
         (read-back (string->number printed base)))
    (if (not (eqv? number read-back))
        (begin
          (write string)
          (if (exact? number) (display " (exact) ") (display " (inexact) "))
          (display " -- failed base ")
          (display base)
          (display " (printed as ")
          (write printed)
          (display ", read back as ")
          (display read-back)
          (if (exact? number) (display " (exact) ") (display " (inexact) "))
          (display ")")
          (newline)))
    #t))

(e::set-permanent! 'test-in-base)

(define (process-number-in-just-base-ten str)
    (test-in-base str 10))

(e::set-permanent! 'process-number-in-just-base-ten)

(define (process-number str)
    (test-in-base str 2)
    (test-in-base str 8)
    (test-in-base str 10)
    (test-in-base str 16)
    )

(e::set-permanent! 'process-number)

