//
//  BadgedIconView.h
//
//  Put simple badges on program icons.  Copyright (c) 2009 by Jay Reynolds Freeman
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <Cocoa/Cocoa.h>

//  The intent here is to create a static badged icon, so I arrange to
//  supply the information about it, and do all the setup for drawing
//  that I can, in an initialization method.  The instance variables are
//  to provide information for drawRect (which is overridden), and also
//  were used to store information for test and debugging methods (which
//  are now removed).

//  I have in mind a particular image to use for the basic appearance
//  of the badged icon; hence many items about the size and position
//  of things to draw are hard-coded herein.

@interface BadgedIconView : NSView {

    NSImage      *theImage;     //  The image to badge.
    NSString     *theString;    //  The text to badge it with (a number of up to three digits is intended).
    NSText       *badgeNSText;  //  Where the string gets put.
    NSRect        badgeFrame;   //  Location of the text frame -- hence the badge -- within the image frame.
    }

- (id) initWithImage:(NSImage *)anImage andString:(NSString *)aString;

@end
