//
//  DrawerController.h
//  WraithCocoa
//
//  Created by Jay Freeman on 12/16/06.
//  Copyright 2006 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <Cocoa/Cocoa.h>


@interface DrawerController : NSObject {
    IBOutlet NSDrawer *basicButtonsDrawer;
    IBOutlet NSDrawer *instrumentPanelDrawer;
    IBOutlet NSDrawer *sockDrawer;
    IBOutlet NSMenuItem *bBMenuItem;
    IBOutlet NSMenuItem *iPMenuItem;
    IBOutlet NSMenuItem *sDMenuItem;
    }

- (void) applicationDidFinishLaunchingContent;

- (void)presentBasicButtonsDrawer;
- (void)concealBasicButtonsDrawer;
- (void)toggleBasicButtonsDrawerNoSender;
- (IBAction)toggleBasicButtonsDrawer:(id)sender;

- (void)presentInstrumentPanelDrawer;
- (void)concealInstrumentPanelDrawer;
- (void)toggleInstrumentPanelDrawerNoSender;
- (IBAction)toggleInstrumentPanelDrawer:(id)sender;

- (void)presentSockDrawer;
- (void)concealSockDrawer;
- (void)toggleSockDrawerNoSender;
- (IBAction)toggleSockDrawer:(id)sender;


@end
