//
//  DrawerController.m
//  WraithCocoa
//
//  Created by Jay Freeman on 12/16/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import "DrawerController.h"

@implementation DrawerController

- (void) applicationDidFinishLaunchingContent {

    NSSize theInstrumentPanelMaxSize;
    theInstrumentPanelMaxSize.height = 279.0F;
    theInstrumentPanelMaxSize.width  = 100.0F;   // DUMMY

    NSSize theInstrumentPanelSize;
    theInstrumentPanelSize.height = 168.0F;
    theInstrumentPanelSize.width  = 100.0F;   // DUMMY

    [instrumentPanelDrawer setMaxContentSize:theInstrumentPanelMaxSize];
    [instrumentPanelDrawer setContentSize:theInstrumentPanelSize];
    }

// basicButtonsDrawer

- (void)presentBasicButtonsDrawer {
    [basicButtonsDrawer openOnEdge:NSMinXEdge];
    [bBMenuItem setState:NSOnState];
    }
    
- (void)concealBasicButtonsDrawer {
    [basicButtonsDrawer close];
    [bBMenuItem setState:NSOffState];
    }

- (void)toggleBasicButtonsDrawerNoSender {
    NSDrawerState state = [basicButtonsDrawer state];
    if( (state == NSDrawerOpeningState) || (state == NSDrawerOpenState) ) {
        [basicButtonsDrawer close];
        [bBMenuItem setState:NSOffState];
        }
    else {
        [basicButtonsDrawer openOnEdge:NSMinXEdge];
        [bBMenuItem setState:NSOnState];
        }
    }

- (IBAction)toggleBasicButtonsDrawer:(id)sender { [self toggleBasicButtonsDrawerNoSender]; }

// InstrumentPanelDrawer

- (void)presentInstrumentPanelDrawer {
    [instrumentPanelDrawer openOnEdge:NSMinYEdge];
    [iPMenuItem setState:NSOnState];
    }
    
- (void)concealInstrumentPanelDrawer {
    [instrumentPanelDrawer close];
    [iPMenuItem setState:NSOffState];
    }
    
- (void)toggleInstrumentPanelDrawerNoSender {
    NSDrawerState state = [instrumentPanelDrawer state];
    if( (state == NSDrawerOpeningState) || (state == NSDrawerOpenState) ) {
        [instrumentPanelDrawer close];
        [iPMenuItem setState:NSOffState];
        }
	else {
        [instrumentPanelDrawer openOnEdge:NSMinYEdge];
        [iPMenuItem setState:NSOnState];
        }
    }

- (IBAction)toggleInstrumentPanelDrawer:(id)sender { [self toggleInstrumentPanelDrawerNoSender]; }

// SockDrawer

- (void)presentSockDrawer {
    [sockDrawer openOnEdge:NSMaxXEdge];
    [sDMenuItem setState:NSOnState];
    }
    
- (void)concealSockDrawer {
    [sockDrawer close];
    [sDMenuItem setState:NSOffState];
    }
    
- (void)toggleSockDrawerNoSender {
    NSDrawerState state = [sockDrawer state];
    if( (state == NSDrawerOpeningState) || (state == NSDrawerOpenState) ) {
        [sockDrawer close];
        [sDMenuItem setState:NSOffState];
        }
	else {
        [sockDrawer openOnEdge:NSMaxXEdge];
        [sDMenuItem setState:NSOnState];
        }
    }

- (IBAction)toggleSockDrawer:(id)sender { [self toggleSockDrawerNoSender]; }

@end
