//
//  JRFNSTextView.m
//  WraithCocoa
//
//  Created by Jay Freeman on 12/21/06.
//  Copyright 2006 Jay Reynolds Freeman. All rights reserved.
//

//  Like an ordinary text view, except that resizing
//  keeps the bottom in view, if possible.
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import "JRFNSTextView.h"
#import "MainWindowController.h"
#import "WraithSchemeOuterController.h"
#import "ASCIITypes.h"

@implementation JRFNSTextView

- (void) viewDidEndLiveResize {
    [super viewDidEndLiveResize];
    [self scrollToBottom];
    }

- (void) scrollToBottom {

    NSClipView *theClipView = nil;
    NSRange endRange;
    NSPoint newPoint;
    NSRect clipViewBounds;
    NSRect mainBounds;
    NSUInteger lnth = [[self string] length];

    endRange.location = lnth;
    if( endRange.location < 0 )
        endRange.location = 0;
    endRange.length = 0;

    [self scrollRangeToVisible:endRange];   // Doesn't work if last two characters are both 0x0a; erratic.  Fix-up follows:

    mainBounds = [self bounds];
    theClipView = (NSClipView *)[self superview];
    clipViewBounds = [theClipView bounds];

    newPoint.x = 0;
    if( (lnth > 0) && ([[self string] characterAtIndex:(lnth - 1)] == NEWLINE ) )
        newPoint.y = mainBounds.size.height - clipViewBounds.size.height - [theWindowController currentLineHeight];
    else
        newPoint.y = mainBounds.size.height - clipViewBounds.size.height;

    if( newPoint.y < 0 )
        newPoint.y = 0;

    [theClipView scrollToPoint:newPoint];
    }

/*
- (void) keyDown:(NSEvent *)theEvent {

    // Unfinished method, perhaps to pass marked text to input on receipt of a special command shortcut key.

    NSString *theCharacters = [theEvent characters];
    NSInteger c;
    NSRange selectionRange;
    NSArray *selRanges = [self selectedRanges];
    
    c = [theCharacters characterAtIndex:0];

    if( [selRanges count] != 0 ) {
        selectionRange = [[selRanges objectAtIndex:0] rangeValue];
        if( selectionRange.length > 0 ) {
            // NSBeep
            ;
            }
        }
    [super keyDown:theEvent];
    }
*/

- (BOOL) isOpaque { return YES; }

@end
