//
//  Preferences.h
//  WraithCocoa
//
//  Created by Jay Freeman on 12/19/06.
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/
//
//  This file contains code derived from the source code
//    for the Apple "TextEditor" application, as provided to
//    developers.  The following copyright notice is intended
//    only to protect such rights to the derivative work as
//    I may possess; I make no claim to material copyrighted
//    by Apple.
//
//  Copyright 2006 Jay Reynolds Freeman. All rights reserved.
//

#ifndef PREFERENCES_H
#define PREFERENCES_H

#import <Cocoa/Cocoa.h>

/* Keys in the dictionary... */   

#define CompileDefines @"CompileDefines"
#define DisplayFullPrecision @"DisplayFullPrecision"
#define LoadLastFile @"LoadLastFile"
#define NostalgiaMode @"NostalgiaMode"
#define ShowBasicButtons @"ShowBasicButtons"
#define ShowInstrumentPanel @"ShowInstrumentPanel"
#define MainMemorySize @"MainMemorySize"
#define GenerationSize @"GenerationSize"
#define PathToInitialLoad @"PathToInitialLoad"
#define ConfigurationA @"ConfigurationA"

#define recentFile0  @"recentFile0"
#define recentFile1  @"recentFile1"
#define recentFile2  @"recentFile2"
#define recentFile3  @"recentFile3"
#define recentFile4  @"recentFile4"
#define recentFile5  @"recentFile5"
#define recentFile6  @"recentFile6"
#define recentFile7  @"recentFile7"
#define recentFile8  @"recentFile8"
#define recentFile9  @"recentFile9"
#define recentFile10 @"recentFile10"
#define recentFile11 @"recentFile11"
#define recentFile12 @"recentFile12"
#define recentFile13 @"recentFile13"
#define recentFile14 @"recentFile14"
#define recentFile15 @"recentFile15"
#define recentFile16 @"recentFile16"
#define recentFile17 @"recentFile17"
#define recentFile18 @"recentFile18"
#define recentFile19 @"recentFile19"
#define recentFile20 @"recentFile20"
#define recentFile21 @"recentFile21"
#define recentFile22 @"recentFile22"
#define recentFile23 @"recentFile23"
#define recentFile24 @"recentFile24"
#define recentFile25 @"recentFile25"
#define recentFile26 @"recentFile26"
#define recentFile27 @"recentFile27"
#define recentFile28 @"recentFile28"
#define recentFile29 @"recentFile29"
#define recentFile30 @"recentFile30"
#define recentFile31 @"recentFile31"
#define recentFile32 @"recentFile32"
#define recentFile33 @"recentFile33"
#define recentFile34 @"recentFile34"
#define recentFile35 @"recentFile35"
#define recentFile36 @"recentFile36"
#define recentFile37 @"recentFile37"
#define recentFile38 @"recentFile38"
#define recentFile39 @"recentFile39"

#define PreferredBackgroundColorAsInteger @"PreferredBackgroundColorAsInteger"
#define PreferredTextColorAsInteger @"PreferredTextColorAsInteger"
#define NumberOfKittens @"NumberOfKittens"
#define UseGenerationalGC @"UseGenerationalGC"

#define minMainMemoryMB 10
#define maxMainMemoryMB 65536

#define minGenerationMB 1
#define maxGenerationMB 100

#define minNumberOfKittens 0
#define maxNumberOfKittens 15

@class WraithSchemeOuterController;

@interface Preferences : NSObject {
    IBOutlet id memorySizeNumberField;
    IBOutlet id generationSizeNumberField;
    IBOutlet id loadSourceFilePathField;
    IBOutlet id CFButton;
    IBOutlet id CDButton;
    IBOutlet id DPButton;
    IBOutlet id NMButton;
    IBOutlet id RLButton;
    IBOutlet id SBButton;
    IBOutlet id SIButton;
    IBOutlet id numberOfKittensField;
    IBOutlet id UGGCButton;
    IBOutlet id WSController;
    
    IBOutlet NSColorWell *backgroundCWell;
    IBOutlet NSColorWell *textCWell;

    IBOutlet id restoreDefaultsButton;
    IBOutlet id panel;
    
    IBOutlet NSWindow *MyParentWindow;

    NSDictionary *defaultValues;
    NSMutableDictionary *displayedValues;	// Values displayed in the UI
    NSColor *defaultBackgroundColor;
    NSColor *preferredBackgroundColor;
    NSColor *defaultTextColor;
    NSColor *preferredTextColor;
    NSColorPanel *SharedColorPanel;

    bool okayToClose;
    }

- (void)saveDefaults;		/* Save the current preferences */

- (id)objectForKey:(id)key;     /* Convenience for getting a value */

- (void)showPanel:(id)sender;	/* Shows the panel */

- (void)updateUI;		/* Updates the displayed values in the UI */

- (void)ok:(id)sender;		/* Calls commitUI to commit the displayed values as current */
- (void)revertToDefault:(id)sender;    

- (void)miscChanged:(id)sender;		/* Action message for most of the misc items in the UI to get displayedValues */

- (NSMutableDictionary *)preferencesFromDefaults;
- (void)savePreferencesToDefaults:(NSDictionary *)dict;

- (bool)treatPreference;
- (void)setTreatPreference:(bool)value;
- (NSColor *)preferredBackgroundColor;
- (NSColor *)preferredTextColor;
- (void)setPreferredBackgroundColor:(NSColor *)aColor;
- (void)setPreferredTextColor:(NSColor *)aColor;

- (void)addLoadRecentPreference:(NSString *)path;
- (IBAction)clearRecentFiles:(id)sender;
- (NSMutableArray *)loadRecentPreferences;

- (void) localError:(NSString *)message;
- (IBAction) getPathForPreferences:(id)sender;

@property (nonatomic, retain) IBOutlet NSColorWell *backgroundCWell;
@property (nonatomic, retain) IBOutlet NSColorWell *textCWell;

@end

#endif
