//
//  Preferences.m
//  WraithCocoa
//
//  Created by Jay Freeman on 12/19/06.
//
//  This file contains code derived from the source code
//    for the Apple "TextEditor" application, as provided to
//    developers.  The following copyright notice is intended
//    only to protect such rights to the derivative work as
//    I may possess; I make no claim to material copyrighted
//    by Apple.
//
//  Copyright 2006 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

// This stuff is way too messy; I copied it from a sample
// application that I didn't understand, but that had more
// "Preferences" capability than I actually needed.  I have
// tried to simplfy things herein a bit, but they are still
// way too messy.

#import <Cocoa/Cocoa.h>
#import "Preferences.h"
#import "LocalTypes.h"

extern UnsignedWord theKittenNumber;     // In MainAux.c++

#define getStringDefault(name) \
  {id obj = [defaults stringForKey:name]; \
      [dict setObject:obj ? obj : [defaultValues objectForKey:name] forKey:name];}

#define getBoolDefault(name) \
  {id obj = [defaults objectForKey:name]; \
      [dict setObject:obj ? [NSNumber numberWithBool:[defaults boolForKey:name]] : [defaultValues objectForKey:name] forKey:name];}

#define getLongDefault(name) \
  {id obj = [defaults objectForKey:name]; \
      [dict setObject:obj ? [NSNumber numberWithLong:[defaults integerForKey:name]] : [defaultValues objectForKey:name] forKey:name];}

#define getUnsignedLongDefault(name) \
  {id obj = [defaults objectForKey:name]; \
      [dict setObject:obj ? [NSNumber numberWithUnsignedLong:[defaults integerForKey:name]] : [defaultValues objectForKey:name] forKey:name];}

@implementation Preferences

@synthesize backgroundCWell;
@synthesize textCWell;

- (void)awakeFromNib {

    defaultValues = [[NSDictionary alloc] initWithObjectsAndKeys:

                      [NSNumber numberWithBool:YES], CompileDefines, 
                      [NSNumber numberWithBool:NO],  DisplayFullPrecision, 
                      [NSNumber numberWithBool:NO],  LoadLastFile, 
                      [NSNumber numberWithBool:NO],  NostalgiaMode, 
                      [NSNumber numberWithBool:YES], ShowBasicButtons,
                      [NSNumber numberWithBool:YES], ShowInstrumentPanel,

                      [NSNumber numberWithInt:10],   MainMemorySize, 
                      [NSNumber numberWithInt:1],    GenerationSize, 
                      [NSNumber numberWithInt:0],    NumberOfKittens, 

                      @"Wraith Scheme.app/Contents/Resources/Demo.txt", PathToInitialLoad,

                      @"", recentFile0,
                      @"", recentFile1,
                      @"", recentFile2,
                      @"", recentFile3,
                      @"", recentFile4,
                      @"", recentFile5,
                      @"", recentFile6,
                      @"", recentFile7,
                      @"", recentFile8,
                      @"", recentFile9,
                      @"", recentFile10,
                      @"", recentFile11,
                      @"", recentFile12,
                      @"", recentFile13,
                      @"", recentFile14,
                      @"", recentFile15,
                      @"", recentFile16,
                      @"", recentFile17,
                      @"", recentFile18,
                      @"", recentFile19,
                      @"", recentFile20,
                      @"", recentFile21,
                      @"", recentFile22,
                      @"", recentFile23,
                      @"", recentFile24,
                      @"", recentFile25,
                      @"", recentFile26,
                      @"", recentFile27,
                      @"", recentFile28,
                      @"", recentFile29,
                      @"", recentFile30,
                      @"", recentFile31,
                      @"", recentFile32,
                      @"", recentFile33,
                      @"", recentFile34,
                      @"", recentFile35,
                      @"", recentFile36,
                      @"", recentFile37,
                      @"", recentFile38,
                      @"", recentFile39,

                      [NSNumber numberWithBool:NO], ConfigurationA,

                      [NSNumber numberWithUnsignedInt:0xffffac], PreferredBackgroundColorAsInteger,
                      [NSNumber numberWithUnsignedInt:0x000000], PreferredTextColorAsInteger,

                      [NSNumber numberWithBool:YES], UseGenerationalGC,

	              nil];

    defaultBackgroundColor = [NSColor colorWithCalibratedRed:1.00  green:1.00  blue:0.67450980392  alpha:1.00];
    [defaultBackgroundColor retain];
    preferredBackgroundColor = [NSColor colorWithCalibratedRed:1.00  green:1.00  blue:0.67450980392  alpha:1.00];
    [preferredBackgroundColor retain];

    defaultTextColor = [NSColor colorWithCalibratedRed:0.00  green:0.00  blue:0.00  alpha:1.00];
    [defaultTextColor retain];
    preferredTextColor = [NSColor colorWithCalibratedRed:0.00  green:0.00  blue:0.00  alpha:1.00];
    [preferredTextColor retain];

    displayedValues = [[self preferencesFromDefaults] retain];
    okayToClose = YES;
    [self updateUI];
    }

- (id)objectForKey:(id)key { return [displayedValues objectForKey:key]; }

- (void)saveDefaults { [self savePreferencesToDefaults:displayedValues]; }

- (void)showPanel:(id)sender {
    if( ! panel ) {
        if( ! [NSBundle loadNibNamed:@"Preferences" owner:self] )  {
            NSLog(@"Failed to load Preferences.nib");
            NSBeep();
            return;
            }
        [panel setHidesOnDeactivate:NO];
        [panel setExcludedFromWindowsMenu:YES];
        [panel setMenu:nil];
        [self updateUI];
        [panel center];
        }
    SharedColorPanel = [NSColorPanel sharedColorPanel];
    [SharedColorPanel setShowsAlpha:FALSE];

    if( theKittenNumber != 0 ) {
        [backgroundCWell setEnabled:NO];
        [textCWell setEnabled:NO];
        }

    [panel makeKeyAndOrderFront:nil];
    }

- (void)updateUI {

    if( ! memorySizeNumberField )     // UI hasn't been loaded...
        return;

    [ memorySizeNumberField      setIntValue:[[displayedValues objectForKey:     MainMemorySize       ] intValue]];
    [ generationSizeNumberField  setIntValue:[[displayedValues objectForKey:     GenerationSize       ] intValue]];
    [ numberOfKittensField       setIntValue:[[displayedValues objectForKey:     NumberOfKittens      ] intValue]];
    [ loadSourceFilePathField    setStringValue:[displayedValues objectForKey:   PathToInitialLoad    ]];

    [ CDButton   setState:[[displayedValues objectForKey:   CompileDefines         ] boolValue] ? 1 : 0];
    [ DPButton   setState:[[displayedValues objectForKey:   DisplayFullPrecision   ] boolValue] ? 1 : 0];
    [ NMButton   setState:[[displayedValues objectForKey:   NostalgiaMode          ] boolValue] ? 1 : 0];
    [ RLButton   setState:[[displayedValues objectForKey:   LoadLastFile           ] boolValue] ? 1 : 0];
    [ SBButton   setState:[[displayedValues objectForKey:   ShowBasicButtons       ] boolValue] ? 1 : 0];
    [ SIButton   setState:[[displayedValues objectForKey:   ShowInstrumentPanel    ] boolValue] ? 1 : 0];

    [backgroundCWell  setColor:preferredBackgroundColor];
    [textCWell  setColor:preferredTextColor];

    [UGGCButton setState:[[displayedValues objectForKey:    UseGenerationalGC      ] boolValue] ? 1 : 0];
    [generationSizeNumberField setEnabled:[UGGCButton state]];
    }

/* Gets everything from UI */

- (void)miscChanged:(id)sender {

    static NSNumber *yes = nil;
    static NSNumber *no = nil;
    NSColor *dummyColor;
    
    SInt32 anInt       = 0;
    SInt32 redPart     = 0;
    SInt32 greenPart   = 0;
    SInt32 bluePart    = 0;
    SInt32 pBCAI       = 0;
    SInt32 pTCAI       = 0;

    okayToClose = YES;

    dummyColor = [backgroundCWell color];
    if( dummyColor != nil ) {
        if( preferredBackgroundColor != nil )
            [preferredBackgroundColor release];
        preferredBackgroundColor = [dummyColor retain];
        }
    redPart   = (SInt32)lround( [preferredBackgroundColor redComponent  ] * 255.);
    greenPart = (SInt32)lround( [preferredBackgroundColor greenComponent] * 255.);
    bluePart  = (SInt32)lround( [preferredBackgroundColor blueComponent ] * 255.);
    pBCAI = (redPart << 16) | (greenPart << 8) | bluePart;

    dummyColor = [textCWell color];
    if( dummyColor != nil ) {
        if( preferredTextColor != nil )
            [preferredTextColor release];
        preferredTextColor = [dummyColor retain];
        }
    redPart   = (SInt32)lround( [preferredTextColor redComponent  ] * 255.);
    greenPart = (SInt32)lround( [preferredTextColor greenComponent] * 255.);
    bluePart  = (SInt32)lround( [preferredTextColor blueComponent ] * 255.);
    pTCAI = (redPart << 16) | (greenPart << 8) | bluePart;

    if( ! yes ) {
        yes = [[NSNumber alloc] initWithBool:YES];
        no  = [[NSNumber alloc] initWithBool:NO];
        }

    if( ((anInt = [memorySizeNumberField intValue]) < minMainMemoryMB) || (anInt > maxMainMemoryMB) ) {
        // User's value is out of range -- set to the next highest end-of-range.
        if( anInt < minMainMemoryMB )
            [displayedValues setObject:[NSNumber numberWithInt:minMainMemoryMB] forKey: MainMemorySize];
        else
            [displayedValues setObject:[NSNumber numberWithInt:maxMainMemoryMB] forKey: MainMemorySize];
         }
    else   // User's value is okay.
        [displayedValues setObject:[NSNumber numberWithInt:anInt] forKey:MainMemorySize];

    if( ((anInt = [generationSizeNumberField intValue]) < minGenerationMB) || (anInt > maxGenerationMB) ) {
        // User's value is out of range -- set to the next highest end-of-range.
        if( anInt < minGenerationMB )
            [displayedValues setObject:[NSNumber numberWithInt:minGenerationMB] forKey: GenerationSize];
        else
            [displayedValues setObject:[NSNumber numberWithInt:maxGenerationMB] forKey: GenerationSize];
         }
    else   // User's value is okay.
        [displayedValues setObject:[NSNumber numberWithInt:anInt] forKey:GenerationSize];

    if( ((anInt = [numberOfKittensField intValue]) < minNumberOfKittens) || (anInt > maxNumberOfKittens) ) {
        // User's value is out of range -- set to the nearest end-of-range.
        if( anInt < minNumberOfKittens )
            [displayedValues setObject:[NSNumber numberWithInt:minNumberOfKittens] forKey: NumberOfKittens];
        else
            [displayedValues setObject:[NSNumber numberWithInt:maxNumberOfKittens] forKey: NumberOfKittens];
         }
    else   // User's value is okay.
        [displayedValues setObject:[NSNumber numberWithInt:anInt] forKey:NumberOfKittens];

    // Make sure to display what we think the user typed.

    [memorySizeNumberField      setIntValue:[[displayedValues objectForKey: MainMemorySize] intValue]];
    [generationSizeNumberField  setIntValue:[[displayedValues objectForKey: GenerationSize] intValue]];
    [numberOfKittensField       setIntValue:[[displayedValues objectForKey: NumberOfKittens] intValue]];

    if( ! [[loadSourceFilePathField stringValue] canBeConvertedToEncoding:NSASCIIStringEncoding] ) {
        okayToClose = NO;
        [loadSourceFilePathField setStringValue:@""];
        [self localError:
           @"\nThe path (including the file name) to the file to load when Wraith Scheme starts included some non-ASCII characters.\n\nScheme is supposed to use only ASCII characters.  They are pretty much the \"regular\" keyboard characters, entered without the \"command-\" and \"option-\" modifier keys.\n\nPlease provide a file and pathname that contain only ASCII characters."];
        }

    [displayedValues setObject:[   loadSourceFilePathField    stringValue] forKey:   PathToInitialLoad   ];

    [displayedValues setObject:[   CDButton   state] ? yes : no forKey:   CompileDefines         ];
    [displayedValues setObject:[   DPButton   state] ? yes : no forKey:   DisplayFullPrecision   ];
    [displayedValues setObject:[   NMButton   state] ? yes : no forKey:   NostalgiaMode          ];
    [displayedValues setObject:[   RLButton   state] ? yes : no forKey:   LoadLastFile           ];
    [displayedValues setObject:[   SBButton   state] ? yes : no forKey:   ShowBasicButtons       ];
    [displayedValues setObject:[   SIButton   state] ? yes : no forKey:   ShowInstrumentPanel    ];
    
    [displayedValues setObject:[NSNumber numberWithInt:pBCAI] forKey:PreferredBackgroundColorAsInteger];
    [displayedValues setObject:[NSNumber numberWithInt:pTCAI] forKey:PreferredTextColorAsInteger];

    [displayedValues setObject:[ UGGCButton   state] ? yes : no forKey:   UseGenerationalGC      ];

    [generationSizeNumberField setEnabled:[UGGCButton state]];

    }

/**** Commit/revert etc ****/

- (void)ok:(id)sender
{
   [self miscChanged:sender];
   [SharedColorPanel orderOut:nil];
   if( okayToClose ) {
       [self saveDefaults];
       [panel close];
       }
   }

- (void)revertToDefault:(id)sender {

    NSInteger DBCAI = 0;
    NSInteger DTCAI = 0;

    [displayedValues setObject:[defaultValues objectForKey:MainMemorySize] forKey:MainMemorySize];
    [displayedValues setObject:[defaultValues objectForKey:GenerationSize] forKey:GenerationSize];
    [displayedValues setObject:[defaultValues objectForKey:PathToInitialLoad] forKey:PathToInitialLoad];
    [displayedValues setObject:[defaultValues objectForKey:CompileDefines] forKey:CompileDefines];
    [displayedValues setObject:[defaultValues objectForKey:DisplayFullPrecision] forKey:DisplayFullPrecision];
    [displayedValues setObject:[defaultValues objectForKey:LoadLastFile] forKey:LoadLastFile];
    [displayedValues setObject:[defaultValues objectForKey:NostalgiaMode] forKey:NostalgiaMode];
    [displayedValues setObject:[defaultValues objectForKey:ShowBasicButtons] forKey:ShowBasicButtons];
    [displayedValues setObject:[defaultValues objectForKey:ShowInstrumentPanel] forKey:ShowInstrumentPanel];
    [displayedValues setObject:[defaultValues objectForKey:PreferredBackgroundColorAsInteger] forKey:PreferredBackgroundColorAsInteger];
    [displayedValues setObject:[defaultValues objectForKey:PreferredTextColorAsInteger] forKey:PreferredTextColorAsInteger];
    [displayedValues setObject:[defaultValues objectForKey:NumberOfKittens] forKey:NumberOfKittens];

    DBCAI = [[displayedValues objectForKey:PreferredBackgroundColorAsInteger] intValue];

    [displayedValues setObject:[defaultValues objectForKey:UseGenerationalGC] forKey:UseGenerationalGC];

    if( preferredBackgroundColor )
        [preferredBackgroundColor release];

    preferredBackgroundColor =
      [NSColor colorWithCalibratedRed: ((CGFloat)((DBCAI >> 16) & 0xFF)) / 255.
                                green: ((CGFloat)((DBCAI >>  8) & 0xFF)) / 255.
                                 blue: ((CGFloat)((DBCAI >>  0) & 0xFF)) / 255.
                                alpha: 1.00];

    [preferredBackgroundColor retain];

    DTCAI = [[displayedValues objectForKey:PreferredTextColorAsInteger] intValue];

    if( preferredTextColor )
        [preferredTextColor release];

    preferredTextColor =
      [NSColor colorWithCalibratedRed: ((CGFloat)((DTCAI >> 16) & 0xFF)) / 255.
                                green: ((CGFloat)((DTCAI >>  8) & 0xFF)) / 255.
                                 blue: ((CGFloat)((DTCAI >>  0) & 0xFF)) / 255.
                                alpha: 1.00];

    [preferredTextColor retain];

    [self updateUI];
    }

- (NSMutableDictionary *)preferencesFromDefaults {

    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    NSMutableDictionary *dict = [NSMutableDictionary dictionaryWithCapacity:24];
    SInt32 DBCAI = 0;
    SInt32 DTCAI = 0;

    getLongDefault(   MainMemorySize   ); 
    getLongDefault(   GenerationSize   ); 
    getLongDefault(   NumberOfKittens  );

    getStringDefault(   PathToInitialLoad   );

    getBoolDefault(   CompileDefines         );
    getBoolDefault(   DisplayFullPrecision   );
    getBoolDefault(   LoadLastFile           );
    getBoolDefault(   NostalgiaMode          );
    getBoolDefault(   ShowBasicButtons       );
    getBoolDefault(   ShowInstrumentPanel    );
    getBoolDefault(   UseGenerationalGC      );
    getBoolDefault(   ConfigurationA         );
    
    getStringDefault(  recentFile0 );
    getStringDefault(  recentFile1 );
    getStringDefault(  recentFile2 );
    getStringDefault(  recentFile3 );
    getStringDefault(  recentFile4 );
    getStringDefault(  recentFile5 );
    getStringDefault(  recentFile6 );
    getStringDefault(  recentFile7 );
    getStringDefault(  recentFile8 );
    getStringDefault(  recentFile9 );
    getStringDefault(  recentFile10 );
    getStringDefault(  recentFile11 );
    getStringDefault(  recentFile12 );
    getStringDefault(  recentFile13 );
    getStringDefault(  recentFile14 );
    getStringDefault(  recentFile15 );
    getStringDefault(  recentFile16 );
    getStringDefault(  recentFile17 );
    getStringDefault(  recentFile18 );
    getStringDefault(  recentFile19 );
    getStringDefault(  recentFile20 );
    getStringDefault(  recentFile21 );
    getStringDefault(  recentFile22 );
    getStringDefault(  recentFile23 );
    getStringDefault(  recentFile24 );
    getStringDefault(  recentFile25 );
    getStringDefault(  recentFile26 );
    getStringDefault(  recentFile27 );
    getStringDefault(  recentFile28 );
    getStringDefault(  recentFile29 );
    getStringDefault(  recentFile30 );
    getStringDefault(  recentFile31 );
    getStringDefault(  recentFile32 );
    getStringDefault(  recentFile33 );
    getStringDefault(  recentFile34 );
    getStringDefault(  recentFile35 );
    getStringDefault(  recentFile36 );
    getStringDefault(  recentFile37 );
    getStringDefault(  recentFile38 );
    getStringDefault(  recentFile39 );

    getLongDefault( PreferredBackgroundColorAsInteger );
    DBCAI = [[dict objectForKey:PreferredBackgroundColorAsInteger] intValue];

    if( preferredBackgroundColor )
        [preferredBackgroundColor release];

    preferredBackgroundColor =
      [NSColor colorWithCalibratedRed: ((CGFloat)((DBCAI >> 16) & 0xFF)) / 255.
                                green: ((CGFloat)((DBCAI >>  8) & 0xFF)) / 255.
                                 blue: ((CGFloat)((DBCAI >>  0) & 0xFF)) / 255.
                                alpha: 1.00];

    [preferredBackgroundColor retain];

    getLongDefault( PreferredTextColorAsInteger );
    DTCAI = [[dict objectForKey:PreferredTextColorAsInteger] intValue];

    if( preferredTextColor )
        [preferredTextColor release];

    preferredTextColor =
      [NSColor colorWithCalibratedRed: ((CGFloat)((DTCAI >> 16) & 0xFF)) / 255.
                                green: ((CGFloat)((DTCAI >>  8) & 0xFF)) / 255.
                                 blue: ((CGFloat)((DTCAI >>  0) & 0xFF)) / 255.
                                alpha: 1.00];

    [preferredTextColor retain];

    return dict;
    }

#define setStringDefault(name) { [defaults setObject:[dict objectForKey:name] forKey:name]; }

#define setBoolDefault(name) { [defaults setBool:[[dict objectForKey:name] boolValue] forKey:name]; }

#define setIntDefault(name) { [defaults setInteger:[[dict objectForKey:name] intValue] forKey:name]; }

- (void)savePreferencesToDefaults:(NSDictionary *)dict {

    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

    setIntDefault(   MainMemorySize   );
    setIntDefault(   GenerationSize   );
    setIntDefault(   NumberOfKittens  );

    setStringDefault(   PathToInitialLoad   );

    setBoolDefault(   CompileDefines         );
    setBoolDefault(   DisplayFullPrecision   );
    setBoolDefault(   LoadLastFile           );
    setBoolDefault(   NostalgiaMode          );
    setBoolDefault(   ShowBasicButtons       );
    setBoolDefault(   ShowInstrumentPanel    );
    setBoolDefault(   UseGenerationalGC      );
    setBoolDefault(   ConfigurationA         );

    setStringDefault(  recentFile0 );
    setStringDefault(  recentFile1 );
    setStringDefault(  recentFile2 );
    setStringDefault(  recentFile3 );
    setStringDefault(  recentFile4 );
    setStringDefault(  recentFile5 );
    setStringDefault(  recentFile6 );
    setStringDefault(  recentFile7 );
    setStringDefault(  recentFile8 );
    setStringDefault(  recentFile9 );
    setStringDefault(  recentFile10 );
    setStringDefault(  recentFile11 );
    setStringDefault(  recentFile12 );
    setStringDefault(  recentFile13 );
    setStringDefault(  recentFile14 );
    setStringDefault(  recentFile15 );
    setStringDefault(  recentFile16 );
    setStringDefault(  recentFile17 );
    setStringDefault(  recentFile18 );
    setStringDefault(  recentFile19 );
    setStringDefault(  recentFile20 );
    setStringDefault(  recentFile21 );
    setStringDefault(  recentFile22 );
    setStringDefault(  recentFile23 );
	setStringDefault(  recentFile24 );
	setStringDefault(  recentFile25 );
	setStringDefault(  recentFile26 );
	setStringDefault(  recentFile27 );
	setStringDefault(  recentFile28 );
	setStringDefault(  recentFile29 );
	setStringDefault(  recentFile30 );
	setStringDefault(  recentFile31 );
	setStringDefault(  recentFile32 );
	setStringDefault(  recentFile33 );
	setStringDefault(  recentFile34 );
	setStringDefault(  recentFile35 );
	setStringDefault(  recentFile36 );
	setStringDefault(  recentFile37 );
	setStringDefault(  recentFile38 );
	setStringDefault(  recentFile39 );

    setIntDefault( PreferredBackgroundColorAsInteger )
    setIntDefault( PreferredTextColorAsInteger )

    [defaults synchronize];
    }

- (bool)treatPreference { return [[displayedValues objectForKey:ConfigurationA] boolValue]; }

- (void)setTreatPreference:(bool)value { 

    [displayedValues setObject:[NSNumber numberWithBool:value] forKey:ConfigurationA];
    }

- (NSColor *)preferredBackgroundColor { return preferredBackgroundColor; }

- (void)setPreferredBackgroundColor:(NSColor *)aColor {

    SInt32 redPart   = 0;
    SInt32 greenPart = 0;
    SInt32 bluePart  = 0;
    SInt32 pBCAI     = 0;
    
    if( preferredBackgroundColor != nil )
        [preferredBackgroundColor release];
    preferredBackgroundColor = aColor;
    redPart   = (SInt32)lround( [preferredBackgroundColor redComponent  ] * 255.);
    greenPart = (SInt32)lround( [preferredBackgroundColor greenComponent] * 255.);
    bluePart  = (SInt32)lround( [preferredBackgroundColor blueComponent ] * 255.);
    pBCAI = (redPart << 16) | (greenPart << 8) | bluePart;

    [displayedValues setObject:[NSNumber numberWithInt:pBCAI] forKey:PreferredBackgroundColorAsInteger];
    [backgroundCWell  setColor:preferredBackgroundColor];
    [self saveDefaults];
    }

- (NSColor *)preferredTextColor { return preferredTextColor; }

- (void)setPreferredTextColor:(NSColor *)aColor {

    SInt32 redPart   = 0;
    SInt32 greenPart = 0;
    SInt32 bluePart  = 0;
    SInt32 pTCAI     = 0;
    
    if( preferredTextColor != nil )
        [preferredTextColor release];
    preferredTextColor = aColor;
    redPart   = (SInt32)lround( [preferredTextColor redComponent  ] * 255.);
    greenPart = (SInt32)lround( [preferredTextColor greenComponent] * 255.);
    bluePart  = (SInt32)lround( [preferredTextColor blueComponent ] * 255.);
    pTCAI = (redPart << 16) | (greenPart << 8) | bluePart;

    [displayedValues setObject:[NSNumber numberWithInt:pTCAI] forKey:PreferredTextColorAsInteger];
    [textCWell  setColor:preferredTextColor];
    [self saveDefaults];
    }

- (void)addLoadRecentPreference:(NSString *)path {

    NSInteger i = 0;

    //  Hack, hack ... there's a better way to do this, but I am enough
    //  confused by preferences that I don't know what it is ...
    //  ... besides, I have never written a bubble-sort routine.

    // Make bubble if value was already present.

    if( [[displayedValues objectForKey:recentFile0] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile0];
    else if( [[displayedValues objectForKey:recentFile1] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile1];
    else if( [[displayedValues objectForKey:recentFile2] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile2];
    else if( [[displayedValues objectForKey:recentFile3] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile3];
    else if( [[displayedValues objectForKey:recentFile4] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile4];
    else if( [[displayedValues objectForKey:recentFile5] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile5];
    else if( [[displayedValues objectForKey:recentFile6] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile6];
    else if( [[displayedValues objectForKey:recentFile7] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile7];
    else if( [[displayedValues objectForKey:recentFile8] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile8];
    else if( [[displayedValues objectForKey:recentFile9] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile9];
    else if( [[displayedValues objectForKey:recentFile10] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile10];
    else if( [[displayedValues objectForKey:recentFile11] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile11];
    else if( [[displayedValues objectForKey:recentFile12] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile12];
    else if( [[displayedValues objectForKey:recentFile13] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile13];
    else if( [[displayedValues objectForKey:recentFile14] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile14];
    else if( [[displayedValues objectForKey:recentFile15] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile15];
    else if( [[displayedValues objectForKey:recentFile16] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile16];
    else if( [[displayedValues objectForKey:recentFile17] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile17];
    else if( [[displayedValues objectForKey:recentFile18] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile18];
    else if( [[displayedValues objectForKey:recentFile19] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile19];
    else if( [[displayedValues objectForKey:recentFile20] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile20];
    else if( [[displayedValues objectForKey:recentFile21] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile21];
    else if( [[displayedValues objectForKey:recentFile22] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile22];
    else if( [[displayedValues objectForKey:recentFile23] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile23];
    else if( [[displayedValues objectForKey:recentFile24] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile24];
    else if( [[displayedValues objectForKey:recentFile25] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile25];
    else if( [[displayedValues objectForKey:recentFile26] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile26];
    else if( [[displayedValues objectForKey:recentFile27] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile27];
    else if( [[displayedValues objectForKey:recentFile28] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile28];
    else if( [[displayedValues objectForKey:recentFile29] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile29];
    else if( [[displayedValues objectForKey:recentFile30] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile30];
    else if( [[displayedValues objectForKey:recentFile31] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile31];
    else if( [[displayedValues objectForKey:recentFile32] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile32];
    else if( [[displayedValues objectForKey:recentFile33] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile33];
    else if( [[displayedValues objectForKey:recentFile34] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile34];
    else if( [[displayedValues objectForKey:recentFile35] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile35];
    else if( [[displayedValues objectForKey:recentFile36] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile36];
    else if( [[displayedValues objectForKey:recentFile37] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile37];
    else if( [[displayedValues objectForKey:recentFile38] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile38];
    else if( [[displayedValues objectForKey:recentFile39] isEqual:path] )
        [displayedValues setObject:@"" forKey:recentFile39];

    // Propagate bubbles toward high-numbered end of section.

    for( i = 0; i < 39; ++i ) {
	if( [[displayedValues objectForKey:recentFile0] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile1] forKey:recentFile0];
	    [displayedValues setObject:@"" forKey:recentFile1];
 	    }
	if( [[displayedValues objectForKey:recentFile1] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile2] forKey:recentFile1];
	    [displayedValues setObject:@"" forKey:recentFile2];
	    }
	if( [[displayedValues objectForKey:recentFile2] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile3] forKey:recentFile2];
	    [displayedValues setObject:@"" forKey:recentFile3];
	    }
	if( [[displayedValues objectForKey:recentFile3] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile4] forKey:recentFile3];
	    [displayedValues setObject:@"" forKey:recentFile4];
	    }
	if( [[displayedValues objectForKey:recentFile4] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile5] forKey:recentFile4];
	    [displayedValues setObject:@"" forKey:recentFile5];
	    }
	if( [[displayedValues objectForKey:recentFile5] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile6] forKey:recentFile5];
	    [displayedValues setObject:@"" forKey:recentFile6];
	    }
	if( [[displayedValues objectForKey:recentFile6] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile7] forKey:recentFile6];
	    [displayedValues setObject:@"" forKey:recentFile7];
	    }
	if( [[displayedValues objectForKey:recentFile7] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile8] forKey:recentFile7];
	    [displayedValues setObject:@"" forKey:recentFile8];
	    }
	if( [[displayedValues objectForKey:recentFile8] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile9] forKey:recentFile8];
	    [displayedValues setObject:@"" forKey:recentFile9];
	    }
	if( [[displayedValues objectForKey:recentFile9] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile10] forKey:recentFile9];
	    [displayedValues setObject:@"" forKey:recentFile10];
	    }
	if( [[displayedValues objectForKey:recentFile10] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile11] forKey:recentFile10];
	    [displayedValues setObject:@"" forKey:recentFile11];
	    }

	if( [[displayedValues objectForKey:recentFile11] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile12] forKey:recentFile11];
	    [displayedValues setObject:@"" forKey:recentFile12];
	    }
	if( [[displayedValues objectForKey:recentFile12] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile13] forKey:recentFile12];
	    [displayedValues setObject:@"" forKey:recentFile13];
	    }
	if( [[displayedValues objectForKey:recentFile13] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile14] forKey:recentFile13];
	    [displayedValues setObject:@"" forKey:recentFile14];
	    }
	if( [[displayedValues objectForKey:recentFile14] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile15] forKey:recentFile14];
	    [displayedValues setObject:@"" forKey:recentFile15];
	    }
	if( [[displayedValues objectForKey:recentFile15] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile16] forKey:recentFile15];
	    [displayedValues setObject:@"" forKey:recentFile16];
	    }
	if( [[displayedValues objectForKey:recentFile16] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile17] forKey:recentFile16];
	    [displayedValues setObject:@"" forKey:recentFile17];
	    }
	if( [[displayedValues objectForKey:recentFile17] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile18] forKey:recentFile17];
	    [displayedValues setObject:@"" forKey:recentFile18];
	    }
	if( [[displayedValues objectForKey:recentFile18] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile19] forKey:recentFile18];
	    [displayedValues setObject:@"" forKey:recentFile19];
	    }
	if( [[displayedValues objectForKey:recentFile19] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile20] forKey:recentFile19];
	    [displayedValues setObject:@"" forKey:recentFile20];
	    }
	if( [[displayedValues objectForKey:recentFile20] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile21] forKey:recentFile20];
	    [displayedValues setObject:@"" forKey:recentFile21];
	    }
	if( [[displayedValues objectForKey:recentFile21] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile22] forKey:recentFile21];
	    [displayedValues setObject:@"" forKey:recentFile22];
	    }
	if( [[displayedValues objectForKey:recentFile22] isEqual:@""] ) {
	    [displayedValues setObject:[displayedValues objectForKey:recentFile23] forKey:recentFile22];
	    [displayedValues setObject:@"" forKey:recentFile23];
	    }
    if( [[displayedValues objectForKey:recentFile23] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile24] forKey:recentFile23];
        [displayedValues setObject:@"" forKey:recentFile24];
        }
    if( [[displayedValues objectForKey:recentFile24] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile25] forKey:recentFile24];
        [displayedValues setObject:@"" forKey:recentFile25];
        }
    if( [[displayedValues objectForKey:recentFile25] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile26] forKey:recentFile25];
        [displayedValues setObject:@"" forKey:recentFile26];
        }
    if( [[displayedValues objectForKey:recentFile26] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile27] forKey:recentFile26];
        [displayedValues setObject:@"" forKey:recentFile27];
        }
    if( [[displayedValues objectForKey:recentFile27] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile28] forKey:recentFile27];
        [displayedValues setObject:@"" forKey:recentFile28];
        }
    if( [[displayedValues objectForKey:recentFile28] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile29] forKey:recentFile28];
        [displayedValues setObject:@"" forKey:recentFile29];
        }
    if( [[displayedValues objectForKey:recentFile29] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile30] forKey:recentFile29];
        [displayedValues setObject:@"" forKey:recentFile30];
        }
    if( [[displayedValues objectForKey:recentFile30] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile31] forKey:recentFile30];
        [displayedValues setObject:@"" forKey:recentFile31];
        }
    if( [[displayedValues objectForKey:recentFile31] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile32] forKey:recentFile31];
        [displayedValues setObject:@"" forKey:recentFile32];
        }
    if( [[displayedValues objectForKey:recentFile32] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile33] forKey:recentFile32];
        [displayedValues setObject:@"" forKey:recentFile33];
        }
    if( [[displayedValues objectForKey:recentFile33] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile34] forKey:recentFile33];
        [displayedValues setObject:@"" forKey:recentFile34];
        }
    if( [[displayedValues objectForKey:recentFile34] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile35] forKey:recentFile34];
        [displayedValues setObject:@"" forKey:recentFile35];
        }
    if( [[displayedValues objectForKey:recentFile35] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile36] forKey:recentFile35];
        [displayedValues setObject:@"" forKey:recentFile36];
        }
    if( [[displayedValues objectForKey:recentFile36] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile37] forKey:recentFile36];
        [displayedValues setObject:@"" forKey:recentFile37];
        }
    if( [[displayedValues objectForKey:recentFile37] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile38] forKey:recentFile37];
        [displayedValues setObject:@"" forKey:recentFile38];
        }
    if( [[displayedValues objectForKey:recentFile38] isEqual:@""] ) {
        [displayedValues setObject:[displayedValues objectForKey:recentFile39] forKey:recentFile38];
        [displayedValues setObject:@"" forKey:recentFile39];
        }
    }

    // Add value at zero.

    [displayedValues setObject:[displayedValues objectForKey:recentFile38] forKey:recentFile39];
    [displayedValues setObject:[displayedValues objectForKey:recentFile37] forKey:recentFile38];
    [displayedValues setObject:[displayedValues objectForKey:recentFile36] forKey:recentFile37];
    [displayedValues setObject:[displayedValues objectForKey:recentFile35] forKey:recentFile36];
    [displayedValues setObject:[displayedValues objectForKey:recentFile34] forKey:recentFile35];
    [displayedValues setObject:[displayedValues objectForKey:recentFile33] forKey:recentFile34];
    [displayedValues setObject:[displayedValues objectForKey:recentFile32] forKey:recentFile33];
    [displayedValues setObject:[displayedValues objectForKey:recentFile31] forKey:recentFile32];
    [displayedValues setObject:[displayedValues objectForKey:recentFile30] forKey:recentFile31];
    [displayedValues setObject:[displayedValues objectForKey:recentFile29] forKey:recentFile30];
    [displayedValues setObject:[displayedValues objectForKey:recentFile28] forKey:recentFile29];
    [displayedValues setObject:[displayedValues objectForKey:recentFile27] forKey:recentFile28];
    [displayedValues setObject:[displayedValues objectForKey:recentFile26] forKey:recentFile27];
    [displayedValues setObject:[displayedValues objectForKey:recentFile25] forKey:recentFile26];
    [displayedValues setObject:[displayedValues objectForKey:recentFile24] forKey:recentFile25];
    [displayedValues setObject:[displayedValues objectForKey:recentFile23] forKey:recentFile24];

    [displayedValues setObject:[displayedValues objectForKey:recentFile22] forKey:recentFile23];
    [displayedValues setObject:[displayedValues objectForKey:recentFile21] forKey:recentFile22];
    [displayedValues setObject:[displayedValues objectForKey:recentFile20] forKey:recentFile21];
    [displayedValues setObject:[displayedValues objectForKey:recentFile19] forKey:recentFile20];
    [displayedValues setObject:[displayedValues objectForKey:recentFile18] forKey:recentFile19];
    [displayedValues setObject:[displayedValues objectForKey:recentFile17] forKey:recentFile18];
    [displayedValues setObject:[displayedValues objectForKey:recentFile16] forKey:recentFile17];
    [displayedValues setObject:[displayedValues objectForKey:recentFile15] forKey:recentFile16];
    [displayedValues setObject:[displayedValues objectForKey:recentFile14] forKey:recentFile15];
    [displayedValues setObject:[displayedValues objectForKey:recentFile13] forKey:recentFile14];
    [displayedValues setObject:[displayedValues objectForKey:recentFile12] forKey:recentFile13];
    [displayedValues setObject:[displayedValues objectForKey:recentFile11] forKey:recentFile12];

    [displayedValues setObject:[displayedValues objectForKey:recentFile10] forKey:recentFile11];
    [displayedValues setObject:[displayedValues objectForKey:recentFile9] forKey:recentFile10];
    [displayedValues setObject:[displayedValues objectForKey:recentFile8] forKey:recentFile9];
    [displayedValues setObject:[displayedValues objectForKey:recentFile7] forKey:recentFile8];
    [displayedValues setObject:[displayedValues objectForKey:recentFile6] forKey:recentFile7];
    [displayedValues setObject:[displayedValues objectForKey:recentFile5] forKey:recentFile6];
    [displayedValues setObject:[displayedValues objectForKey:recentFile4] forKey:recentFile5];
    [displayedValues setObject:[displayedValues objectForKey:recentFile3] forKey:recentFile4];
    [displayedValues setObject:[displayedValues objectForKey:recentFile2] forKey:recentFile3];
    [displayedValues setObject:[displayedValues objectForKey:recentFile1] forKey:recentFile2];
    [displayedValues setObject:[displayedValues objectForKey:recentFile0] forKey:recentFile1];
    [displayedValues setObject:path forKey:recentFile0];

    [self saveDefaults];
    }

- (IBAction)clearRecentFiles:(id)sender {

    [displayedValues setObject:@"" forKey:recentFile39];
    [displayedValues setObject:@"" forKey:recentFile38];
    [displayedValues setObject:@"" forKey:recentFile37];
    [displayedValues setObject:@"" forKey:recentFile36];
    [displayedValues setObject:@"" forKey:recentFile35];
    [displayedValues setObject:@"" forKey:recentFile34];
    [displayedValues setObject:@"" forKey:recentFile33];
    [displayedValues setObject:@"" forKey:recentFile32];
    [displayedValues setObject:@"" forKey:recentFile31];
    [displayedValues setObject:@"" forKey:recentFile30];
    [displayedValues setObject:@"" forKey:recentFile29];
    [displayedValues setObject:@"" forKey:recentFile28];
    [displayedValues setObject:@"" forKey:recentFile27];
    [displayedValues setObject:@"" forKey:recentFile26];
    [displayedValues setObject:@"" forKey:recentFile25];
    [displayedValues setObject:@"" forKey:recentFile24];
    [displayedValues setObject:@"" forKey:recentFile23];
    [displayedValues setObject:@"" forKey:recentFile22];
    [displayedValues setObject:@"" forKey:recentFile21];
    [displayedValues setObject:@"" forKey:recentFile20];
    [displayedValues setObject:@"" forKey:recentFile19];
    [displayedValues setObject:@"" forKey:recentFile18];
    [displayedValues setObject:@"" forKey:recentFile17];
    [displayedValues setObject:@"" forKey:recentFile16];
    [displayedValues setObject:@"" forKey:recentFile15];
    [displayedValues setObject:@"" forKey:recentFile14];
    [displayedValues setObject:@"" forKey:recentFile13];
    [displayedValues setObject:@"" forKey:recentFile12];
    [displayedValues setObject:@"" forKey:recentFile11];
    [displayedValues setObject:@"" forKey:recentFile10];
    [displayedValues setObject:@"" forKey:recentFile9];
    [displayedValues setObject:@"" forKey:recentFile8];
    [displayedValues setObject:@"" forKey:recentFile7];
    [displayedValues setObject:@"" forKey:recentFile6];
    [displayedValues setObject:@"" forKey:recentFile5];
    [displayedValues setObject:@"" forKey:recentFile4];
    [displayedValues setObject:@"" forKey:recentFile3];
    [displayedValues setObject:@"" forKey:recentFile2];
    [displayedValues setObject:@"" forKey:recentFile1];
    [displayedValues setObject:@"" forKey:recentFile0];

    [self saveDefaults];
    }

- (NSMutableArray *)loadRecentPreferences {   //  Caller must free the returned array.

    NSMutableArray *answer = 0;
    NSInteger i = 0;

    answer = [[NSMutableArray arrayWithCapacity:24] retain];

    if( ! [[displayedValues objectForKey:recentFile0] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile0] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile1] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile1] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile2] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile2] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile3] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile3] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile4] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile4] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile5] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile5] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile6] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile6] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile7] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile7] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile8] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile8] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile9] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile9] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile10] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile10] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile11] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile11] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile12] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile12] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile13] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile13] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile14] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile14] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile15] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile15] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile16] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile16] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile17] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile17] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile18] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile18] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile19] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile19] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile20] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile20] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile21] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile21] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile22] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile22] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile23] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile23] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile24] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile24] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile25] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile25] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile26] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile26] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile27] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile27] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile28] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile28] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile29] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile29] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile30] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile30] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile31] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile31] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile32] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile32] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile33] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile33] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile34] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile34] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile35] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile35] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile36] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile36] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile37] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile37] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile38] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile38] atIndex:i++];
    if( ! [[displayedValues objectForKey:recentFile39] isEqual:@""] )
        [answer insertObject:[displayedValues objectForKey:recentFile39] atIndex:i];

    return answer;
    }

- (void) localError:(NSString *)message {
    NSBeginAlertSheet(
        message,
        @"Okay", NULL, NULL,
        panel,
        self,
        NULL,
        NULL,
        NULL,
        @"",
        NULL
        );
    }

- (IBAction) getPathForPreferences:(id)sender {
    static NSString *filePath = nil;
    NSInteger result;
    const char *theString = 0;
    NSOpenPanel *op = [NSOpenPanel openPanel];

    [op setTitle:@"Startup File"];
    [op setMessage:@"Pick a file for Wraith Scheme to load at startup."];
    result = [op runModalForDirectory:nil file:nil types:nil];
    if (result == NSOKButton) {
        filePath = [[op filenames] objectAtIndex:0];
        theString = [filePath cStringUsingEncoding:NSASCIIStringEncoding];
        if( theString && (strlen( theString ) > 0 ) ) {
            [displayedValues setObject:filePath forKey:PathToInitialLoad];
            [loadSourceFilePathField setStringValue:[displayedValues objectForKey:PathToInitialLoad]];
            }
        else
            [self localError:@"\nThe path (including the file name) to the file to load when Wraith Scheme starts included some non-ASCII characters.\n\nScheme is supposed to use only ASCII characters.  They are pretty much the \"regular\" keyboard characters, entered without the \"command-\" and \"option-\" modifier keys.\n\nTo use the file you selected, you must change its name, or the names of the directories in the path to the file, or both, to contain only ASCII characters."];
        }
    }

/**** Window delegation ****/

// We do this to catch the case where the user enters a value into one
// of the text fields but closes the window without hitting enter or tab.

- (void)windowWillClose:(NSNotification *)notification {
    NSWindow *window = [notification object];
    (void)[window makeFirstResponder:window];
    }

@end
