//
//  SenseLightArrayController.h
//  WraithCocoa
//
//  Copyright 2010 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <Cocoa/Cocoa.h>
#import "SenseLightCommands.h"

#ifndef BITS_IN_BYTE

#define BITS_IN_BYTE 8

#endif

@interface SenseLightArrayController : NSObject {

    IBOutlet id theSchemeController;    

    bool state[ N_SENSE_LIGHTS ];             // true <--> on; false <--> off.
    bool visible[ N_SENSE_LIGHTS ];           // Are the lights visible?
    int illumination[ N_SENSE_LIGHTS ];       // What colors are the lights?  (Includes "off")
    NSImageView *theView[ N_SENSE_LIGHTS ];

    IBOutlet NSImageView *imageView0;
    IBOutlet NSImageView *imageView1;
    IBOutlet NSImageView *imageView2;
    IBOutlet NSImageView *imageView3;
    IBOutlet NSImageView *imageView4;
    IBOutlet NSImageView *imageView5;
    IBOutlet NSImageView *imageView6;
    IBOutlet NSImageView *imageView7;

    NSImage *redImage;
    NSImage *orangeImage;
    NSImage *yellowImage;
    NSImage *greenImage;
    NSImage *cyanImage;
    NSImage *magentaImage;
    NSImage *offImage;
    NSImage *blackImage;

    }

- (void) initialize;
- (void) clearSenseLights;
- (void) interpretLongCommand:(long)c;
- (void) interpretOneCommand:(unsigned char)c forLight:(int)light;
- (void) interpretBothCommands:(unsigned char)c forLight:(long)light;
- (void) rotateLights:(long)n;
- (void) setLight:(int)light toIllumination:(int)newIllumination;
- (void) setLight:(int)light toVisible:(bool)newVisible;

@end
