 
//
//  SneakyWindowController.m
//  WraithCocoa
//
//  Created by Jay Freeman on 05/02/2007.
//  Copyright 2007 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import "SneakyWindowController.h"

@implementation SneakyWindowController

// The "init" method creates the sneaky window offscreen somewhere

- (id) init {

    NSRect mainScreenFrame = [[NSScreen mainScreen] frame];
    NSRect imageFrame;

    visibleRect.size.height = 20.0;
    visibleRect.size.width = 16.0;
    visibleRect.origin.x = 20.0;
    visibleRect.origin.y = mainScreenFrame.size.height - visibleRect.size.height;

    offScreenRect.size.height = 20.0;
    offScreenRect.size.width = 35.0;
    offScreenRect.origin.x = -1000.0;
    offScreenRect.origin.y = -1000.0;

    theWindow = [[[NSWindow alloc] initWithContentRect: offScreenRect
                                             styleMask: NSBorderlessWindowMask
                                               backing: NSBackingStoreBuffered
                                                 defer: NO]
                   retain];
    [theWindow setIgnoresMouseEvents:YES];


    imageFrame.origin.x = 0.0;
    imageFrame.origin.y = 0.0;
    imageFrame.size.height = 21.0;
    imageFrame.size.width = 16.0;

    theView = [[[NSImageView alloc] initWithFrame:imageFrame] retain];
    [theWindow setContentView:theView];
    [theView setImageAlignment:NSImageAlignBottomLeft];
    [theView setImageScaling:NSScaleNone];
    [theView setFrame:imageFrame];
//    [theView setToolTip:@"\"It's a poor sort of memory that only works backwards.\"    Lewis Carroll"];
    [theView setToolTip:@"\"It's a poor sort of memory that only works backwards.\"  --  Lewis Carroll"];
    [theWindow setOpaque:NO];
    [theWindow setBackgroundColor:[NSColor colorWithDeviceRed:0.0 green:0.0 blue:1.0 alpha:0.0]];
    
    return self;
    }

- (void) conceal {

    [theWindow setFrame:offScreenRect display:FALSE];
    }

- (void) reveal {

    [theWindow setLevel:NSMainMenuWindowLevel];
    [theWindow setFrame:visibleRect display:TRUE];
    [theWindow orderFront:self];
    }

- (void) setImage:(NSImage *)anImage {

    [theView setImage:anImage];
    }

- (void) test:(NSImage *)anImage {

    [theWindow setLevel:NSMainMenuWindowLevel];
    [theWindow orderFront:self];
    [theView setImage:anImage];
    [theView display];
    [theWindow display];
    [theView display];
    }

@end
