//
//  StatusLightController.h
//  WraithCocoa
//
//  Created by Jay Freeman on 12/16/06.
//  Copyright 2006 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <Cocoa/Cocoa.h>


@interface StatusLightController : NSObject {
    bool state;            // true <--> on; false <--> off.
    IBOutlet NSImageView *theView;
    NSImage *onImage;
    NSImage *alternateOnImage;
    NSImage *offImage;
    bool usingAlternateOnImage;
    }

- (void) awakeFromNib;
- (bool) statusControllerState;
- (void) setOnImage:(NSImage *)theOnImage;
- (void) setAlternateOnImage:(NSImage *)theAlternateOnImage;
- (void) setOffImage:(NSImage *)theOffImage;
- (void) toggleBrightness;
- (void) turnOn;
- (void) turnOff;
- (bool) isOn;

@end
