//
//  WS64GroupController.m
//
//  Created by Jay Freeman on 9/8/10.
//  Copyright 2010 Jay Reynolds Freeman.  All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import "WS64GroupController.h"
#import "WraithSchemeOuterController.h"
#import "Preferences.h"

extern Boolean setMemoryFromCommandLine;             // In main.mm
extern long commandLineMemorySizeInUse;              // In main.mm
extern Boolean setNKittensFromCommandLine;           // In main.mm
extern unsigned int commandLineNKittens;             // In main.mm
extern Boolean setGCTypeFromCommandLine;             // In main.mm
extern long commandLineUsingGenerationalGC;          // In main.mm
extern Boolean outerIsMomCatP;                       // In main.mm
extern unsigned int outerKittenNumber;               // In main.mm

@implementation WS64GroupController

- (void) applicationDidFinishLaunching:(NSNotification *)aNotification {

    UnsignedWord localNKittens = 1;
    NSInteger localMainMemorySize = 10485760;
    NSInteger localGenerationalMemorySize = 10485760;
    Boolean localUsingGenerationalGC = TRUE;

    if( setNKittensFromCommandLine )
        localNKittens = commandLineNKittens + 1;
    else
        localNKittens = [[thePreferences objectForKey:NumberOfKittens] intValue] + 1;

    if( setMemoryFromCommandLine )
        localMainMemorySize = commandLineMemorySizeInUse * 1048576;
    else
        localMainMemorySize = [[thePreferences objectForKey:MainMemorySize] longValue] * 1048576;

    if( localMainMemorySize < 10485760 )
        localMainMemorySize = 10485760;

    localGenerationalMemorySize = [[thePreferences objectForKey:GenerationSize] longValue] * 1048576;

    if( setGCTypeFromCommandLine )
        localUsingGenerationalGC = commandLineUsingGenerationalGC;
    else
        localUsingGenerationalGC = [[thePreferences objectForKey:UseGenerationalGC] boolValue];

//    [theWraithSchemeOuterController applicationDidFinishLaunchingContent];
    [theWraithSchemeOuterController
         applicationLaunchWithNumberOfKittens:localNKittens
                           withMainMemorySize:localMainMemorySize
                   withGenerationalMemorySize:localGenerationalMemorySize
                      withGenerationalGCInUse:localUsingGenerationalGC
                         withHasWorldToLaunch:hasWorldForLaunch
                              withPathToWorld:pathToWorldForLaunch
                                withIsMomCatP:outerIsMomCatP
                             withKittenNumber:outerKittenNumber
        ];
    
    }

//######## This method just records the fact that evidently we have been given a world to open at start-time.

- (bool)application:(NSApplication *)theApplication openFile:(NSString *)filename {

    hasWorldForLaunch = true;
    pathToWorldForLaunch = filename;
    [pathToWorldForLaunch retain];
    return true;
    }

//######## Termination method calls the one in the outer controller.

- (void) applicationWillTerminate:(NSNotification *)notification {

    [theWraithSchemeOuterController applicationWillTerminate:notification];

    }
    

@end
