
//
//  WraithSchemeOuterController.h
//  WraithCocoa
//
//  Created by Jay Freeman on 12/15/06.
//  Copyright 2006 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <sys/types.h>
#import <sys/stat.h>

#import "LocalTypes.h"
#import "WraithSchemeControllerAndModel.h"

@class BadgedIconView;
@class ColorChooserWindow;
@class DrawerController;
@class MainWindowController;
@class Preferences;
@class StatusLightController;
@class SenseLightArrayController;
@class JRFNSTextView;
@class JRF2NSTextView;
@class JRF4NSTextView;
@class SneakyWindowController;
@class CustomDockIconView;

@interface WraithSchemeOuterController : WraithSchemeControllerAndModel {

    bool displayingMessage;
    bool evaluating;
    bool expectMoreInput;
    bool gcing;
    bool lastFileLoadBegan;
    bool lastFileLoadSucceeded;
    bool lastLoadStatBufferIsGood;
    bool loadingLastFileWhenUpdated;
    bool outputEnabled;
    bool stopEvaluatingPending;
    bool wantsToQuit;

    char lastFileLoadedPathAsCString[ MAXPATHLEN + 42 ];
    char nextToLastFileLoadedPathAsCString[ MAXPATHLEN + 42 ];

    int nextTask;
    int controllerActionCounter;
    int notEvaluatingHowLongCounter;

    long messageDisplayCounter;

    struct stat lastLoadStatBuffer;
    struct stat currentStatBuffer;

    NSArray *symbolsInWraithSchemeDictionary;

    NSColor *kittenColor1;
    NSColor *kittenColor2;
    NSColor *kittenColor3;
    NSColor *kittenColor4;
    NSColor *kittenColor5;
    NSColor *kittenColor6;
    NSColor *kittenColor7;
    NSColor *kittenColor8;
    NSColor *kittenColor9;
    NSColor *kittenColor10;
    NSColor *kittenColor11;
    NSColor *kittenColor12;
    NSColor *kittenColor13;
    NSColor *kittenColor14;
    NSColor *kittenColor15;

    NSColor *savedBackgroundColor;
    NSColor *savedTextColor;

    NSColorPanel *theSharedColorPanel;

    NSNumberFormatter *sliderFormatter;

    NSMutableArray *recentFiles;
//    NSMutableArray *symbolsInObList;

    NSString *lastFileLoadedPath;
    NSString *nextToLastFileLoadedPath;

    IBOutlet ColorChooserWindow *myBackgroundColorChooser;
    IBOutlet ColorChooserWindow *myTextColorChooser;

    IBOutlet DrawerController *theDrawerController;

    IBOutlet JRFNSTextView *mainView;

    IBOutlet JRF2NSTextView *responseView;

    IBOutlet JRF4NSTextView *inputView;

    IBOutlet MainWindowController *mWController;

    IBOutlet Preferences* thePreferences;

    IBOutlet SenseLightArrayController *sLAController;

    IBOutlet SneakyWindowController *mySneakyWindow;

    IBOutlet StatusLightController *cDBController;
    IBOutlet StatusLightController *eBController;
    IBOutlet StatusLightController *gCBController;
    IBOutlet StatusLightController *lOUBController;
    IBOutlet StatusLightController *mLIBController;
    IBOutlet StatusLightController *nBController;
    IBOutlet StatusLightController *sFPBController;
    IBOutlet StatusLightController *sBController;

    IBOutlet NSButton *dIButton;
    IBOutlet NSButton *lLFButton;
    IBOutlet NSButton *lLFWUButton;

    IBOutlet NSColorWell *myBackgroundColorChooserColorWell;
    IBOutlet NSColorWell *myTextColorChooserColorWell;

    IBOutlet NSImageView *donationSheetImageView;
             NSImage *sadKitty;
             NSImage *wraithFace;

    IBOutlet NSMenu     *wraithSchemeMenu;
    IBOutlet NSMenuItem *aboutMenuItem;
    IBOutlet NSMenuItem *preferencesMenuItem;
    IBOutlet NSMenuItem *servicesMenuItem;
    IBOutlet NSMenuItem *hideWraithSchemeMenuItem;
    IBOutlet NSMenuItem *hideOthersMenuItem;
    IBOutlet NSMenuItem *showAllMenuItem;
    IBOutlet NSMenuItem *considerSharewareDonationMenuItem;
    IBOutlet NSMenuItem *quitMenuItem;

    IBOutlet NSMenu     *interpreterMenu;
       
    IBOutlet NSMenuItem *resetMenuItem;
    IBOutlet NSMenuItem *dIMenuItem;
    IBOutlet NSMenuItem *tSMenuItem;
    IBOutlet NSMenuItem *lFMenuItem;
    IBOutlet NSMenuItem *lRecentFMenuItem;
    IBOutlet NSMenuItem *lLFMenuItem;
    IBOutlet NSMenuItem *lNLFMenuItem;
    IBOutlet NSMenuItem *lLFWUMenuItem;
    IBOutlet NSMenuItem *lWMenuItem;
    IBOutlet NSMenuItem *sWMenuItem;
    IBOutlet NSMenuItem *cDMenuItem;
    IBOutlet NSMenuItem *sFPMenuItem;
    IBOutlet NSMenuItem *nMMenuItem;

             NSMenu     *lRecentFSubMenu;
    IBOutlet NSMenu     *shortcutsMenu;

    IBOutlet NSMenuItem *kittenFrontMenuItem;
             NSMenu     *kittenFrontSubMenu;

    IBOutlet NSMenuItem *kittensAllFrontMenuItem;

    IBOutlet NSMenuItem *wraithSchemeHelpMenuItem;

    IBOutlet NSPanel *myDonationSheet;

    IBOutlet NSProgressIndicator *myProgressIndicator;

    IBOutlet NSScrollView *mainScrollView;
        
    IBOutlet NSTextField *byField;
    IBOutlet NSTextField *compileStringView;
    IBOutlet NSTextField *generationalMemoryInUseView;
    IBOutlet NSTextField *generationalMemorySizeView;
    IBOutlet NSTextField *lastFileLoadedView;
    IBOutlet NSTextField *lastWorldLoadedView;
    IBOutlet NSTextField *listPrintLengthView;
    IBOutlet NSTextField *listPrintDepthView;
    IBOutlet NSTextField *memoryInUseView;
    IBOutlet NSTextField *memorySizeView;
    IBOutlet NSTextField *numberOfGCsLabelView;
    IBOutlet NSTextField *numberOfGenerationalGCsLabelView;
    IBOutlet NSTextField *numberOfGCsView;
    IBOutlet NSTextField *numberOfGenerationalGCsView;
    IBOutlet NSTextField *vectorPrintLengthView;
    IBOutlet NSTextField *vectorPrintDepthView;

             bool showingGenerationalInformation;
             bool showingExpectView;
             NSInteger expectOnCount;

    IBOutlet NSTextField *expectView;

    IBOutlet NSTextView *promptView;

    IBOutlet NSTextField *boldField;
    IBOutlet NSTextField *normalField;
    IBOutlet NSButton *closeButton;

    IBOutlet NSPanel *backgroundColorPreferenceSheet;
    IBOutlet NSImageView *backgroundColorPreferenceSheetImageView;
             NSImage *coloredKitty;
    IBOutlet NSPanel *textColorPreferenceSheet;
    IBOutlet NSImageView *textColorPreferenceSheetImageView;

    IBOutlet NSWindow *myParentWindow;

    IBOutlet NSButton *toggleSwitch0;
    IBOutlet NSButton *toggleSwitch1;
    IBOutlet NSButton *toggleSwitch2;
    IBOutlet NSButton *toggleSwitch3;
    IBOutlet NSButton *toggleSwitch4;
    IBOutlet NSButton *toggleSwitch5;
    IBOutlet NSButton *toggleSwitch6;
    IBOutlet NSButton *toggleSwitch7;

    IBOutlet NSButton *pushButton0;
    IBOutlet NSButton *pushButton1;
    IBOutlet NSButton *pushButton2;
    IBOutlet NSButton *pushButton3;

    IBOutlet NSButton *bigRedButton;

    IBOutlet NSSlider *slider0;
    IBOutlet NSSlider *slider1;
    IBOutlet NSSlider *slider2;
    IBOutlet NSSlider *slider3;

    IBOutlet NSTextField *slider0Value;
    IBOutlet NSTextField *slider1Value;
    IBOutlet NSTextField *slider2Value;
    IBOutlet NSTextField *slider3Value;

    IBOutlet NSLevelIndicator *levelIndicator0;
    IBOutlet NSLevelIndicator *levelIndicator1;
    IBOutlet NSLevelIndicator *levelIndicator2;
    IBOutlet NSLevelIndicator *levelIndicator3;

    IBOutlet NSTextField *levelIndicator0Value;
    IBOutlet NSTextField *levelIndicator1Value;
    IBOutlet NSTextField *levelIndicator2Value;
    IBOutlet NSTextField *levelIndicator3Value;

    }

//- (void)loadMutableArray:(NSMutableArray *)nsa fromCStringArrayEndingInZero:(char **)csa startingWith:(int)start;
- (void) acceptBackgroundColorChooser;
- (IBAction) acceptBackgroundColorPreference:(id)sender;
- (void) acceptColorChooser:(id)sender;
- (void) acceptTextColorChooser;
- (IBAction) acceptTextColorPreference:(id)sender;
- (void) adjustLights;
//- (void) applicationDidFinishLaunchingContent;

- (void) applicationLaunchWithNumberOfKittens:(UnsignedWord)nKittens
                           withMainMemorySize:(NSInteger)mmSize
                   withGenerationalMemorySize:(NSInteger)gmSize
                      withGenerationalGCInUse:(Boolean)useGGC
                         withHasWorldToLaunch:(Boolean)hasWorld
                              withPathToWorld:(NSString *)pathToWorld
                                withIsMomCatP:(Boolean)momCatP
                             withKittenNumber:(unsigned int)kittenNumber;

- (IBAction) arrangeKittenInFront:(id)sender;
- (IBAction) arrangeAllKittensInFront:(id)sender;
- (void) beginInitProgress;
- (IBAction) bigRedButtonPushed:(id)sender;
- (void) cancelBackgroundColorChooser:(id)sender;
- (void) cancelTextColorChooser:(id)sender;
- (void) cleanUpColorChooser;
- (IBAction) clearRecentFilesWrapper:(id)sender;
- (IBAction) closeDonationSheet:(id)sender;
- (void) colorIconForKittenNumber;
- (void) colorSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (bool) controllerInitializationTask;
- (bool) dealWithInputText:(NSString *)theText;
- (bool) dealWithResponseText:(NSString *)theText;
- (IBAction) declineBackgroundColorPreference:(id)sender;
- (IBAction) declineTextColorPreference:(id)sender;
- (void) disableOutputSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (void) doControllerInitializationTask:(NSTimer *)theTimer;
- (void) donationSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (void) endInitProgress;
- (void) fileLoadBeginning:(const char *)givenPath;
- (void) fileLoadFailed;
- (IBAction)findInWraithSchemeDictionary:(id)sender;
- (id) init;
- (IBAction) loadLastFile:(id)sender;
- (IBAction) loadNextToLastFile:(id)sender;
- (void) loadRecentFileNo:(id)sender;
- (void) localError:(NSString *)message;
- (void) newViewNumber:(long)newNumber forView:(NSTextField *)theView;
- (void) newViewParenthesizedNumber:(long)newNumber forView:(NSTextField *)theView;
- (void) newViewString:(const char *)newString forView:(NSTextField *)theView;
- (void) openBackgroundColorChooser:(id)sender;
- (IBAction) openDictionary:(id)sender;
- (IBAction) openForLoad:(id)sender;
- (IBAction) openForWorldLoad:(id)sender;
- (IBAction) openForWorldSave:(id)sender;
- (IBAction) openGNU:(id)sender;
- (IBAction) openHelpFile:(id)sender;
- (IBAction) openInternalsFile:(id)sender;
- (IBAction) openReadMe:(id)sender;
- (IBAction) openSourceCode1:(id)sender;
- (IBAction) openSourceCode2:(id)sender;
- (IBAction) openSourceCode3:(id)sender;
- (IBAction) openSourceCode4:(id)sender;
- (IBAction) openSourceCode5:(id)sender;
- (IBAction) openSourceCode6:(id)sender;
- (IBAction) openSourceCode7:(id)sender;
- (IBAction) openSourceCode8:(id)sender;
- (IBAction) openSourceCode9:(id)sender;
- (IBAction) openSourceCode10:(id)sender;
- (void) openTextColorChooser:(id)sender;
- (IBAction) pushButtonPushed:(id)sender;
- (void) quitFinal;
- (void) quitSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (NSImage *) replaceColorAtPixelX:(int)i y:(int)j inImage:(NSImage *)anImage withColor:(NSColor *)newColor;
- (void) reportDisasterAndQuit:(const char *)errorMessage;
- (void) reportDisasterAndQuitDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (void) reportEarlyDisasterAndQuit;
- (void) reportEarlyDisasterAndQuitDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (IBAction) requestReset:(id)sender;
- (IBAction) runDisableOutputSheet:(id)sender;
- (IBAction) runDonationSheet:(id)sender;
- (IBAction) runQuitSheet:(id)sender;
- (IBAction) runTreatSheet:(NSString *)prompt;
- (void) setForEvaluating;
- (void) setForFileLoadBegan;
- (void) setForFileLoadFailed;
- (void) setForGCing;
- (void) setForNostalgiaMode;
- (void) setForNotEvaluating;
- (void) setForNotGCing;
- (void) setForNotNostalgiaMode;
- (void) setNonEvaluatorPreferences;
- (void) setNormalLights;
- (void) setNostalgiaLights;
- (void) setUpKittenFrontSubMenu:(int)nKittens;
- (void) singleControllerAction:(NSTimer*)theTimer;
- (void) singleControllerActionGuts;
- (IBAction) sliderDidChange:(id)sender;
- (void) sliderUpdateForTag:(NSInteger)tag toValue:(int)value;
- (IBAction) sliderValueDidChange:(id)sender;
- (void) sliderValueUpdateForTag:(NSInteger)tag toValue:(int)value;
- (NSArray *)spellingCompletionsForPartialWord:(NSString *)partWord;
- (void) startController;
- (void) startDialog:(NSString *)thePrompt;
- (void) startNormalInput;
- (IBAction) toggleCompileDefines:(id)sender;
- (IBAction) toggleFullNumericPrecision:(id)sender;
- (IBAction) toggleLoadLastFileWhenUpdated:(id)sender;
- (IBAction) toggleNostalgiaMode:(id)sender;
- (IBAction) toggleSwitchDidChange:(id)sender;
- (void) treatSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (IBAction) tryBackgroundColorChooser:(id)sender;
- (IBAction) tryTextColorChooser:(id)sender;
- (void) turnLightsOn;
- (void) turnLightsOff;
- (void) updateInitProgress:( double )newValue;
- (void) updateLoadRecentMenu;
- (void) worldLoadSucceeded:(const char *)path;

- (IBAction)Test1:(id)sender;
- (IBAction)Test2:(id)sender;
- (IBAction)Test3:(id)sender;
- (IBAction)Test4:(id)sender;
- (IBAction)Test5:(id)sender;
- (IBAction)Test6:(id)sender;
- (IBAction)Test7:(id)sender;
- (IBAction)Test8:(id)sender;

@end
