//
//  main.mm
//  WraithCocoa
//
//  Created by Jay Freeman on 12/18/06.
//  Copyright Jay Reynolds Freeman 2006. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/
#import <Cocoa/Cocoa.h>
#import <stdio.h>
#import <stdlib.h>
#import <sys/types.h>
#import <sys/mman.h>

#define WORD_MASK 0xffffffff

extern void mallocForMomCat();
extern void memFillForMomCat();
extern void mallocForMomCat();

int globalArgc;
char **globalArgv;
Boolean setCompileDefinesFromCommandLine = FALSE;
Boolean commandLineCompileDefinesFlag = FALSE;
Boolean setMemoryFromCommandLine = FALSE;
NSInteger commandLineMemorySizeInUse = 0;
Boolean setNKittensFromCommandLine = FALSE;
unsigned int commandLineNKittens = 0;
Boolean setGCTypeFromCommandLine = FALSE;
unsigned long commandLineUsingGenerationalGC = 0;
Boolean outerIsMomCatP = TRUE;
unsigned int outerKittenNumber = 0;

extern int optind;
extern int optopt;
extern int opterr;
extern int optreset;

extern char *optarg;
extern Boolean useStdinP;

void parseArgsForCocoa( int argc, char *argv[] );

/**** parseArgsForCocoa -- simple routine to check for test mode ****/

#import <unistd.h>

void parseArgsForCocoa( int argc, char *argv[] )
{
    int ch;

    while( (ch = getopt( argc, argv, "abc:defghijk:lm:nopqrstuvwxyz:_0123456789")) != -1 )
        switch( ch ) {
            case 'c':                      // set compile-defines from command line -- option '0' (FALSE) or not.
                setCompileDefinesFromCommandLine = TRUE;
                commandLineCompileDefinesFlag = (*optarg != '0');
                break;
            case 'g':                      // set number of kittens from commmand line -- option an integer
                setGCTypeFromCommandLine = TRUE;
                commandLineUsingGenerationalGC = (NSInteger)strtol( optarg, 0, 0 );
                break;
            case 'k':                      // kitten
                outerIsMomCatP = FALSE;
                outerKittenNumber = (unsigned int)strtol( optarg, 0, 0 );
                break;
            case 'm':                      // set memory from command line -- option an integer (MByte)
                setMemoryFromCommandLine = TRUE;
                commandLineMemorySizeInUse = (NSInteger)strtol( optarg, 0, 0 );
                break;
            case 't':                      // test mode -- accept input from stdin instead of the usual window
                useStdinP = TRUE;
                break;
            case 'z':                      // set number of kittens from commmand line -- option an integer
                setNKittensFromCommandLine = TRUE;
                commandLineNKittens = (int)(strtol( optarg, 0, 0 ) & WORD_MASK);
                break;
            default: break;
            }
    }

int main(int argc, char *argv[])
{
    globalArgc = argc;
    globalArgv = argv;
    parseArgsForCocoa( argc, argv );

    return NSApplicationMain(argc,  (const char **) argv);
    }
