/****************************************************************************************

CocoaIO.h -- Copyright (c) by Jay Reynolds Freeman 2006

Header file for stuff used in Wraith Scheme's Cocoa IO routines.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "WraithHeader.h"

// No varargs, so messy specialized print routines.  Each takes the number of arguments
// indicated by its name.  If there is a transcript port, it prints them on it, and
// in any case it prints them on the first argument, "f".

#define COCOA_MB_SIZE 1024

extern Text CocoaMessageBuffer[];
extern Boolean Cocoa_printf( Text *msg );
extern Boolean tprintfX( taggedAval *f );
extern volatile Boolean nostalgiaMode;
extern void emitIOInitializationMessages();

//  These macros are a bit clumsy, but they work.  The idea is to prepare a string for output by
//  using standard C++ facilities to format it into a local buffer, then call a modestly
//  complicated function to decide where it goes.  The messages to be printed are all of
//  statically-determinable length, so there is no need to check the buffer size at run-time
//  assuming we have got it right at compile time in the first place

#define tprintf2( f, s0 ) ( snprintf( CocoaMessageBuffer, COCOA_MB_SIZE, "%s", (s0) ), tprintfX( (f) ) )
#define tprintf3( f, s0, s1 ) ( snprintf( CocoaMessageBuffer, COCOA_MB_SIZE, (s0), (s1) ), tprintfX( (f) ) )
#define tprintf4( f, s0, s1, s2 ) ( snprintf( CocoaMessageBuffer, COCOA_MB_SIZE, (s0), (s1), (s2) ), tprintfX( (f) ) )
#define tprintf5( f, s0, s1, s2, s3 ) ( snprintf( CocoaMessageBuffer, COCOA_MB_SIZE, (s0), (s1), (s2), (s3) ), tprintfX( (f) ) )
#define tprintf6( f, s0, s1, s2, s3, s4 ) ( snprintf( CocoaMessageBuffer, COCOA_MB_SIZE, (s0), (s1), (s2), (s3), (s4) ), tprintfX( (f) ) )
#define tprintf7( f, s0, s1, s2, s3, s4, s5 ) ( snprintf( CocoaMessageBuffer, COCOA_MB_SIZE, (s0), (s1), (s2), (s3), (s4), (s5) ), tprintfX( (f) ) )
#define tprintf8( f, s0, s1, s2, s3, s4, s5, s6 ) ( snprintf( CocoaMessageBuffer, COCOA_MB_SIZE, (s0), (s1), (s2), (s3), (s4), (s5), (s6) ), tprintfX( (f) ) )
#define tprintf9( f, s0, s1, s2, s3, s4, s5, s6, s7 ) ( snprintf( CocoaMessageBuffer, COCOA_MB_SIZE, (s0), (s1), (s2), (s3), (s4), (s5), (s6), (s7) ), tprintfX( (f) ) )
#define tprintf10( f, s0, s1, s2, s3, s4, s5, s6, s7, s8 ) ( snprintf( CocoaMessageBuffer, COCOA_MB_SIZE, (s0), (s1), (s2), (s3), (s4), (s5), (s6), (s7), (s8)), tprintfX( (f) ) )


