/****************************************************************************************

CURSESIO.h -- Copyright (c) by Jay Reynolds Freeman 2006

Header file for stuff used in Wraith Scheme's CURSES IO routines

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#ifndef __CURSESIO_H__
#define __CURSESIO_H__

// No varargs, so messy specialized print routines.  Each takes the number of arguments
// indicated by its name.  If there is a transcript port, it jprints them on it, and
// in any case it jprints them on the first argument, "f".  These macros use the
// "?:" operator, with a comma operator used to repeat the jprintf to f in the
// consequent, to make sure the whole macro is a single statement, which may be
// terminated with a ';'.

#define CMB_SIZE 1024

extern Text CursorMessageBuffer[];
extern Boolean cprintf( Text *msg, Boolean saveP );
extern Boolean tprintfX( taggedAval *f );
extern Boolean nostalgiaMode;

#define tprintf2( f, s0 ) ( snprintf( CursorMessageBuffer, CMB_SIZE, "%s", (s0) ), tprintfX( (f) ) )
#define tprintf3( f, s0, s1 ) ( snprintf( CursorMessageBuffer, CMB_SIZE, (s0), (s1) ), tprintfX( (f) ) )
#define tprintf4( f, s0, s1, s2 ) ( snprintf( CursorMessageBuffer, CMB_SIZE, (s0), (s1), (s2) ), tprintfX( (f) ) )
#define tprintf5( f, s0, s1, s2, s3 ) ( snprintf( CursorMessageBuffer, CMB_SIZE, (s0), (s1), (s2), (s3) ), tprintfX( (f) ) )
#define tprintf6( f, s0, s1, s2, s3, s4 ) ( snprintf( CursorMessageBuffer, CMB_SIZE, (s0), (s1), (s2), (s3), (s4) ), tprintfX( (f) ) )
#define tprintf7( f, s0, s1, s2, s3, s4, s5 ) ( snprintf( CursorMessageBuffer, CMB_SIZE, (s0), (s1), (s2), (s3), (s4), (s5) ), tprintfX( (f) ) )
#define tprintf8( f, s0, s1, s2, s3, s4, s5, s6 ) ( snprintf( CursorMessageBuffer, CMB_SIZE, (s0), (s1), (s2), (s3), (s4), (s5), (s6) ), tprintfX( (f) ) )
#define tprintf9( f, s0, s1, s2, s3, s4, s5, s6, s7 ) ( snprintf( CursorMessageBuffer, CMB_SIZE, (s0), (s1), (s2), (s3), (s4), (s5), (s6), (s7) ), tprintfX( (f) ) )
#define tprintf10( f, s0, s1, s2, s3, s4, s5, s6, s7, s8 ) ( snprintf( CursorMessageBuffer, CMB_SIZE, (s0), (s1), (s2), (s3), (s4), (s5), (s6), (s7), (s8)), tprintfX( (f) ) )

#endif

