/****************************************************************************************

DataTypes.e -- Copyright (c) by Jay Reynolds Freeman 1987, 1988, 1989, 1990, 1991, 2006

Data management externals, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "DataTypes.h"

extern Boolean validDataType( Tag t );

extern memoryBlockSize lengthTaggedAvalPointer( taggedAval *a );

extern Boolean equalByteBlockString( taggedAval *a, taggedAval *b );
extern Boolean equalByteBlockToString( taggedAval *block, const Text *str );

extern Boolean printAnyTaggedAval( taggedAval *aPort, taggedAval *a );

extern Boolean writeTaggedAvalSafely( taggedAval *value );
extern Boolean writeTaggedAvalSafelyNoScheme( taggedAval *value );

extern void initializeDataTypeList();
extern void initializeDataTypeTable( Boolean describeListP, Boolean describeTableP );

extern UnsignedLongWord describeTaggedAvalPointer( taggedAval *a );
extern UnsignedLongWord printfTaggedAvalPointer( taggedAval *a );
extern UnsignedLongWord getPeculiarNonLeafNumber( taggedAval *a );
extern fileDescriptor *getPortFD( taggedAval *aPort );
extern FILE *getPortFilePointer( taggedAval *aPort );
extern UnsignedLongWord getPortBigArrayLocation( taggedAval *a );
extern UnsignedLongWord getBigArrayLocation( taggedAval *a );
extern UnsignedLongWord getPortKitten( taggedAval *a );
extern LongWord getPeculiarNonLeafKitten( taggedAval *a );
extern memoryBlockSize lengthString( taggedAval *str );
extern memoryBlockSize lengthVector( taggedAval *vec );

extern Text *startString( taggedAval *str );
extern const Text *typeName( Tag tag );
extern Text refString( taggedAval *str, LongWord cursor );

extern void extractByteBlockString();
extern void setString( taggedAval *str, LongWord cursor, Text character );

extern memoryBlockSize noFlip( taggedAval *aTag );
extern void flipTag( Tag *tP );
extern void flipPointer( void **pP );
extern void flipLongWord( LongWord *l );
extern void flipUnsignedLongWord( UnsignedLongWord *l );
extern void flipTaggedAvalOnly( taggedAval *a );
extern void flipShortFloat( taggedAval *aTag );
extern void flipPeculiarNonLeaf( taggedAval *a );
extern memoryBlockSize flipDataItemToBigEndian( taggedAval *a, void *worldEnd, void *world, void *alternateWorld );
extern memoryBlockSize flipDataItemToLittleEndian( taggedAval *a, void *worldEnd, void *world, void *alternateWorld );

extern dataDescriptor 	exactShortFixnum,
                      	forwardingPointer,
			pair,					  
			string,
			character,
			symbol,
			schemeMachinePC;

extern Boolean displaySymbol( taggedAval *aPort );
extern Boolean displaySymbolAndBinding( taggedAval *aPort );

extern Boolean printfSymbol();
extern Boolean printfAnyTaggedAval( FILE *fp, taggedAval *a );

extern Boolean displayByteBlockPointer( taggedAval *a, taggedAval *aPort );
extern Boolean printfPort( taggedAval *thePort, FILE *where, Text *message );

extern Boolean inspectAnyTaggedAval( taggedAval *aPort );

