/****************************************************************************************

Events.h -- Copyright (c) by Jay Reynolds Freeman 2006.

Header file for event stuff in Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#ifndef __EVENT_HEADER__
#define __EVENT_HEADER__

#import "WraithHeader.h"

enum {

/*   0  */    NO_EVENT,
/*   1  */    CONTROL_C_EVENT,
/*   2  */    INITIALIZATION_FINISHED_EVENT,
/*   3  */    WINDOW_CHANGED_EVENT,
/*   4  */    GC_START_EVENT,
/*   5  */    GC_START_EVENT_1,
/*   6  */    GC_START_EVENT_2,
/*   7  */    GC_START_EVENT_3,
/*   8  */    GC_END_EVENT,
/*   9  */    GC_END_EVENT_1,
/*   10 */    GC_END_EVENT_2,
/*   11 */    GC_END_EVENT_3,
/*   12 */    GC_END_EVENT_4,
/*   13 */    GC_END_EVENT_5,
/*   14 */    GC_END_EVENT_6,
/*   15 */    COMPILE_DEFINES_EVENT,
/*   16 */    DO_NOT_COMPILE_DEFINES_EVENT,
/*   17 */    USE_LOW_PRECISION_EVENT,
/*   18 */    USE_HIGH_PRECISION_EVENT,
/*   19 */    START_EVALUATION_EVENT,
/*   20 */    END_EVALUATION_EVENT,
/*   21 */    REQUEST_RESET_EVENT,
/*   22 */    MEMORY_SIZE_EVENT,
/*   23 */    GENERATIONAL_MEMORY_SIZE_EVENT,
/*   24 */    CURRENT_MEMORY_IN_USE_EVENT,
/*   25 */    CURRENT_GENERATIONAL_MEMORY_IN_USE_EVENT,
/*   26 */    TOTAL_MEMORY_IN_USE_EVENT,
/*   27 */    FILE_LOAD_BEGINNING_EVENT,
/*   28 */    FILE_LOAD_SUCCEEDED_EVENT,
/*   29 */    FILE_LOAD_FAILED_EVENT,
/*   30 */    WORLD_LOAD_SUCCEEDED_EVENT,
/*   31 */    WORLD_LOAD_FAILED_EVENT,
/*   32 */    WORLD_SAVE_SUCCEEDED_EVENT,
/*   33 */    PARSER_STATUS_EVENT,
/*   34 */    LIST_PRINT_LENGTH_EVENT,
/*   35 */    LIST_PRINT_DEPTH_EVENT,
/*   36 */    VECTOR_PRINT_LENGTH_EVENT,
/*   37 */    VECTOR_PRINT_DEPTH_EVENT,
/*   38 */    WAKED_UP_EVENT,
/*   39 */    EXPECT_DOUBLE_QUOTE_EVENT,
/*   40 */    EXPECT_RPARENS_EVENT,
/*   41 */    MAKE_FRONT_EVENT,
/*   42 */    INIT_PROGRESS_EVENT,
/*   43 */    INCREMENT_PROGRESS_EVENT,
/*   44 */    WRAPUP_PROGRESS_EVENT,
/*   45 */    SIGUSR1_EVENT,
/*   46 */    SIGALRM_EVENT,
/*   47 */    REQUEST_RESET_EVENT_2,
/*   48 */    REQUEST_RESET_EVENT_3,
/*   49 */    REQUEST_RESET_EVENT_4,
/*   50 */    REINITIALIZATION_COMPLETE,

/*      */    NUMBER_OF_EVENTS
              };

#endif
