/****************************************************************************************

FunctionAndSpecialNames.e -- Copyright (c) by Jay Reynolds Freeman 1990, 1991, 2006

Names of code routines for Wraith functions and special forms.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#ifndef __FASNEXTERNS__
#define __FASNEXTERNS__

extern void
    leafPCode(),
    assocCode(),
    assqCode(),
    assvCode(),
    blockCode(),
    releaseCode(),
    blockSymbolBindingCode(),
    booleanPCode(), 
    boundInstancePCode(),
    boundInstanceInEnvironmentPCode(),
    car(),
    cdr(),
    cadrCode(),
    cddrCode(),
    cdarCode(),
    caarCode(),
    caddrCode(),
    cdddrCode(),
    cdadrCode(),
    caadrCode(),
    cadarCode(),
    cddarCode(),
    cdaarCode(),
    caaarCode(),
    cadddrCode(),
    cddddrCode(),
    cdaddrCode(),
    caaddrCode(),
    cadadrCode(),
    cddadrCode(),
    cdaadrCode(),
    caaadrCode(),
    caddarCode(),
    cdddarCode(),
    cdadarCode(),
    caadarCode(),
    cadaarCode(),
    cddaarCode(),
    cdaaarCode(),
    caaaarCode(),
    clearPermanentCode(),
    closedPortPCode(),
    compileCode(),
    compilingP(),
    cons(),
    cwCCode(),
    eIECode(),
    cwccCode(),
    dECode(),
    dELCode(),
    dDELCode(),
    describeMemoryCode(),
    describeActiveMemoryCode(),
    describeAgingMemoryCode(),
    describeLocksCode(),
    releaseLocksCode(),
    letDeadlockTimeOutCode(),
    describeRoomCode(),
    describeStackCode(),
    displayCode(),
    environmentCode(), 
    topLevelEnvironmentCode(), 
    nullEnvironmentCode(), 
    schemeReportEnvironmentCode(), 
    environmentNDownCode(), 
    environmentRefCode(), 
    topLevelEnvironmentRefCode(), 
    topLevelEnvironmentRefForSymbolCode(), 
    eofPCode(),
    eqPCode(),
    equalPCode(),
    eqvPCode(),
    errorPortCode(),
    kittenBusyCode(),
    inputQueueCode(),
    kittenDequeueCode(),
    kittenEmptyQueueCode(),
    purgeKittenQueueCode(),

    tellKittenCode(),

    expandMacroAux(),
    expandMacroCode(),
    forceCode(),
    forcedPCode(), 
    fullGCType2Code(),
    genSym(),
    getTagCode(),
    hashStringCode(),
    infPCode(), 
    inspectCode(),
    uSleepCode(),
    acosMC(),
    asinMC(),
    addCode(),
    bitAndCode(),
    bitNotCode(),
    bitOrCode(),
    bitXorCode(),
    bitShiftLeftCode(),
    bitShiftRightArithmeticCode(),
    bitShiftRightLogicalCode(),
    ceilingCode(),
    cosMC(),
    complexPCode(),
    divideCode(),
    evenPCode(),
    exptCode(),
    exactPCode(),
    exactToInexactCode(),
    expMC(),
    fixnumPCode(),
    floatPCode(),
    floorCode(),
    GCDCode(),
    inexactPCode(),
    inexactToExactCode(),
    integerPCode(),
    lastPair(),
    lastPairCode(),
    logMC(),
    LCMCode(),
    shortFloatPCode(),
    moduloCode(),
    multiplyCode(),
    numAbsCode(),
    numEqualCode(),
    numGreaterCode(),
    numGreaterEqualCode(),
    numLessCode(),
    numLessEqualCode(),
    numMaxCode(),
    numMinCode(),
    numNegativePCode(),
    numPositivePCode(),
    numberPCode(),
    oddPCode(),
    quotientCode(),
    rationalPCode(),
    realPCode(),
    remainderCode(),
    roundCode(),
    shortFloatPCode(),
    sinMC(),
    sqrtMC(),
    subtractCode(),
    tanMC(),
    truncateCode(),
    zeroPCode(),
    appendCode(),
    listRefCode(),
    listTail(),
    listTailCode(),
    listToVectorCode(),
    loadWorldCode(),
    examineWorldCode(),
    macroPCode(),
    multipleValuesPCode(),
    memberCode(),
    memqCode(),
    memvCode(),
    memvfCode(),
    nanPCode(), 
    newlineCode(),
    notPCode(),
    nullPCode(),
    notNullPCode(),
    pairPCode(),
    permanentPCode(),
    printDepthListGet(),
    printDepthVectorGet(),
    printLengthListGet(),
    printLengthVectorGet(),
    printDepthListSet(),
    printDepthVectorSet(),
    printLengthListSet(),
    printLengthVectorSet(),
    procedurePCode(),
    promisePCode(),
    properListPCode(),
    quitCode(),
    randomCode(), 
    resetCode(),
    saveWorldCode(),
    setBlockedBindingCode(),
    setCarCode(),
    setCdrCode(),
    setPermanentCode(),
    setTagCode(),
    sRandomCode(), 
    stackDepth(),
    stringSymbolCode(),
    symbolPCode(),
    syntaxBindingPCode(),
    lookUp(),
    lookUpInEnvironment(),
    systemCode(),
    tickCode(),
    vectorPCode(),
    vectorFillCode(),
    vectorToListCode(),
    versionGetCode(),
    vRefCode(),
    vSetCode(),
    writeCharCode(),
    writeCode(),
    writeContinuationCode(),
    writeStackCode(),
    charPCode(),
    charAlphaPCode(),
    charLowerPCode(),
    charNumberPCode(),
    charUpperPCode(),
    charWhitespacePCode(),
    charEqualPCode(),
    charGreaterPCode(),
    charGreaterEqualPCode(),
    charLessPCode(),
    charLessEqualPCode(),
    charCIEqualPCode(),
    charCIGreaterPCode(),
    charCIGreaterEqualPCode(),
    charCILessPCode(),
    charCILessEqualPCode(),
    charToIntegerCode(),
    integerToCharCode(),
    callWithInputPortCode(),
    callWithOutputPortCode(),
    charReadyPCode(),
    charUpCaseCode(),
    charDowncaseCode(),
    closePort(),
    currentInputPortCode(),
    currentOutputPortCode(),
    fileExistsPCode(),
    getStartupFolderCode(),
    getWorkingFolderCode(),
    getInitFilePathCode(),
    inputPortPCode(),
    loadCode(),
    numberToStringCode(),
    numberToStringViaSPrintfCode(),
    openInputFileCode(),
    openOutputFileCode(),
    outputPortPCode(),
    peekCharCode(),
    readCode(),
    readCharCode(),
    setInputPortCode(),
    setWorkingFolderCode(),
    transcriptOffCode(),
    transcriptOnCode(),
    withInputFileCode(),
    withOutputFileCode(),
    stringPCode(),
    listToStringCode(),
    stringAppendCode(),
    stringFillCode(),
    stringRefCode(),
    stringSetCode(),
    stringEqualPCode(),
    stringCIEqualPCode(),
    stringGreaterEqualPCode(),
    stringGreaterPCode(),
    stringLessEqualPCode(),
    stringLessPCode(),
    stringCIGreaterEqualPCode(),
    stringCIGreaterPCode(),
    stringCILessEqualPCode(),
    stringCILessPCode(),
    stringToListCode(),
    stringToNumberCode(),
    substringCode(),
    downInFlamesCode(),
    atanCode(),
    forEachCode(),
    makeStringCode(),
    mapCode(),
    makeVectorCode(),
    compilerOnCode(),
    compilerOffCode(),
    fullPrecisionOnCode(),
    fullPrecisionOffCode(),
    compilingPCode(),
    fullPrecisionPCode(),
    momcatPCode(),
    kittenNumberCode(),
    maxKittenNumberCode(),
    showKittensCode(),
    getPIDCode(),
    nonPrintingObjectPCode(),

    beginEvalCode(),
    compiledBlockEvalCode(),
    cSetBangEvalCode(),
    defineEvalCode(),
    ifAuxCode(),
    if3EvalCode(),
    lambdaEvalAux(),
    lambdaEvalCode(),
    macroBodyAux(),
    macroBodyCode(),
    macroEvalAux(),
    macroEvalCode(),
    quoteSimpleEvalCode(),
    quoteEvalCode(),
    setBangEvalCode(),

    socketCreateAndListen(),
    socketAccept(),
    socketWrite(),
    openInputSocketCode(),
    socketFGets(),

    return90PercentFlagOp(),
    disableConsoleOutputCode(),
    enableConsoleOutputCode(),
    consoleOutputEnabledPCode(),
    kittenResetCode(),
    makeForgettableCode(),
    forgettablePCode(),
    forgettableForgottenPCode(),
    forgettableRememberedPCode(),
    forgettableUnexpiredPCode(),
    forgettableObjectCode(),
    forgettableTimeCode(),
    forgettableRememberProbabilityCode(),
    setForgettableTimeCode(),
    setForgettableRememberProbabilityCode(),
    makeMMappedBlockCode(),
    mmapBlockInCurrentKittenCode(),
    getMMappableSpaceCode(),
    peek8Code(),
    peek8SignExtendCode(),
    peek8VectorCode(),
    peek8VectorSignExtendCode(),
    poke8Code(),
    poke8VectorCode(),
    peek16Code(),
    peek16SignExtendCode(),
    peek16VectorCode(),
    peek16VectorSignExtendCode(),
    poke16Code(),
    poke16VectorCode(),
    peek32Code(),
    peek32SignExtendCode(),
    peek32VectorCode(),
    peek32VectorSignExtendCode(),
    poke32Code(),
    poke32VectorCode(),
    peek64Code(),
    peek64VectorCode(),
    poke64Code(),
    poke64VectorCode(),
    peekFlonumCode(),
    pokeFlonumCode(),
    peekFlonumVectorCode(),
    pokeFlonumVectorCode(),
    peekCStringCode(),
    pokeCStringCode(),
    memoryMappedBlockPCode(),
    interruptVectorRegisterCode(),
    setInterruptCode(),
    clearInterruptCode(),
    interruptCode(),
    getInterruptFileInformationCode(),
    loadFromStringCode(),
    makeStringWithPromptCode(),
    peekPokeAtomicCode(),
    blockAnyBindingCode(),
    cBooleanToSchemeBooleanCode(),
    schemeBooleanToCBooleanCode(),
    setAlarmCode(),
    alarmPCode(),
    alarmTimeCode(),
    clearInterruptRequestedCode(),
    setSenseLightNIlluminationCode(),
    setSenseLightNVisibilityCode(),
    senseLightPCode(),
    senseLightIlluminationPCode(),
    showSenseLightsCode(),
    hideSenseLightsCode(),
    setSenseLightsOffCode(),
    setSenseLightIlluminationsCode(),
    rotateSenseLightsCode(),
    applicativeModeCheckSetBangCode(),
    applicativeModeCheckCode(),
    applicativeBitPCode(),
    setApplicativeBitCode(),
    setApplicativeBitNDownCode(),
    clearApplicativeBitCode(),
    cSetTagCode(),
    clearApplicativeBitNDownCode(),
    senseSwitchesCode(),
    sliderCode(),
    enablePushbuttonCode(),
    pushbuttonInterruptNumberCode(),
    disablePushbuttonCode(),
    enableBigRedButtonCode(),
    bigRedButtonInterruptNumberCode(),
    disableBigRedButtonCode(),
    pushbuttonEnabledCode(),
    bigRedButtonEnabledCode(),
    setLevelIndicatorCode()
    ;

#endif
