/****************************************************************************************

LowLevelIO.e -- Copyright (c) by Jay Reynolds Freeman 2006

Low-level I/O externals, for Wraith Scheme.  There is no specific matching
".c" file for these externals; rather, *any* module that provides
low-level I/O (e.g., via direct use of stdin and stdout or by "curses",
must provide the functions declared here as externals.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "LocalTypes.h"

#ifdef USE_TTY_IO

#import "TTYIO.h"

#endif

#ifdef USE_CURSES_IO

#import "CursesIO.h"

#endif

#ifdef USE_COCOA_IO

#import "CocoaIO.h"

#endif

extern void clearNostalgiaMode();
extern void setNostalgiaMode();
extern Boolean emitStatusMessage( const Text *msg );
extern Boolean performDialogAndReturnString( const Text *prompt, Text *result, UnsignedWord resultLength );

extern void initializeLowLevelIO();
extern void reinitializeLowLevelIO( Text *reinitializationAction );
extern void cleanUpLowLevelIO();
extern void dealWithResize();
extern void fatalErrorWithText( Text *fatalErrorMessage );
extern void fatalError( UnsignedLongWord n );
extern void useFatalErrorOutput();

extern void switchToSystemIO();
extern void switchFromSystemIO();

extern Word tgetchar();
extern void untgetchar( Text c );
extern Boolean tcharreadyConsole();
extern void tfflushConsoleInput();

