/****************************************************************************************

Reader.h -- Copyright (c) by Jay Reynolds Freeman 1987, 1988, 1989, 1990, 1991, 2006

Header file for the reader typedefs and macros used in Wraith.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "SchemeCType.h"

/******** Typedefs: ********/

typedef enum {
	EOF_TYPE,
	INITIAL_TYPE,
	PECULIAR_NON_POINT_TYPE, 
	SHARP_TYPE, 
	DOUBLE_QUOTE_TYPE, 
	DIGIT_10_TYPE,
	DELIMITER_TYPE,
	POINT_TYPE,
	WEIRD_TYPE,
	BAD_FIRST_CHARACTER_TYPE 
	} FirstType;
	
typedef enum {
	LEX_EOF,
	LEX_IDENTIFIER,
	LEX_BOOLEAN,
	LEX_NUMBER,
	LEX_CHARACTER,
	LEX_STRING,
	LEX_DELIMITER,
	LEX_VECTOR,
	LEX_CONS_DOTTER,
    LEX_LOGIC,
    LEX_NON_PRINTING,
	BAD_LEXTYPE
	} LexType;

#define MAX_ATOM_SIZE	    ((UnsignedLongWord)1024)
#define MAX_NUMBER_SIZE	    ((UnsignedLongWord)128)


