/****************************************************************************************

Registers.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006, 2008

SECD machine register externals, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "DataTypes.h"

/* Non-simple registers, declared elsewhere, included here commented out as a reminder ... */

// extern taggedAval ObList;               /* oblist */  // Made a global, see Register.h and Clowder stuff.
// extern taggedAval TopLevelE;            // Made a global, see Register.h and Clowder stuff.
// extern taggedAval IVR;                  // Made a global, see Register.h and Clowder stuff.
// extern taggedAval TLC;                  /* TopLoopCode */  // Made a global, see Register.h and Clowder stuff.
// extern taggedAval KIQ;                  /* Kitten Input Queue */  // Made a global, see Register.h and Clowder stuff.

/* main SEC(no more D) machine registers */

extern taggedAval *S;
extern taggedAval  E;

/* other registers */

extern taggedAval R;			/* convention -- return results here */
extern taggedAval A;
extern taggedAval CurrentInputPort;
extern taggedAval CurrentOutputPort;
extern taggedAval ErrorPort;
extern taggedAval SavedE;		/* for macro expansion */
extern taggedAval *F;
extern taggedAval L;			/* current lambda, if any */

extern taggedAval DefaultInputPort;
extern taggedAval MasterDefaultInputPort;
extern taggedAval TranscriptPort;

extern taggedAval *CS, *CF;
// extern taggedAval NArgs, ArgCounter;

extern Text *FrameName;

extern Boolean B;

extern UnsignedLongWord ESR;
