/****************************************************************************************

SECD.h -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006, 2007.

Header file for stuff used in the SECD Machine files, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "WraithHeader.h"

#define HASH_MULTIPLIER          37
//#define SYMBOL_HASH_CONSTANT   4096           // Must be a multiple of the number of bits in a byte, assumed to be 8.
#define SYMBOL_HASH_CONSTANT  16384           // Must be a multiple of the number of bits in a byte, assumed to be 8.
#define SYMBOL_HASH_BYTE_FOR_BIT( n )         ((n) >> 3)
#define SYMBOL_HASH_BIT_IN_BYTE( n )          ((n) & 0x7)
#define SYMBOL_HASH_WORD_FOR_BIT( n )         (TLEBinLockBits[ (n) >> 5 ])
#define SYMBOL_HASH_BIT_LOCATION_IN_WORD( n ) ((n) && 0x1f)
#define SYMBOL_HASH_BIT_IN_WORD( w, l )       (((w) >> (l)) & 1)
#define SYMBOL_HASH_BIT( n )                  (SYMBOL_HASH_BIT_IN_WORD( SYMBOL_HASH_WORD_FOR_BIT( n ), SYMBOL_HASH_BIT_LOCATION_IN_WORD( n ) ))

#define NUMBER_OF_INTERRUPTS 1024

#define infFloatP( x ) (fpclassify( (x) ) == FP_INFINITE)
#define nanFloatP( x ) (fpclassify( (x) ) == FP_NAN)
#define nanOrInfFloatP( x ) ( nanFloatP( x ) || infFloatP( x ) )

#define infShortFloatP( x ) infFloatP( x )
#define nanShortFloatP( x ) nanFloatP( x )
#define nanOrInfShortFloatP( x ) nanOrInfFloatP( x )

