/****************************************************************************************

SECDFloatStuff.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

SECD machine floating-point op code and static externals, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "DataTypes.h"

extern LongWord coerceToShortFixnum( taggedAval x );

extern ShortFloat coerceToShortFloat( taggedAval *x );
extern ShortFloat  coerceToShortFloat( taggedAval *x );

extern void acosMC(),
            asinMC(),
            atanMC(),
            atan2MC(),
            ceilingMC(),
            cosMC(),
            expMC(),
            exptMC(),
            floorMC(),
            logMC(),
            roundMC(),
            sinMC(),
            sqrtMC(),
            tanMC(),
            truncateMC();

extern void add(),
            subtract(), 
            multiply(),
            divide(),
            quotient2(),
            remainder2();

extern void coerceRToShortFixnum(),
            coerceRToShortFloat(),
            coerceS0ToShortFixnum(),
            coerceS0ToShortFloat(),
            rangeCheckAsSignedFixnumMC(),
            rangeCheckAsUnsignedFixnumMC();

extern Boolean coerceRToShortFixnumIfPossible();

extern void infPMC(),
            nanPMC(),
            nanOrInfPMC();

extern void gcdMC(),
            lcmMC();

extern void stupidDummyFunction( taggedAval *port, const Text *dummy, LongWord n );

