/****************************************************************************************

SECDMachine.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

SECD machine op code and static externals, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "DataTypes.h"

/**** handy statics ****/

extern void initializeSpecialTags();

/**** Booleans that are useable only as "microcode" ****/
/**** Also see the boolean inlines in "WraithConsts.h". ****/

extern void eqPMC();
extern void equalPMC();
extern void eqvPMC();
extern void evenPMC();
extern void exactIntegerPMC();
extern void integerPMC();
extern void letterPMC();
extern void nonPrintingObjectPMC();
extern void nonNegativeIntegerPMC();
extern void numEqualPMC();
extern void numGreaterPMC();
extern void numGreaterEqualPMC();
extern void numLessPMC();
extern void numLessEqualPMC();
extern void oddPMC();
extern void positiveIntegerPMC();
extern void procedurePMC();
extern void properListPMC();
extern void radixPMC();
extern void kittenRangeCheckPMC();
extern void interruptRangeCheckPMC();
extern void sliderNumberRangeCheckPMC();
extern void pushbuttonNumberRangeCheckPMC();
extern void levelIndicatorNumberRangeCheckPMC();
extern void levelIndicatorValueRangeCheckPMC();
extern void reverseTopN();
extern void emptyListPMC();

extern void shortFixnumPMC();

/**** End Booleans ****/

extern UnsignedLongWord lengthFunction();

extern void bitAnd();
extern void bitNot();
extern void bitOr();
extern void bitXor();
extern void bitShiftLeft();
extern void bitShiftRightArithmetic();
extern void bitShiftRightLogical();
extern void car();
extern void carCdrMixForCSPushProperList();
extern void carRegardlessOfBlocking();
extern void cdr();
extern void cdrRegardlessOfBlocking();
extern void charIsAlphaPMC();
extern void charIsLowerPMC();
extern void charIsNumericPMC();
extern void charIsUpperPMC();
extern void charIsWhitespacePMC();
extern void charToLower();
extern void charToUpper();
extern void cons();
extern void coerceRToShortFixnum();
extern void coerceS0ToShortFixnumPMC();
extern void dereferenceAddressMC();
extern void dereferenceEnvironmentReferenceMC();
extern void dereferenceStackReferenceMC();
extern void dereferenceTopLevelEnvironmentReferenceMC();
extern void dereferenceTopLevelEnvironmentReferenceForSymbolMC();
extern void describeCurrentMainSpace();
extern void describeRoomOp();
extern void displayObject();
extern void displayObjectOnPort();
extern void dropNFromStack();
extern void genSymMC();
extern void getHashValue();
extern void getPortBigArrayNumberMC();
extern void getPeculiarNonLeafNumberMC();
extern void getBigArrayNumberMC();
extern void getPName();
extern void getBlockedPName();
extern void getSymbolBindingValue();
extern void getSymbolValue();
extern void getSymbolValueNoCheck();
extern void hashString();
extern void hashText();
extern void inspectObject();
extern void inspectObjectOnPort();
extern void lengthOp();
extern void listTopN();
extern void makeImmutable();
extern void makeString( const Text *str );
extern void makeStringNEmpty( UnsignedLongWord n );
extern void numberToStringMC();
extern void nilCons();
extern void pushListOnStack();
extern void peekLoop();
extern void quotient1();
extern void rebindForce();
extern void remainder1();
extern void resetScheme();
extern void resetSchemeFinal();
extern void resetEverybody();
extern void returnRoomOp();
extern void returnActiveRoomOp();
extern void returnAgingRoomOp();
extern void returnStoreSizeOp();
extern void returnActiveStoreSizeOp();
extern void return90PercentFlagOp();
extern void setCar();
extern void setCarWithPairAlreadyBlockedKeepBlock();
extern void setCdr();
extern void setUpApply();
extern void stringAppend();
extern void stringCopy();
extern void stringEqual();
extern void stringEqualCI();
extern void stringInsert();
extern void stringLength();
extern void stringLengthMany();
extern void stringRef();
extern void stringSet();
extern void stringToLower();
extern void stringToNumber();
extern void stringToUpper();
extern void stringGreaterEqualPMC();
extern void stringGreaterPMC();
extern void stringLessEqualPMC();
extern void stringLessPMC();
extern void stringGreaterEqualCIPMC();
extern void stringGreaterCIPMC();
extern void stringLessEqualCIPMC();
extern void stringLessCIPMC();
extern void stringEqualsTextPMC();
extern void substring();
extern void useErrorOutput();
extern void useFatalErrorOutput();
extern void vectorLength();
extern void vectorRef();
extern void vectorRefN( LongWord n );
extern void vectorSet();
extern void writeChar();
extern void writeCharOnPort();
extern void writeObject();
extern void writeObjectOnPort();
extern void writeStack();
extern void executeBoundSymbol( const Text *nonHeapSymbolName );

extern Boolean portableP( taggedAval *tp );
extern UnsignedLongWord calculatePortableObjectSize();
