/****************************************************************************************

SECDRegisters.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

SECD register externals, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "DataTypes.h"

extern void saveStack(),
            restoreFrame(),
            restoreStack(),
            restoreStackAndFrame(),
            stackDepth(),
            stackUnZap();

extern void nilConsPush(),
            SDropFunction(),
            SPopEFunction(),
            SPopRFunction(),
            SPushFunction(),
            Swap(),
            SwapCons(),
            popToEFunction();

extern void CDropFunction(),
            CPopRFunction(),
            CPushFunction(),
            ClearLFunction();

extern void initializeMachine(),
            reinitializeMachine(), 
            resetScheme();

extern void restoreContinuation();
extern void restoreContinuationAndFrame();
extern void saveContinuation();
extern void saveForCWCC();
extern void restoreForCWCC();
extern void displayFrame( Text *message );
extern void CSPushProperList();

extern LongWord lengthOfC();
extern LongWord lengthOfCFrame();
extern void compareContinuations( Text *msg, Boolean forceP );
extern void CSPushProperList();
extern void describeCurrentCFrame( Text *msg );
extern void compareFirstContinuationObjects( Text *msg );

extern void MakeRTrueFunction();

extern taggedAval spliceOutNotCarForwardingPointers( taggedAval x );
extern taggedAval *spliceOutNotCarForwardingPointersIndirect( taggedAval *xp );

extern void exchangeFunction( taggedAval *foo, taggedAval *bar );

extern Boolean applicativeModeP();
extern Boolean applicativeModeNDown( UnsignedLongWord N );
extern Boolean applicativeModeOneDown();
extern void setApplicativeModeNDown( UnsignedLongWord N );
extern void clearApplicativeModeNDown( UnsignedLongWord N );

extern UnsignedLongWord senseSwitchPositions;
extern UnsignedLongWord sliderValues[ N_SLIDERS ];

extern UnsignedLongWord pushbuttonInterruptNumbers[ N_PUSHBUTTONS ];
extern Boolean pushbuttonEnabled[ N_PUSHBUTTONS ];

extern UnsignedLongWord bigRedButtonInterruptNumber;
extern Boolean bigRedButtonEnabled;
