/****************************************************************************************

SchemeAux.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

Externals for the auxiliary scheme functions, for Wraith Scheme.  Every function in
"SchemeAux.c" should be mentioned here.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#ifndef __SCHEMEAUX_EXTERNS__
#define __SCHEMEAUX_SEXTERNS__

extern void copyList(),
            copyListWithLength(),
            displayLambdaNameOnDefaultPort(),
            displayLambdaSourceOnDefaultPort(),
            displayMacroSourceOnDefaultPort(),
            debugCode(),
            lambdaBodyCheck(),
            lambdaListCheck(),
            lastPair(),
            lastPairDangerous(),
            listTail(),
            loadDFromR(),
            makeExactShortFixnum(),
//            makeExactShortFloat(),
//            makeInexactShortFloat(),
            makeVectorAndStuff(),
            makeVectorAndStuffFromStack(),
            makeVectorOfSharpF(),
            noop(),
            properListCheck(),
            reverseListCode(),
            stringFillAux(),
            S0toC(),
            vectorFillAux();

/**** Booleans (that are CALLable) ****/

extern void alwaysFalse();
extern void alwaysTrue();
extern void booleanP();
extern void builtInFunctionP();
extern void byteBlockP();
extern void carEqP();
extern void carEqualP();
extern void carEqvP();
extern void characterP();
extern void charAlphaP();
extern void charLowerP();
extern void charNumericP();
extern void charUpperP();
extern void charWhitespaceP();
extern void complexP();
extern void emptyListP();
extern void environmentReferenceP();
extern void exactIntegerP();
extern void exactP();
extern void exactShortFloatP();
extern void exactShortFixnumP();
extern void failP();
extern void falseP();
extern void fixnumP();
extern void floatP();
extern void forgettableP();
extern void forgettableForgottenP();
extern void forgettableRememberedP();
extern void forgettableUnexpiredP();
extern void forwardingPointerP();
extern void ggcForwardingPointerP();
extern void inexactShortFloatP();
extern void inexactShortFixnumP();
extern void inexactP();
extern void infP();
extern void inputPortP();
extern void integerP();
extern void interruptRangeCheckP();
extern void kittenRangeCheckP();
extern void lambdaPairP();
extern void letterP();
extern void listP();
extern void levelIndicatorNumberRangeCheckP();
extern void levelIndicatorValueRangeCheckP();
extern void properListP();
extern void longP();
extern void macroP();
extern void mmappedBlockP();
extern void multipleValuesP();
extern void nanP();
extern void nanOrInfP();
extern void nonLeafP();
extern void nonNegativeIntegerP();
extern void numberP();
extern void outputPortP();
extern void pairP();
extern void peculiarLeafP();
extern void peculiarNonLeafP();
extern void pointerToByteBlockP();
extern void portP();
extern void positiveIntegerP();
extern void probabilityP();
extern void procedureP();
extern void promiseP();
extern void radixP();
extern void rangeCheckAsSignedFixnumP();
extern void rangeCheckAsUnsignedFixnumP();
extern void rationalP();
extern void realP();
extern void schemeMachinePCP();
extern void schemeMachinePCIndexP();
extern void senseLightP();
extern void senseLightIlluminationP();
extern void sharpFOrProperListP();
extern void shortFixnumP();
extern void sliderNumberRangeCheckP();
extern void pushbuttonNumberRangeCheckP();
extern void specialFormP();
extern void stackReferenceP();
extern void stringP();
extern void succeedP();
extern void symbolP();
extern void syntaxBindingP();
extern void topLevelEnvironmentReferenceP();
extern void trueP();
extern void vectorP();

#endif

