/****************************************************************************************

SchemeFunctionsExterns.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

Scheme built-in function code for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "SchemeFunctions.h"

extern functionDescriptorTypeOne
    leafPFD,
    assocFD,
    assqFD,
    assvFD,
    blockFD,
    releaseFD,
    blockSymbolBindingFD,
    setBlockedBindingFD,
    booleanPFD,
    boundInstancePFD,
    boundInstanceInEnvironmentPFD,
    carFD, cdrFD,
    cadrFD, cddrFD, caarFD, cdarFD,
    caddrFD, cdddrFD, caadrFD, cdadrFD, cadarFD, cddarFD, caaarFD, cdaarFD,
    cadddrFD, cddddrFD, caaddrFD, cdaddrFD, cadadrFD, cddadrFD, caaadrFD, cdaadrFD,
    caddarFD, cdddarFD, caadarFD, cdadarFD, cadaarFD, cddaarFD, caaaarFD, cdaaarFD,
    clearPermanentFD,
    closedPortPFD,
    compileCodeFD,
    ccompilingPFD,
    consFD,
    cwCFD,
    eIEFD,
    cwccFD,
    dEFD,
    dELFD,
    dDELFD,
    dereferenceAddressFD,
    describeMemoryFD,
    describeActiveMemoryFD,
    describeAgingMemoryFD,
    describeLocksFD,
    releaseLocksFD,
    letDeadlockTimeOutFD,
    describeRoomFD,
    describeStackFD,
    environmentFD,
    topLevelEnvironmentFD,
    nullEnvironmentFD,
    schemeReportEnvironmentFD,
    environmentNDownFD,
    environmentRefFD,
    topLevelEnvironmentRefFD,
    topLevelEnvironmentRefForSymbolFD,
    eofPFD,
    eqPFD,
    equalPFD,
    eqvPFD,
    expandMacroFD,
    forceFD, 
    forcedPFD,
    fullGC2FD,
    genSymFD,
    getTagFD,
    hashStringFD,
    infPFD,
    momcatPFD,
    kittenNumberFD,
    maxKittenNumberFD,
    showKittensFD,
    getPIDFD,
    makeMMappedBlockFD,
    mmapBlockInCurrentKittenFD,
    uSleepFD,
    compilerOnFD,
    compilerOffFD,
    fullPrecisionOnFD,
    fullPrecisionOffFD,
    compilingPFD,
    fullPrecisionPFD,
    getMMappableSpaceFD,
    acosFD,
    asinFD,
    bitAndFD,
    bitNotFD,
    bitOrFD,
    bitXorFD,
    bitShiftLeftFD,
    bitShiftRightArithmeticFD,
    bitShiftRightLogicalFD,
    ceilingFD,
    complexPFD,
    cosFD,
    evenPFD,
    exactPFD,
    expFD,
    exptFD,
    exactToInexactFD,
    fixnumPFD,
    floatPFD, 
    floorFD,
    GCDFD,
    inexactPFD,
    inexactToExactFD,
    integerPFD,
    LCMFD,
    logFD,
    shortFloatPFD,
    moduloFD,
    numberPFD,
    numAbsFD, 
    numNegativePFD, 
    numPositivePFD,
    oddPFD,
    quotientFD,
    rationalPFD,
    realPFD,
    remainderFD,
    roundFD, 
    shortFloatPFD,
    sinFD,
    sqrtFD,
    tanFD,
    truncateFD,
    zeroPFD,
    lastPairFD, 
    lengthFD,
    listRefFD, 
    listTailFD,
    listToVectorFD,
    macroPFD,
    memberFD,
    memqFD, 
    memvFD,
    nanPFD,
    notPFD,
    nullPFD, 
    notNullPFD, 
    pairPFD,
    permanentPFD,
    printDepthListGetFD,
    printDepthVectorGetFD,
    printLengthListGetFD,
    printLengthVectorGetFD,
    printDepthListSetFD,
    printDepthVectorSetFD,
    printLengthListSetFD,
    printLengthVectorSetFD,
    promisePFD,
    properListPFD,
    procedurePFD,
    randomFD,
    quitFD,
    resetFD,
    returnRoomFD,
    returnActiveRoomFD,
    returnAgingRoomFD,
    returnStoreSizeFD,
    returnActiveStoreSizeFD,
    return90PercentFlagFD,
    reverseFD,
    setCarFD,
    setCdrFD,
    setPermanentFD,
    setTagFD,
    sRandomFD,
    stackDepthFD,
    stringSymbolFD,
    multipleValuesPFD, 
    syntaxBindingPFD, 
    symbolPFD, 
    symbolStringFD,
    symevalFD,
    symevalInEnvironmentFD,
    systemFD,
    tickFD,
    vectorPFD,
    vectorFillFD,
    vectorToListFD,
    versionGetFD,
    vLengthFD, 
    vRefFD,
    vSetFD,
    writeContinuationFD,
    writeStackFD,
    charPFD,
    charAlphaPFD,
    charLowerPFD,
    charNumberPFD,
    charUpperPFD,
    charWhitespacePFD,
    charEqualPFD,
    charGreaterPFD,
    charGreaterEqualPFD, 
    charLessPFD,
    charLessEqualPFD,
    charCIEqualPFD,
    charCIGreaterPFD,
    charCIGreaterEqualPFD,
    charCILessPFD,
    charCILessEqualPFD,
    charToIntegerFD,
    integerToCharFD,
    charUpcaseFD,
    charDowncaseFD,
    closeInputPortFD,
    closeOutputPortFD,
    currentInputPortFD,
    currentOutputPortFD,
    errorPortFD,
    fileExistsPFD,
    getStartupFolderFD,
    getWorkingFolderFD,
    getInitFilePathFD, 
    inputPortPFD,
    kittenBusyFD,
    inputQueueFD,
    kittenEmptyQueueFD,
    outputPortPFD,
    purgeKittenQueueFD,
    transcriptOffFD,
    tellKittenFD,
    socketCreateAndListenFD,
    socketAcceptFD,
    socketWriteFD,
    openInputSocketFD,
    socketFGetsFD,
    disableConsoleOutputFD,
    enableConsoleOutputFD,
    consoleOutputEnabledPFD,
    kittenResetFD,
    stringPFD, 
    listToStringFD,
    numberToStringFD,
    numberToStringWithCFormatFD,
    stringCopyFD,
    stringFillFD,
    downInFlamesFD,
    stringLengthFD,
    stringRefFD,
    stringSetFD,
    stringEqualPFD,
    stringCIEqualPFD,
    stringGreaterEqualPFD,
    stringGreaterPFD,
    stringLessEqualPFD,
    stringLessPFD,
    stringCIGreaterEqualPFD,
    stringCIGreaterPFD,
    stringCILessEqualPFD,
    stringCILessPFD,
    stringToListFD,
    stringToNumberFD,
    substringFD,
    makeForgettableFD,
    forgettablePFD,
    forgettableForgottenPFD,
    forgettableRememberedPFD,
    forgettableUnexpiredPFD,
    forgettableObjectFD,
    forgettableTimeFD,
    forgettableRememberProbabilityFD,
    setForgettableTimeFD,
    setForgettableRememberProbabilityFD,
    peek8FD,
    poke8FD,
    peek8SignExtendFD,
    peek8VectorFD,
    peek8VectorSignExtendFD,
    poke8VectorFD,
    peek16FD,
    poke16FD,
    peek16SignExtendFD,
    peek16VectorFD,
    peek16VectorSignExtendFD,
    poke16VectorFD,
    peek32FD,
    poke32FD,
    peek32SignExtendFD,
    peek32VectorFD,
    peek32VectorSignExtendFD,
    poke32VectorFD,
    peek64FD,
    poke64FD,
    peek64VectorFD,
    poke64VectorFD,
    peekFlonumFD,
    pokeFlonumFD,
    peekFlonumVectorFD,
    pokeFlonumVectorFD,
    peekCStringFD,
    pokeCStringFD,
    memoryMappedBlockPFD,
    interruptVectorRegisterFD,
    setInterruptFD,
    clearInterruptFD,
    interruptFD,
    getInterruptFileInformationFD,
    loadFromStringFD,
    makeStringWithPromptFD,
    peekPokeAtomicFD,
    blockAnyBindingFD,
    cBooleanToSchemeBooleanFD,
    schemeBooleanToCBooleanFD,
    setAlarmFD,
    alarmPFD,
    alarmTimeFD,
    clearInterruptRequestedFD,
    nonPrintingObjectPFD,
    senseLightPFD,
    senseLightIlluminationPFD,
    setSenseLightNIlluminationFD,
    setSenseLightNVisibilityFD,
    showSenseLightsFD,
    hideSenseLightsFD,
    setSenseLightsOffFD,
    setSenseLightIlluminationsFD,
    rotateSenseLightsFD,
    applicativeModeCheckSetBangFD,
    applicativeModeCheckFD,
    applicativeBitPFD,
    setApplicativeBitFD,
    setApplicativeBitNDownFD,
    clearApplicativeBitFD,
    cSetTagFD,
    clearApplicativeBitNDownFD,
    senseSwitchesFD,
    sliderFD,
    enablePushbuttonFD,
    pushbuttonInterruptFD,
    disablePushbuttonFD,
    enableBigRedButtonFD,
    bigRedButtonInterruptFD,
    disableBigRedButtonFD,
    pushbuttonEnabledFD,
    bigRedButtonEnabledFD,
    setLevelIndicatorFD
    ;

extern functionDescriptorTypeFive
    addFD,
    multiplyFD,
    numEqualPFD,
    numGreaterPFD,
    numGreaterEqualPFD,
    numLessPFD, 
    numLessEqualPFD,
    numMaxFD,
    numMinFD,
    listFD,
    vectorFD,
    stringAppendFD
    ;

extern functionDescriptorTypeSix
    displayFD,
    inspectFD,
    divideFD,
    subtractFD,
    writeCharFD,
    writeFD,
    atanFD,
    makeStringFD,
    makeVectorFD
    ;

extern functionDescriptorTypeSeven
    examineWorldFD,
    loadWorldFD,
    newlineFD,
    saveWorldFD,
    charReadyPFD,
    loadFD,
    openInputFileFD,
    openOutputFileFD,
    peekCharFD,
    readFD,
    readCharFD,
    setWorkingFolderFD,
    setInputPortFD,
    transcriptOnFD,
    applyFD,
    forEachFD,
    mapFD,
    mapNoTypeCheckingFD
    ;

extern functionDescriptorTypeEight
    appendFD,
    callWithInputPortFD,
    callWithOutputPortFD,
    withInputFileFD,    
    withOutputFileFD
    ;

extern void expandMacroAux();
extern short appVRefNum;
extern void doInitWDCode();
extern void assertFileLoadSucceeded();
extern Text lastFileLoadedName[];
extern void loadCode();
