/****************************************************************************************

SchemeFunctionStatics.h -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

Header file for the Scheme built-in functions' special statics used in Wraith.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#ifndef __SCHEMEFUNCTIONSTATICS__
#define __SCHEMEFUNCTIONSSTATICS__

/******** non-specific statics ********/

extern void (*anyAnyChecker[2])();
extern void (*anyChecker[1])();
extern void (*anyIntegerProbabilityChecker[3])();
extern void (*anyListChecker[2])();
extern void (*anyNumberChecker[2])();
extern void (*anyProperListChecker[2])();
extern void (*anyTypeBinaryChecker[2])();
extern void (*charBinaryChecker[2])();
extern void (*charChecker[1])();
extern void (*eRefChecker[1])();
extern void (*exactIntegerChecker[1])();
extern void (*forgettableChecker[1])();
extern void (*forgettableIntegerChecker[2])();
extern void (*forgettableProbabilityChecker[2])();
extern void (*inputPortChecker[1])();
extern void (*integerChecker[1])();
extern void (*integerNonNegativeIntegerChecker[2])();
extern void (*integerStringChecker[2])();
extern void (*interruptChecker[1])();
extern void (*interruptKittenAnyChecker[3])();
extern void (*kittenAnyChecker[2])();
extern void (*kittenChecker[1])();
extern void (*kittenInterruptChecker[2])();
extern void (*lambdaPairChecker[1])();
extern void (*letterChecker[1])();
extern void (*levelIndicatorNumberValueChecker[2])();
extern void (*listChecker[1])();
extern void (*listIntegerChecker[2])();
extern void (*macroChecker[1])();
extern void (*mmapBlockChecker[1])();
extern void (*mmapBlockUnsigned[2])();
extern void (*mmapBlockUnsignedInteger[3])();
extern void (*mmapBlockUnsignedNumber[3])();
extern void (*mmapBlockUnsignedString[3])();
extern void (*mmapBlockUnsignedVector[3])();
extern void (*nonLeafChecker[1])();
extern void (*nonNegativeIntegerChecker[1])();
extern void (*numberBinaryChecker[2])();
extern void (*numberChecker[1])();
extern void (*numberPairChecker[2])();
extern void (*outputPortChecker[1])();
extern void (*pairAnyChecker[2])();
extern void (*pairChecker[1])();
extern void (*positiveIntegerStringChecker[2])();
extern void (*probabilityChecker[1])();
extern void (*procedureChecker[1])();
extern void (*promiseChecker[1])();
extern void (*properListChecker[1])();
extern void (*pushbuttonChecker[1])();
extern void (*pushbuttonInterruptChecker[2])();
extern void (*realChecker[1])();
extern void (*senseLightBooleanChecker[2])();
extern void (*senseLightIlluminationChecker[1])();
extern void (*senseLightSenseLightIlluminationChecker[2])();
extern void (*signedFixnumBinaryChecker[2])();
extern void (*signedFixnumChecker[1])();
extern void (*signedFixnumUnsignedFixnumChecker[2])();
extern void (*sliderChecker[1])();
extern void (*stringBinaryChecker[2])();
extern void (*stringCharChecker[2])();
extern void (*stringChecker[1])();
extern void (*stringIntegerCharChecker[3])();
extern void (*stringIntegerChecker[2])();
extern void (*stringIntegerIntegerChecker[3])();
extern void (*stringNonNegativeIntegerCharChecker[3])();
extern void (*stringNonNegativeIntegerChecker[2])();
extern void (*stringNonNegativeIntegerNonNegativeIntegerChecker[3])();
extern void (*stringSymbolSymbolChecker[3])();
extern void (*symbolChecker[1])();
extern void (*symbolPairChecker[2])();
extern void (*topLevelERefChecker[1])();
extern void (*unsignedFixnumBinaryChecker[2])();
extern void (*unsignedFixnumChecker[1])();
extern void (*unsignedFixnumSignedFixnumChecker[2])();
extern void (*vectorAnyChecker[2])();
extern void (*vectorChecker[1])();
extern void (*vectorIntegerAnyChecker[3])();
extern void (*vectorIntegerChecker[2])();

extern const Text *anyAnyCheckerNames[2];
extern const Text *anyCheckerNames[1];
extern const Text *anyIntegerProbabilityCheckerNames[3];
extern const Text *anyListCheckerNames[2];
extern const Text *anyNumberCheckerNames[2];
extern const Text *anyProperListCheckerNames[2];
extern const Text *anyTypeBinaryCheckerNames[2];
extern const Text *charBinaryCheckerNames[2];
extern const Text *charCheckerNames[1];
extern const Text *eRefCheckerNames[1];
extern const Text *exactIntegerCheckerNames[1];
extern const Text *forgettableCheckerNames[1];
extern const Text *forgettableIntegerCheckerNames[2];
extern const Text *forgettableProbabilityCheckerNames[2];
extern const Text *inputPortCheckerNames[1];
extern const Text *integerCheckerNames[1];
extern const Text *integerNonNegativeIntegerCheckerNames[2];
extern const Text *integerStringCheckerNames[2];
extern const Text *interruptCheckerNames[1];
extern const Text *interruptKittenAnyCheckerNames[3];
extern const Text *kittenAnyCheckerNames[2];
extern const Text *kittenCheckerNames[1];
extern const Text *kittenInterruptCheckerNames[2];
extern const Text *lambdaPairCheckerNames[1];
extern const Text *letterCheckerNames[1];
extern const Text *levelIndicatorNumberValueCheckerNames[2];
extern const Text *listCheckerNames[1];
extern const Text *listIntegerCheckerNames[2];
extern const Text *macroCheckerNames[1];
extern const Text *mmapBlockCheckerNames[1];
extern const Text *mmapBlockUnsignedNames[2];
extern const Text *mmapBlockUnsignedIntegerNames[3];
extern const Text *mmapBlockUnsignedNumberNames[3];
extern const Text *mmapBlockUnsignedStringNames[3];
extern const Text *mmapBlockUnsignedVectorNames[3];
extern const Text *nonLeafCheckerNames[1];
extern const Text *nonNegativeIntegerCheckerNames[1];
extern const Text *numberBinaryCheckerNames[2];
extern const Text *numberCheckerNames[1];
extern const Text *numberPairCheckerNames[2];
extern const Text *outputPortCheckerNames[1];
extern const Text *pairAnyCheckerNames[2];
extern const Text *pairCheckerNames[1];
extern const Text *positiveIntegerStringCheckerNames[2];
extern const Text *probabilityCheckerNames[1];
extern const Text *procedureCheckerNames[1];
extern const Text *promiseCheckerNames[1];
extern const Text *properListCheckerNames[1];
extern const Text *pushbuttonCheckerNames[1];
extern const Text *pushbuttonInterruptCheckerNames[2];
extern const Text *realCheckerNames[1];
extern const Text *senseLightBooleanCheckerNames[2];
extern const Text *senseLightIlluminationCheckerNames[1];
extern const Text *senseLightSenseLightIlluminationCheckerNames[2];
extern const Text *signedFixnumBinaryCheckerNames[2];
extern const Text *signedFixnumCheckerNames[1];
extern const Text *signedFixnumUnsignedFixnumCheckerNames[2];
extern const Text *sliderCheckerNames[1];
extern const Text *stringBinaryCheckerNames[2];
extern const Text *stringCharCheckerNames[2];
extern const Text *stringCheckerNames[1];
extern const Text *stringIntegerCharCheckerNames[3];
extern const Text *stringIntegerCheckerNames[2];
extern const Text *stringIntegerIntegerCheckerNames[3];
extern const Text *stringNonNegativeIntegerCharCheckerNames[3];
extern const Text *stringNonNegativeIntegerCheckerNames[2];
extern const Text *stringNonNegativeIntegerNonNegativeIntegerCheckerNames[3];
extern const Text *stringSymbolSymbolCheckerNames[3];
extern const Text *symbolCheckerNames[1];
extern const Text *symbolPairCheckerNames[2];
extern const Text *topLevelERefCheckerNames[1];
extern const Text *unsignedFixnumBinaryCheckerNames[2];
extern const Text *unsignedFixnumCheckerNames[1];
extern const Text *unsignedFixnumSignedFixnumCheckerNames[2];
extern const Text *vectorAnyCheckerNames[2];
extern const Text *vectorCheckerNames[1];
extern const Text *vectorIntegerAnyCheckerNames[3];
extern const Text *vectorIntegerCheckerNames[2];

#endif


