/****************************************************************************************

SchemeFunctions.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

Scheme built-in function externals, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "DataTypes.h"
#import "SchemeFunctions.h"

/**** Stuff for built-in functions */

extern LongWord procedureType( UnsignedLongWord n );

extern UnsignedLongWord loadSchemeFunctions( Boolean showListP );

extern const Text *nameFromChecker( void *checker ),
            *procedureArityText( UnsignedLongWord n, LongWord fType ),
            *procedureNameFetchFunction( UnsignedLongWord n ),
            *procedureReturnTypeText( UnsignedLongWord n, LongWord fType ),
            *procedureTypeStringFetchFunction( void (*typeChecker)() );

extern void getBuiltInChecker(),
            getBuiltInArgName(),
            getPCForIndexInR(),
            getBuiltInCodeIndirect(),
            getBuiltInFirstChecker(),
            getBuiltInFirstArgName69(),
            getBuiltInFirstArgName78(),
            getBuiltInMaxArgs(),
            getBuiltInMinArgs(),
            getBuiltInMinArgsThree(),
            getBuiltInMinArgsSeven(),
            getBuiltInNArgs(),
            getBuiltInNthChecker(),
            getBuiltInNthArgName(),
            getBuiltInPName(),
            getBuiltInRestChecker(),
            getBuiltInRestArgName69(),
            getBuiltInRestArgName78(),
            getBuiltInResultChecker(),
            getBuiltInType(),
            getHowToItems( UnsignedLongWord n, Text *header, Text *A, Text *B, Text *C ),
            getCommandsHelpItems( UnsignedLongWord n, Text *header, Text *A, Text *B, Text *C ),
            getFileHelpItems( UnsignedLongWord n, Text *header, Text *A, Text *B, Text *C ),
            getOptionsHelpItems( UnsignedLongWord n, Text *header, Text *A, Text *B, Text *C ),
            getEditHelpItems( UnsignedLongWord n, Text *header, Text *A, Text *B, Text *C ),
            getWhatIsItems( UnsignedLongWord n, Text *header, Text *A, Text *B, Text *C );

extern void describeFunctionDescriptorTypeOne( functionDescriptorTypeOne *d ), 
            describeFunctionDescriptorTypeFive( functionDescriptorTypeFive *d ),
            describeFunctionDescriptorTypeSix( functionDescriptorTypeSix *d ), 
            describeFunctionDescriptorTypeSeven( functionDescriptorTypeSeven *d ), 
            describeFunctionDescriptorTypeEight( functionDescriptorTypeEight *d );

extern void initializePortmanteauIndices();
