/****************************************************************************************

UserSetup.h -- Copyright (c) by Jay Reynolds Freeman 2010.

Header file for stuff about various user options and vies state.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#ifndef __USER_SETUP__
#define __USER_SETUP__

#import "LocalTypes.h"
#import "SenseLightCommands.h"

typedef struct userSetup_struct {

    double mainWindowX;
    double mainWindowY;
    double mainWindowWidth;
    double mainWindowHeight;

    double fontSize;

    double scrollPointX;
    double scrollPointY;

    UnsignedLongWord selectionLocation;
    UnsignedLongWord selectionLength;

    UnsignedLongWord strLength;

    Word illumination[ N_SENSE_LIGHTS ];         // What colors are the lights?  (Includes "off")

    Boolean state[ N_SENSE_LIGHTS ];             // true <--> on; false <--> off.
    Boolean visible[ N_SENSE_LIGHTS ];           // Are the lights visible?

    Boolean compilerOn;
    Boolean showsFullPrecision;


    Boolean padding[ 6 ];                        // Padding so structs will have same size in 32- and 64-bit apps.
    } userSetup;

#endif

