/****************************************************************************************

MMapStuff.c++ -- Copyright (c) by Jay Reynolds Freeman 2007.

For dealing with malloced and mmapped stuff in "main.m".

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import <stdio.h>
#import <stdlib.h>
#import <string.h>
#import <sys/types.h>
#import <sys/mman.h>
#import "Globals.e"
#import "MMapStuff.e"
#import "TaggedData.h"

unsigned char *interruptInformationReserve  = 0;
unsigned char *spaceAReserve                = 0;
unsigned char *spaceBReserve                = 0;
unsigned char *scratchStackReserve          = 0;
unsigned char *clowderReserve               = 0;
unsigned char *gGCScratchReserve            = 0;
unsigned char *schemeMMapReserve            = 0;

UnsignedLongWord schemeMMapReserveSize = 0;

#ifdef USE_COCOA_IO

extern int fatalErrorOccurred;

#endif

#ifdef PIXIE_SCHEMES

#ifndef PIXIE_SCHEME_III

unsigned char  *WraithSpace    = (unsigned char *)0x10000000000LL;  // Must equal the segment address passed to linker as an option.
long           WraithSpaceSize =                      0x7000000LL;  // Must correspond to segment size set in MemFill.s

#else // This next for Pixie Scheme III

unsigned char  *WraithSpace    =    (unsigned char *)0x02000000LL;  // Must equal the segment address passed to linker as an option.
long           WraithSpaceSize =                      0x7000000LL;  // Must correspond to segment size set in MemFill.s

#endif

#else

unsigned char  *WraithSpace    = (unsigned char *)0x10000000000LL;  // Must equal the segment address passed to linker as an option.
long           WraithSpaceSize =                   0x3C00000000LL;  // Must correspond to segment size set in MemFill.s

#endif

/**** mmapForMomCat ****/

void mmapForMomCat()
{
    interruptInformationReserve  =  WraithSpace;
    spaceAReserve                = interruptInformationReserve  +  INTERRUPT_INFORMATION_RESERVE_SIZE;
    spaceBReserve                = spaceAReserve                +  SPACE_RESERVE_SIZE;
    scratchStackReserve          = spaceBReserve                +  SPACE_RESERVE_SIZE;
    clowderReserve               = scratchStackReserve          +  STACK_RESERVE_SIZE;
    gGCScratchReserve            = clowderReserve               +  GGC_SCRATCH_RESERVE_SIZE;
    schemeMMapReserve            = gGCScratchReserve            +  CLOWDER_RESERVE_SIZE;

    if( (schemeMMapReserve - WraithSpace) >= WraithSpaceSize ) {
        fprintf( stderr, "In initialization, total size %jd of memory reserves required exceeds size %jd of segment _WSS.\n",
                 (intmax_t)(schemeMMapReserve - WraithSpace),
                 (intmax_t)WraithSpaceSize
                 );
        fflush( stderr );
#ifdef USE_COCOA_IO
        fatalErrorOccurred = 1;
#else
        exit( 1 );
#endif

        }
    schemeMMapReserveSize = WraithSpace + WraithSpaceSize - schemeMMapReserve;
    }  

/**** mmapForittens ****/

void mmapForKittens()
{
    interruptInformationReserve  =  WraithSpace;
    spaceAReserve                = interruptInformationReserve  + INTERRUPT_INFORMATION_RESERVE_SIZE;
    spaceBReserve                = spaceAReserve                + SPACE_RESERVE_SIZE;
    scratchStackReserve          = spaceBReserve                + SPACE_RESERVE_SIZE;
    clowderReserve               = scratchStackReserve          + STACK_RESERVE_SIZE;
    gGCScratchReserve            = clowderReserve               +  GGC_SCRATCH_RESERVE_SIZE;
    schemeMMapReserve            = gGCScratchReserve            +  CLOWDER_RESERVE_SIZE;

    schemeMMapReserveSize = WraithSpace + WraithSpaceSize - schemeMMapReserve;
    }  

