/****************************************************************************************

SchemeCType.c -- Copyright (c) by Jay Reynolds Freeman 1990, 1991, 2006

Somewhat fancier versions of "CType"-ish functions than using strchr, etc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#define CHARTYPES_HERE 1

#import "WraithHeader.h"
#import "SchemeCType.h"
#import "Globals.e"
#import "IO.e"

UnsignedWord *pCharTypes;

/**** initializeCharTypes ****/

void initializeCharTypes()
{
    UnsignedWord i;
    UnsignedWord *charTypes;

    if( (charTypes = (UnsignedWord *)malloc(  (1 << (8 * sizeof(char))) * sizeof(UnsignedWord) )) == (UnsignedWord *)0 )
        fatalError( 34 );
    else
        pCharTypes = charTypes;

    charTypes[ 0 ] = 0;
    for( i = 1; i < (1 << (8 * sizeof( char ))) ; ++i ) {
        charTypes[ i ] = 0;
        if( isDelimiter_M( (char)i ) )
            charTypes[ i ] |= DELIMITER_BIT;
        if( isInitial_M( (char)i ) )
            charTypes[ i ] |= INITIAL_BIT;
        if( isMisc_M( (char)i ) )
            charTypes[ i ] |= MISC_BIT;
        if( isPeculiarInitial_M( (char)i ) )
            charTypes[ i ] |= PECULIAR_INITIAL_BIT;
        if( isPeculiarSubsequent_M( (char)i ) )
            charTypes[ i ] |= PECULIAR_SUBSEQUENT_BIT;
        if( isSchemeAlpha_M( (char)i ) )
            charTypes[ i ] |= SCHEME_ALPHA_BIT;
        if( isSchemeDigit_M( (char)i ) )
            charTypes[ i ] |= SCHEME_DIGIT_BIT;
        if( isSchemeLegalCharacter_M( (char)i ) )
            charTypes[ i ] |= SCHEME_LEGAL_BIT;
        if( isSchemeLower_M( (char)i ) )
            charTypes[ i ] |= SCHEME_LOWER_BIT;
        if( isSchemeUpper_M( (char)i ) )
            charTypes[ i ] |= SCHEME_UPPER_BIT;
        if( isSubsequent_M( (char)i ) )
            charTypes[ i ] |= SUBSEQUENT_BIT;
        if( isWhiteSpace_M( (char)i ) )
            charTypes[ i ] |= WHITESPACE_BIT;
        if( isWeird_M( (char)i ) )
            charTypes[ i ] |= WEIRDNESS_BIT;
        }
    }
