(display "SimpleClass.s:\n")

(c::define c::simple-class-list (list (quote c::simple-class-format-call) (quote c::simple-class-last-pair) (quote c::check-simple-class-name-syntax) (quote c::check-simple-class-ivar-syntax) (quote c::check-simple-class-binding-pair-is-pair) (quote c::check-simple-class-list-is-list) (quote c::check-simple-class-has-ivar) (quote c::check-make-simple-class-syntax) (quote c::check-make-simple-class-instance-syntax) (quote c::set!-new-bindings) (quote c::duplicate-simple-all-variable-names) (quote c::duplicate-simple-class-variable-names) (quote c::duplicate-simple-instance-bindings-aux) (quote c::duplicate-simple-instance-bindings) (quote c::duplicate-simple-class-bindings-aux) (quote c::duplicate-simple-class-bindings) (quote c::report-duplicate-simple-class-variable-names-aux) (quote c::report-duplicate-simple-class-variable-names) (quote e::make-simple-class)))

(c::map-without-type-checking e::clear-permanent! c::simple-class-list)

(c::define c::simple-class-format-call (c::lambda (name lyst) (newline (e::error-port)) (display (cons (string-append "<instance of \"" (symbol->string name) "\">") lyst) (e::error-port))))

(c::define c::simple-class-last-pair (c::lambda (lyst) (c::if (null? (cdr lyst)) lyst (c::simple-class-last-pair (cdr lyst)))))

(c::define c::check-simple-class-name-syntax (c::lambda (name) (c::if (not (symbol? name)) (c::begin (newline (e::error-port)) (display " -> " (e::error-port)) (display name (e::error-port)) (e::error (string-append "While creating a new simple class, this object occurred instead of a name for the class."))) #f) #t))

(c::define c::check-simple-class-ivar-syntax (c::lambda (name class-name message1 message2) (c::if (not (symbol? name)) (c::begin (newline (e::error-port)) (display " -> " (e::error-port)) (display name (e::error-port)) (e::error (string-append message1 " \"" (symbol->string class-name) "\", this object occurred instead of " message2 "."))) #f) #t))

(c::define c::check-simple-class-binding-pair-is-pair (c::lambda (element class-name message) (c::if (not (c::if (list? element) (= (length element) 2) #f)) (c::begin (newline (e::error-port)) (display " -> " (e::error-port)) (display element (e::error-port)) (e::error (string-append message " \"" (symbol->string class-name) "\", this object occurred instead of a list of the form (name value)."))) #f) #t))

(c::define c::check-simple-class-list-is-list (c::lambda (lyst class-name message1 message2) (c::if (not (list? lyst)) (c::begin (newline (e::error-port)) (display " -> " (e::error-port)) (display lyst (e::error-port)) (e::error (string-append message1 " \"" (symbol->string class-name) "\", this object occurred instead of a list of (name value) sublists" " " message2 "."))) #f) #t))

(c::define c::check-simple-class-has-ivar (c::lambda (x all-variable-names class-name message lyst) (c::if (not (symbol? x)) (c::begin (c::if lyst (c::simple-class-format-call class-name lyst) #f) (newline (e::error-port)) (display " -> " (e::error-port)) (display x (e::error-port)) (e::error (string-append "In a call to an instance of simple class \"" (symbol->string class-name) "\" " message ", this object occurred instead of a variable name."))) #f) (c::if (not (member x all-variable-names)) (c::begin (c::if lyst (c::simple-class-format-call class-name lyst) #f) (e::error (string-append "In a call to an instance of simple class \"" (symbol->string class-name) "\" " message ", there is no variable named \"" (symbol->string x) "\"."))) #f) #t))

(c::define c::check-make-simple-class-syntax (c::lambda (name class-binding-pairs binding-pairs) (c::check-simple-class-name-syntax name) (c::check-simple-class-list-is-list class-binding-pairs name "While creating a new simple class named" "for the class variable bindings") (c::check-simple-class-list-is-list binding-pairs name "While creating a new simple class named" "for the instance bindings") (map (c::lambda (pair) (c::check-simple-class-binding-pair-is-pair pair name "While creating a new simple class named")) class-binding-pairs) (map (c::lambda (pair) (c::check-simple-class-binding-pair-is-pair pair name "While creating a new simple class named")) binding-pairs) (map (c::lambda (pair) (c::check-simple-class-ivar-syntax (car pair) name "While creating a new simple class named" "a class variable name")) class-binding-pairs) (map (c::lambda (pair) (c::check-simple-class-ivar-syntax (car pair) name "While creating a new simple class named" "an instance variable name")) binding-pairs)))

(c::define c::check-make-simple-class-instance-syntax (c::lambda (name more-binding-pairs) (c::check-simple-class-list-is-list more-binding-pairs name "While creating an instance of simple class" "for the instance bindings") (map (c::lambda (pair) (c::check-simple-class-binding-pair-is-pair pair name "While creating an instance of simple class")) more-binding-pairs) (map (c::lambda (pair) (c::check-simple-class-ivar-syntax (car pair) name "While creating an instance of simple class" "a variable name")) more-binding-pairs)))

(c::define c::set!-new-bindings (c::lambda (class-name all-variable-names original-bindings more-bindings) (map (c::lambda (new-binding) (c::check-simple-class-has-ivar (car new-binding) all-variable-names class-name "that initializes that instance" #f)) more-bindings) (map (c::lambda (new-binding) (set-car! (member (assoc (car new-binding) original-bindings) original-bindings) (list (car new-binding) (cadr new-binding)))) more-bindings)))

(c::define c::duplicate-simple-all-variable-names (c::lambda (superinstance-all-variable-names) (c::if (null? superinstance-all-variable-names) (error: "Badly-formed list of instance names passed to \"c::duplicate-simple-all-variable-names\".") (c::if (equal? (car superinstance-all-variable-names) (quote all-variable-names)) (quote ()) (cons (car superinstance-all-variable-names) (c::duplicate-simple-all-variable-names (cdr superinstance-all-variable-names)))))))

(c::define c::duplicate-simple-class-variable-names (c::lambda (super-class-variable-names) (c::if (null? super-class-variable-names) (quote ()) (cons (car super-class-variable-names) (c::duplicate-simple-class-variable-names (cdr super-class-variable-names))))))

(c::define c::duplicate-simple-instance-bindings-aux (c::lambda (superinstance superinstance-all-variable-names) (c::if (null? superinstance-all-variable-names) (error: "Badly-formed list of instance names passed to \"c::duplicate-simple-instance-bindings-aux\".") (c::if (equal? (car superinstance-all-variable-names) (quote all-variable-names)) (quote ()) (cons (list (car superinstance-all-variable-names) (superinstance (car superinstance-all-variable-names))) (c::duplicate-simple-instance-bindings-aux superinstance (cdr superinstance-all-variable-names)))))))

(c::define c::duplicate-simple-instance-bindings (c::lambda (the-simple-class) ((c::lambda (lambda-var-0) (c::duplicate-simple-instance-bindings-aux lambda-var-0 (lambda-var-0 (quote all-variable-names)))) (the-simple-class (quote ())))))

(c::define c::duplicate-simple-class-bindings-aux (c::lambda (superinstance superinstance-class-variable-names) (c::if (null? superinstance-class-variable-names) (quote ()) (cons (list (car superinstance-class-variable-names) (superinstance (car superinstance-class-variable-names))) (c::duplicate-simple-class-bindings-aux superinstance (cdr superinstance-class-variable-names))))))

(c::define c::duplicate-simple-class-bindings (c::lambda (the-simple-class) ((c::lambda (lambda-var-0) (c::duplicate-simple-class-bindings-aux lambda-var-0 (lambda-var-0 (quote class-variable-names)))) (the-simple-class (quote ())))))

(c::define c::report-duplicate-simple-class-variable-names-aux (c::lambda (variable-names duplicates) (c::if (null? variable-names) duplicates (c::if (c::if (not (member (car variable-names) duplicates)) (member (car variable-names) (cdr variable-names)) #f) (c::report-duplicate-simple-class-variable-names-aux (cdr variable-names) (cons (car variable-names) duplicates)) (c::if #t (c::report-duplicate-simple-class-variable-names-aux (cdr variable-names) duplicates) #t)))))

(c::define c::report-duplicate-simple-class-variable-names (c::lambda (class-name variable-names) ((c::lambda (lambda-var-1) (c::if (not (null? lambda-var-1)) (e::warning (string-append "Class \"" (symbol->string class-name) "\" has duplicates of the following variable names:\n" (apply string-append (map (c::lambda (lambda-var-0) (string-append "    " (symbol->string lambda-var-0) "\n")) (reverse lambda-var-1))))) #f) #t) (c::report-duplicate-simple-class-variable-names-aux variable-names (quote ())))))

(c::define e::make-simple-class (c::lambda (name superclasses class-binding-pairs binding-pairs) (c::check-make-simple-class-syntax name class-binding-pairs binding-pairs) ((c::lambda (lambda-var-23) ((c::lambda (lambda-var-13 lambda-var-12 lambda-var-5 lambda-var-8 lambda-var-10) (c::lambda (lambda-var-0) (c::check-make-simple-class-instance-syntax name lambda-var-0) ((c::lambda (lambda-var-11) ((c::lambda (lambda-var-9) ((c::lambda (lambda-var-3) ((c::lambda () (c::report-duplicate-simple-class-variable-names lambda-var-11 lambda-var-9) (c::set!-new-bindings lambda-var-11 lambda-var-9 lambda-var-3 lambda-var-0) ((c::lambda (lambda-var-1) (lambda-var-1 (quote set!) (quote this) lambda-var-1) lambda-var-1) (c::lambda lambda-var-4 ((c::lambda (lambda-var-2) (c::if (memv lambda-var-2 (quote (1))) (c::begin (c::check-simple-class-has-ivar (car lambda-var-4) lambda-var-9 lambda-var-11 "that reads a variable" lambda-var-4) (cadr (assoc (car lambda-var-4) lambda-var-3))) (c::if (memv lambda-var-2 (quote (2))) (c::if (c::if (symbol? (car lambda-var-4)) (equal? (car lambda-var-4) (quote block-binding)) #f) (c::begin (c::check-simple-class-has-ivar (cadr lambda-var-4) lambda-var-9 lambda-var-11 "that blocks the binding of a variable" lambda-var-4) (e::block-any-binding (cdr (assoc (cadr lambda-var-4) lambda-var-3)))) (c::if (c::if (symbol? (car lambda-var-4)) (equal? (car lambda-var-4) (quote method)) #f) (c::begin (c::check-simple-class-has-ivar (cadr lambda-var-4) lambda-var-9 lambda-var-11 "that uses a variable as a method" lambda-var-4) (c::if (not (procedure? (cadr (assoc (cadr lambda-var-4) lambda-var-3)))) (e::error (string-append "Trying to use variable " (symbol->string (cadr lambda-var-4)) " as a method of class " (symbol->string lambda-var-11) ", but that variable is not bound to a procedure.")) #f) (apply (cadr (assoc (cadr lambda-var-4) lambda-var-3)) (list (cadr (assoc (quote this) lambda-var-3))))) (c::begin (c::simple-class-format-call name lambda-var-4) (e::error (string-append "Unknown syntax of a call to an instance of simple class \"" (symbol->string lambda-var-11) "\"."))))) (c::if (memv lambda-var-2 (quote (3))) (c::if (c::if (symbol? (car lambda-var-4)) (equal? (car lambda-var-4) (quote set!)) #f) (c::begin (c::check-simple-class-has-ivar (cadr lambda-var-4) lambda-var-9 lambda-var-11 "that set!s a variable" lambda-var-4) (set-car! (member (assoc (cadr lambda-var-4) lambda-var-3) lambda-var-3) (list (cadr lambda-var-4) (caddr lambda-var-4)))) (c::if (c::if (symbol? (car lambda-var-4)) (equal? (car lambda-var-4) (quote method)) #f) (c::begin (c::check-simple-class-has-ivar (cadr lambda-var-4) lambda-var-9 lambda-var-11 "that uses a variable as a method" lambda-var-4) (c::if (not (procedure? (cadr (assoc (cadr lambda-var-4) lambda-var-3)))) (e::error (string-append "Trying to use variable " (symbol->string (cadr lambda-var-4)) " as a method of class " (symbol->string lambda-var-11) ", but that variable is not bound to a procedure.")) #f) (apply (cadr (assoc (cadr lambda-var-4) lambda-var-3)) (cons (cadr (assoc (quote this) lambda-var-3)) (cddr lambda-var-4)))) (c::if (c::if (symbol? (car lambda-var-4)) (c::if (equal? (car lambda-var-4) (quote set-blocked-binding!)) (pair? (cadr lambda-var-4)) #f) #f) (c::set-blocked-binding! (cadr lambda-var-4) (caddr lambda-var-4)) (c::begin (c::simple-class-format-call name lambda-var-4) (c::if (c::if (symbol? (car lambda-var-4)) (c::if (equal? (car lambda-var-4) (quote set-blocked-binding!)) (not (pair? (cadr lambda-var-4))) #f) #f) (c::begin (display "\n -> " (e::error-port)) (display (cadr lambda-var-4) (e::error-port)) (display "\n    That second argument is certainly not a lock." (e::error-port)) (e::error (string-append "Incorrect syntax in an attempt to set-blocked-binding! in an instance of simple class \"" (symbol->string lambda-var-11) "\"."))) (e::error (string-append "Unknown syntax of a call to an instance of simple class \"" (symbol->string lambda-var-11) "\"."))))))) (c::if (memv lambda-var-2 (quote (0))) (e::error (string-append "No arguments passed in a call to an instance of simple class \"" (symbol->string lambda-var-11) "\".")) (c::if (c::if (symbol? (car lambda-var-4)) (equal? (car lambda-var-4) (quote method)) #f) (c::begin (c::check-simple-class-has-ivar (cadr lambda-var-4) lambda-var-9 lambda-var-11 "that uses a variable as a method" lambda-var-4) (c::if (not (procedure? (cadr (assoc (cadr lambda-var-4) lambda-var-3)))) (e::error (string-append "Trying to use variable " (symbol->string (cadr lambda-var-4)) " as a method of class " (symbol->string lambda-var-11) ", but that variable is not bound to a procedure.")) #f) (apply (cadr (assoc (cadr lambda-var-4) lambda-var-3)) (cons (cadr (assoc (quote this) lambda-var-3)) (cddr lambda-var-4)))) (c::begin (c::simple-class-format-call name lambda-var-4) (e::error (string-append "Unknown syntax of a call to an instance of simple class \"" (symbol->string lambda-var-11) "\"."))))))))) (length lambda-var-4))))))) ((c::lambda (lambda-var-6) (set-cdr! (c::simple-class-last-pair lambda-var-6) lambda-var-5) lambda-var-6) (append (map (c::lambda (lambda-var-7) lambda-var-7) lambda-var-8) (list (list (quote all-variable-names) lambda-var-9) (list (quote inheritance) lambda-var-10) (list (quote class-variable-names) lambda-var-13) (list (quote class-name) lambda-var-11) (list (quote this) (quote ()))))))) (append lambda-var-12 (list (quote all-variable-names) (quote inheritance) (quote class-variable-names) (quote class-name) (quote this)) lambda-var-13))) name))) (c::if (null? superclasses) (map car class-binding-pairs) (append (map car class-binding-pairs) (apply append (map (c::lambda (lambda-var-14) (c::duplicate-simple-class-variable-names (lambda-var-14 (quote class-variable-names)))) lambda-var-23)))) (c::if (null? superclasses) (map car binding-pairs) (append (map car binding-pairs) (apply append (map (c::lambda (lambda-var-15) (c::duplicate-simple-all-variable-names (lambda-var-15 (quote all-variable-names)))) lambda-var-23)))) (c::if (null? superclasses) (map (c::lambda (lambda-var-16) (list (car lambda-var-16) (cadr lambda-var-16))) class-binding-pairs) (append (map (c::lambda (lambda-var-17) (list (car lambda-var-17) (cadr lambda-var-17))) class-binding-pairs) (apply append (map (c::lambda (lambda-var-18) (c::duplicate-simple-class-bindings lambda-var-18)) superclasses)))) (c::if (null? superclasses) (map (c::lambda (lambda-var-19) (list (car lambda-var-19) (cadr lambda-var-19))) binding-pairs) (append (map (c::lambda (lambda-var-20) (list (car lambda-var-20) (cadr lambda-var-20))) binding-pairs) (apply append (map (c::lambda (lambda-var-21) (c::duplicate-simple-instance-bindings lambda-var-21)) superclasses)))) (c::if (null? superclasses) (list name) (cons name (map (c::lambda (lambda-var-22) (lambda-var-22 (quote inheritance))) lambda-var-23))))) (c::if (null? superclasses) (quote ()) (map (c::lambda (lambda-var-24) (lambda-var-24 (quote ()))) superclasses)))))

